(in-package "CCL")
(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "BACKEND"))

(eval-when (:compile-toplevel :execute)
  (require "NXENV")
  (require "PPCENV"))

(defvar *ppc-vinsn-templates* (make-hash-table :test #'eq))

(next-nx-defops)
(defvar *ppc2-specials* nil)
(let* ((newsize (%i+ (next-nx-num-ops) 10))
       (old *ppc2-specials*)
       (oldsize (length old)))
  (declare (fixnum newsize oldsize))
  (unless (>= oldsize newsize)
    (let* ((v (make-array newsize :initial-element nil)))
      (dotimes (i oldsize (setq *ppc2-specials* v))
        (setf (svref v i) (svref old i))))))

(defun lookup-ppc-opcode (name)
  (gethash (string name) ppc::*ppc-opcode-numbers*))

(defvar *ppc-backend*
  (make-backend :lookup-opcode #'lookup-ppc-opcode
		:lookup-macro #'ppc::ppc-macro-function
		:lap-opcodes ppc::*ppc-opcodes*
		:p2-dispatch *ppc2-specials*
		:p2-vinsn-templates *ppc-vinsn-templates*
		:p2-template-hash-name '*ppc-vinsn-templates*
		:p2-compile 'ppc2-compile
		:target-specific-features
		'(:powerpc :ppc-target :eabi-target :linux-target)
		:target-fasl-pathname (make-pathname :type "pfsl")
		:target-architecture 1
		:name :ppc))

(defun fixup-ppc-backend ()
  (let* ((b *ppc-backend*))
    (setf (backend-lap-opcodes b) ppc::*ppc-opcodes*
	  (backend-p2-dispatch b) *ppc2-specials*
	  (backend-p2-vinsn-templates b)  *ppc-vinsn-templates*)))



(fixup-ppc-backend)

#+ppc-target
(setq *host-backend* *ppc-backend* *target-backend* *ppc-backend*)

(pushnew *ppc-backend* *known-backends* :key #'backend-name)

(require "PPC-VINSNS")
(provide "PPC-BACKEND")
