;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  10 1/22/97 akh  dont remember
;;  9 10/3/96  akh  queue-fixup for arglist-on-space, startup-finished -> l1-readloop.lisp (for MCL-AppGen)
;;  6 3/27/96  akh  probably no change
;;  3 11/9/95  akh  maybe no change
;;  2 10/17/95 akh  merge patches
;;  7 5/8/95   akh  make initialization-output do window show cursor in stream-tyo
;;  6 4/28/95  akh  startup-ccl does window-show-cursor of initialization-output
;;  5 4/24/95  akh  added a comment
;;  3 4/6/95   akh  bind *eval-queue* in startup-ccl
;;  (do not edit before this line!!)


; l1-boot-lds.lisp
; Copyright 1995 Digitool, Inc. The 'tool rules!

(in-package :ccl)

; Modification History
;
; 08/20/96 bill  make-mcl-listener-process binds *listener-p* true so that
;                (method initialize-window :after (listener)) will know it is a listener process.
; -------------  4.0b1
; 05/23/96 bill  startup-ccl disables *load-verbose* while loading the init file.
;                This prevents the "Initialization Output" window from appearing.
; 05/02/96 bill  startup-ccl binds *eval-queue* to its global value (and clears the global value).
; 03/06/96 bill  (load-preferences-file) in startup-ccl
; 11/15/95 bill  If you save-application from the boot-init file, *initialization-output*
;                gets left set. Don't try to write to it if it has no wptr.
;  6/08/95 slh   bye-bye beta notice
;  4/16/95 slh   make-mcl-listener-process: added beta notice





(defun command-line-arguments ()
  ())

; NOTE: this function gets re-entered when making a swapping image!
(defun startup-ccl (&optional init-file)
  (unwind-protect
    (let ((file-list (command-line-arguments)) 
          loaded)
      (with-simple-restart (abort "Abort startup.")
        (when 
          (and (eq (car file-list) :open)
               (dolist (f (cdr file-list) loaded)
                 (when (open-application-document *application* f t)
                   (setq loaded t))))
          (setq init-file nil))
        (when init-file
          (with-simple-restart (continue "Skip loading init file.")
                  (load init-file :if-does-not-exist nil :verbose nil)))
        
        #+no
        (unless t *inhibit-greeting* 
                (format t "~&Welcome to ~A ~A!~%"
                        (lisp-implementation-type) (lisp-implementation-version)))
        ))
   ))

(defparameter *listener-process-stackseg-size* (ash 1 17))

(defun make-mcl-listener-process ()
  (let ((p (make-process *main-listener-process-name* :background-p t
                         :stack-size (truncate (* 4/3 *listener-process-stackseg-size*))
                         :vstack-size *listener-process-stackseg-size*
                         :tstack-size (ceiling *listener-process-stackseg-size* 3))))
                         
    (process-preset p #'(lambda ()
                          (let ((*listener-p* t))
                            (unless *inhibit-greeting* 
                              (format t "~&Welcome to ~A ~A!~%"
                                      (lisp-implementation-type)
                                      (lisp-implementation-version)))
                            (toplevel-loop))))
    (process-enable p)
    p))


; End of l1-boot-lds.lisp
