;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  3 4/1/97   akh  see below
;;  21 9/13/96 akh  pathnamep returns conditionally, more checks for nonsense in directory namestrings
;;                  pathname-host-sstr may return :unspecific
;;  18 9/4/96  akh  put back pathnamep (from l0-pred)
;;  17 7/30/96 akh  pathname-host of string - same as (pathname-host (pathname string)) when no dir
;;  15 7/26/96 akh  remove support for old logical directories
;;  11 5/20/96 akh  open-res-file calls truename for alias resolution
;;  9 3/9/96   akh  fix create-file when type and creator are not default
;;  7 2/19/96  akh  remove :up's in %std-directory-component
;;  3 10/17/95 akh  merge patches
;;  2 10/12/95 akh  no more Lap for PPC
;;  17 6/8/95  slh  move choose-file-ddir
;;  12 5/23/95 akh  mac-file-write-date - unsigned long
;;  10 5/22/95 akh  added mac-file-xx-date functions
;;  3 4/6/95   akh  set-choose-file-default-directory gets full name
;;  2 4/4/95   akh  no change
;;  10 3/20/95 akh  add Kalmans file size utilities
;;  6 3/2/95   akh  use application-file-creator
;;  5 2/21/95  slh  removed naughty word (file is public now)
;;  4 1/30/95  akh  fixes to make-pathname, merge-pathnames from patch,
;;                  and %path-getdirinfo from alias-file-patch
;;  (do not edit before this line!!)

;; L1-files.lisp - Object oriented file stuff
; Copyright 1985-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc. The 'tool rules!

; Modification History
;
; 03/11/97 bill %file-size & file-info error if the "file" is a directory.
; ------------- 4.0
; 9/24/96 slh   overwrite-dialog: fix the message text some more
; 09/24/96 bill overwrite-dialog now reports the file name instead of "filename".
;               Thanks to John Wiseman.
; ------------- 4.0b2
; 9/11/96 slh   find-load-file: recognize pathname-type :unspecific, merge with
;               file types before doing probe-file
;09/07/96 gb    put pathnamep back in l0-pred.
;07/29/96 bill  In initializing semi-pos, pathname-host-sstr ensures that pos is non-NIL before
;               blindly %schar'ing.
;07/01/96 bill  findfolder passes NIL, not (%null-ptr) for the create arg to #_FindFolder
; 6/06/96 slh   parse-namestring fix from patch
;05/24/96 bill  %path-from-params special cases the desktop folder.
;05/06/96 bill  slh's fix to require. It now looks for mac-file-type of :pfsl, not :fasl
;               on ppc-target.
;-------------  MCL-PPC 3.9
;04/03/96 bill  compile-load uses *.lisp-pathname* instead of ".lisp".
;04/26/96 bill  %directory-string-list no longer accesses off the end of the string.
;03/26/96  gb   lowmem accessors.
;02/11/96 bill  James Anderson's fix to the "Load other file..." restart in LOAD
;11/29/95 bill  #_PBxxx -> #_PBxxxSync to avoid trap emulator
;11/12/95 gb    #_H* -> #_PBH* to avoid confusion with interfaces' definitions.
;11/08/95 bill  #_PBExchangeFiles -> #_PBExchangeFilesSync
;               #_PBSetCatInfo -> #_PBSetCatInfoSync
; 6/09/95 slh   Kalman's load patches
; 6/07/95 slh   move CFDs to new-file-dialogs, include old-file-dialogs due
;               to bugs in CustomGetFile (thanks DTS for verifying our fears!)
; 6/01/95 slh   set-choose-file-default-directory: no-error optional argument
;               should really have CFD callers specify whether to do logical xlations
; 5/26/95 slh   alternates for :str255/63
; 5/22/95 slh   %file-date: return nil if error
; 5/19/95 slh   use string-equal on module strings, not string=
; 5/17/95 slh   %file-date: errchk optional, for menu updating niceness
; 4/26/95 slh   use old-file-dialogs module if necessary
; 4/13/95 slh   sf-choose-file-hook: don't set name field - it sets the
;               selection to the end of the list
; 4/11/95 slh   overwrite-dialog: folded in application method
; 3/24/95 slh   choose-file-dialog, choose-directory-dialog: handle :directory "vol:dir",
;               "vol:dir:", and "vol:dir:file"
; 3/11/95 slh   all new choose file/dir functions
; 3/01/95 slh   new Choose Directory dialog - oh oh, may require System 7
; 2/28/95 slh   %path-get-long-dir-info reports real error
; 2/27/95 slh   sf-choose-directory-hook: new item numbers for select, cancel
;-------------- 3.0d17
;    ?    alice
; incorporate alias-file-patch in %path-getdirinfo
; fix make-pathname removing double inclusion of relative default
; kalmans fix to merge-pathnames
; find desktop folder the PC way, added function findfolder (vrefnum ostype)
;--------
;07/29/93 bill  alias-path-p now takes an optional dont-resolve arg.
;06/26/93 bill  put-external-scrap in choose-new-file-dialog
;-------------- 3.0d11
;07/13/93 alice find-load-file - call full-pathname with no-errorp nil
;06/16/93 alice %path-quoted-p and %directory-list-namestring are fat string aware
;06/16/93 alice %path-from-iopb calls %std-name-and-type to parse and quote name and type
;06/15/93 alice %path-std-quotes - removing optimization makes him fat string aware
;		could also leave it in when everyone is base.
;06/15/93 alice %path-from-iopb is fat-string aware and has no more lap at expense of consing an extra string,
;06/14/93 alice %reverse-component-case is fat string aware (dreadfully important).
;06/11/93 alice %%str-member is fat string aware
;03/01/93 alice mid-path-aliases needed to tell %path-getdirinfo that dir is already unquoted
;10/16/92 alice remove-up failed for more than one, directory-string-list forgot about ; and :UP
;08/06/92 alice find-load-file defend against full-pathname returning nil.
;06/08/92 alice probe-file work for both "foo:bar alias:" and "foo:bar alias" 
;06/05/92 alice %path-getdirinfo - look in desktop folder of all vols for aliases
;		pb-resolve-alias - hacked to work for aliases on remote vols
;05/20/92 alice find-load-file - fix for type specified and, untyped file exists
;05/01/92 alice nuke *working-directory*
; 08/04/92 bill  in compile-load: The :fasl-file, :ignore-compiler-warnings,  &
;                :force-compile keywords are no longer passed along to compile-file  or load.
; 07/22/92 bill  dummy definition for %path-get-long-dir-info
; 07/06/92 bill  *last-choose-file-directory*: DEFVAR -> DEFLOADVAR
;--------------  2.0
; 03/20/92 bill  EXCHANGE-FILES exchanges the type, creator, & creation date.
;                Maybe it should exchange some of the other finder info stuff.
; 02/21/92 (alice from bootpatch0) don't die if "home:" gets renamed in 
;                choose-file-default-directory
;---------------- 2.0f2
; 01/07/92 gb    don't require RECORDS.
; 12/19/91 bill  :defaults NIL for make-pathname in find-module-pathnames
; 12/16/91 alice choose-...-dialog remember directory if cancelled
; 12/14/91 alice %load if verbose print *load-pathname* not *loading-file-source-file*
; 12/11/91 gb    signal-file-error a macro, wants a fixnum as first argument.
; 12/10/91 alice exchange-files gets optional errchk argument
; 12/04/91 alice choose-directory-dialog erroneously said pathname-directory, make him set default also
;---------------- 2.0b4
; 11/17/91 alice fix find-load-file again - appear to have misplaced a change
; 10/16/91 bill  %run-masked-periodic-tasks during #_SFGetFile
; 10/24/91 alice directory :wild is '(:absolute :wild-inferiors)
; 10/23/91 alice directory-namestring instead of pathname-directory in choose-file-dialog
; 10/10/91 alice pathname-version had a really dumb bug
; 10/10/91 alice %std-directory-part dtrt and use it for more
; 10/21/91 gb    no more #_PB
; 10/06/91 alice choose-new-file mumble don't lose the name, fix choose-directory-dialog
; 10/03/91 alice directory-pathname-p t if name "" and type :unspecific
; 10/01/91 alice %path-from-iopb if both name and type are absent make em nil
;                instead of "" and :unspecific (what will this break?)
; 10/01/91 alice pb-resolve-alias still botched the dir, %path-getdirinfo recurse right
; 10/01/91 alice %load and find-load-file - try to get the source file right
; 09/23/91 alice %std-directory doesn't transform '(:absolute) to nil ?
; 09/20/91 alice %path-to-iopb and pb-resolve-alias botched the dirid
; 09/11/91 alice create-file call create-directory with the FULL physical directory
;----------------- 2.0b3
; 09/06/91 alice signal-file-error takes args
; 09/09/91 bill  error on attempt to invoke choose-file-dialog when not in *foreground*
; 08/23/91 alice delete-file behave as before - if not there, no error. Add exchange-files
; 08/24/91 gb   use new trap syntax.
; 07/31/91 bill Jeremy's new choose-directory-dialog
; 08/01/91 alice resolve aliases, changes %path-to-iopb a bit. (to do: create-file)
; 07/29/91 alice get-long iodirid
; 07/21/91 gb   error signalling.  Mac-file-thing resolves aliases; should probably happen
;               in TRUENAME or somesuch.
; 07/19/91 alice %std-directory-part handle :wild, choose-file-default-directory aware of *last...
; 07/15/91 alice set-choose-file-default-directory set *last-...-directory* too.
; 06/12/91 bill make the :button-string to choose-new-file-dialog more persistent in sf-hook
; 06/08/91 bill provide no longer puts duplicates on *module-file-alist*
; 06/06/91 bill ALMS's patch to find-load-file to reduce consing.
; 06/26/91 alice enough-namestring return relative directory if possible
; 06/24/91 alice delete-file work for directories as foo:baz:
; 06/13/91 alice merge-pathnames heeds version (do we really care)
; 06/12/91 alice namestring was bogus for host & version "*",
;		 change file-namestring to include version & pathname (PATCH) 
;		(Now files can't be named a.b.* a.b.0 or a.b.newest because both
;		pathname and make-pathname toss the "version" if no host.
;		Pathname, pathname-name, pathname-type all parse strings the same)
; 06/10/91 alice %directory-list-namestring :wild => * &  %std-directory-component no :wild => *
;		%directory-string-list * => :wild
;------------- 2.0b2
; 05/20/91 gb   #'file-error -> #'signal-file-error.
; 05/07/91 bill return :unspecific vice NIL from pathname-version
; 05/03/91 bill namestring includes version,
;               pathname & pathname-version-sstr parse it (more) correctly.
; 05/10/91 alice choose-file-dialog  & choose-new-file-dialog - remember directory so gsb won't complain.
; 04/16/91 alice pathname-type-sstr - If lonely dot, type is "". Fix pathname-version-sstr and pathname-name for trailing dots. (patch?)
; 04/04/91 alice choose-file-dialog  & choose-new-file-dialog closeWD 
; 03/15/91 alice fix recently introduce bug in pathname-host-sstr
; 02/22/91 alice error and %err-disp =>file-error where appropriate, give report-bad-arg a required type in some cases
; 02/15/91 alice merge-pathnames - remove :up if merging relative, nuke (:logical "foo") if logical host 
; 02/15/91 alice %directory-list-namestring - use ; for :up if logical host (patch ?)
; 02/12/91 alice move full-pathname to l1-pathnames for boot reasons
; 02/12/91 alice find-load-file return truename and untranslated name, %load bind *load-pathname* and *load-truename* correctly
; 02/08/91 alice full-pathname with no-errors t,  return nil if got an error in %expand-logical-directories (PATCH!)
;          no-error arg default to t again (doc says so)
;-------------- 2.0b1
; 02/06/91 alice %directory-string-list for host
; 01/25/91 alice pathname-host-sstr - error if undefined host
; 01/25/91 alice per gb's suggestion %path-from-iopb quit at root, full-pathname do error if undefined MCL logical dir 
; 01/25/91 alice parse-namestring do return a logical pathname when a host is provided
; 01/25/91 alice merge-pathnames (re host) said dir when it meant path-dir
; 01/24/91 alice create-file create missing directories (needed this for write-floppies)
;--------------------------2.0a5
; 01/03/90 alice %directory-list-namestring use ";" if we have a logical host. directory-namestring
;          funny quote if no host. %directory-string-list & pathname-directory-sstr take optional host arg too. 
; 01/03/90 alice make-pathname merge dir with defaults a la merge-pathnames
; 01/01/91 alice make-pathname don't do pathname-directory of NIL
; 12/28/90 bill  error in choose-directory-dialog (which still doesn't do anything useful)
; 12/20/90 alice %directory-string-list - log:;foo; directory is relative (pg 629)
;          %directory-list-namestring take optional host arg (used for relative pathnames)
; 12/10/90 alice mods to make-pathname, merge-pathnames ,  merge-pathnames with
;  defaults in mac-directory-namestring
; --------------------------2.0a4
; 11/10/90 gb    new fasloader.  Autoload ff-load.
; 10/27/90 alice probe-file failed for top level non-local dirs
; 10/25/90 alice allow : in directory namestring first component, full-pathname dont return nil
; 10/18/90 alice change pathname-host to return only a defined logical host & make pathname-directory agree
;                parse-namestring dont ignore host, defaults
; 10/16/90 gb    no more %str-length.
; 09/07/90 alice namestring include host (fix all callers)
; 08/23/90 alice probe-file dont give back a dir unless dir pathname provided
; 08/09/90 alice stop making believe we have versions
; 09/16/90 bill  Add errorp arg to %open-res-file
; 09/13/90 bill  compile-load,
;                remove "library;interfaces:" from *module-search-path*: use require-interface
; 09/11/90 bill  Finally restarts for LOAD
; 09/08/90 bill  Remove the trailing newline from LOAD's verbose message and
;                add a force-output so that output can be to a mini-buffer.
; 09/07/90 bill  "ccl;library" -> "ccl;library:", "interfaces" logical directory
; 09/06/90 bill  Joe added "library;interfaces:" to *module-search-path*
; 08/09/90 alice stop making believe we have versions
; 08/03/90 bill add examples & library to *logical-directory-alist*
; 07/27/90 alice make file-author do what the documentation says it does.
; 07/19/90 alice fix set-file-write-date to not bash other info
; 07/06/90 alice gary's fix for bogus forward reference warns with included files
; 07/06/90 alice bind *load-truename* and *load-pathname* in load (issue 112)
; 07/06/90 alice fix full-pathname to merge default-directory, remove up's where possible
;                and obey the no-error arg
; 06/19/90 alice fix (pathname ":") and (make-pathname :directory '(:relative))
; 06/18/90 alice fix enough-namestring, defvar (not defparameter) *logical-directory-alist*
; 06/15/90 alice let probe-file work for directories too!!!
; 06/14/90 alice pathname faster, less garbage
; 06/13/90 alice print-object (pathname) obey *print-readably*
; ------ 2.0d46
; 06/12/90 alice disallow symbols in pathname args, allow version :newest
;06/11/90  gb   bind *readtable* in load.
; 06/08/90 alice make merge-pathnames deal with logical hosts
; ------ 2.0d45
; 06/02/90 alice %directory-string-list  - allow multiple logical directories
; 06/01/90 alice fix pathname-host, pathname and pathname-directory for logical host
;06/04/90 bill in choose-**-dialog: default -> directory (that's what the doc says)
;              add "ccl;examples:" to *module-search-path*.
;06/04/90 gb   Use with-compilation-unit in load-from-stream.
;5/7/90   gz   Pathname component case.
;              Structured directories.
;              Logical pathnames in pathname component accessors & make-pathname.
;04/30/90 gb   hoist a few decls, string-char -> base-character.
;04/23/90 bill add "ccl;library:" to *module-search-path*
;04/14/90 gz   %substr now takes start/end args.
;04/02/90 gz   write-a-pathname -> print-object.
;02/29/90 bill Add directory-exists-p
;12/27/89  gz  Remove obsolete #-bccl conditionals. Init *logical-pathname-alist*
;              here.  Obey *load-print* in LOAD.
;12/21/89  gz  Implement cleanup issue PATHNAME-UNSPECIFIC-COMPONENT...
;29-Nov-89 Mly in write-a-pathnaem: Don't use hairy format in l1.
;              princ just writes namestring.
;11/23/89 gz  define *logical-pathname-alist* here.
;12-Nov-89 Mly *write-istruct-alist*
;10/30/89 bill Rename pr-%print-pathname to write-a-pathname and add stream arg.
;09/27/89 gb simple-string -> ensure-simple-string.
#|
 09/25/89 bill Add modeline - Add one-level cache to %path-from-iopb. This speeds
               up directory by over an order of magnitude.
;07/01/89 bill in delete-file (case .. (nil ..) ..) => (case .. ((nil) ..) ..)
;04/07/89 gb  $sp8 -> $sp.
 04/01/89 gz New defpascal syntax.
 3/22/89  gz Added %fasload, %faslopen.
 7-apr-89 as %str-cat takes rest arg
 02/26/89 gz fix in %path-std-quotes
 02/23/89 gb File creator = CCL2; Time to define *default-file-creator*.
 01/05/89 gz Don't pass 0-length strings to traps.
 01/03/89 gz Moved #P to l1-readloop.
 12/28/88 gz Use istruct-typep.  Lapify bottlenecks. streamp back to l1-streams.
             Added stream-pathname.  full-namestring -> full-pathname.
             Terminate loop on $dirnfErr in %path-from-iopb.
 12/21/88 gz  Added %open-res-file...
 11/3/88  jaj put in support for button-string in choose-**-dialog
 10/18/88 gz Don't allow nil as namestring.
  9/20/88 gb Ignore 0-length ioFileName in %path-GetDirInfo.
  8/31/88 gz Standardize logical name expansions in %expand-logical-names,
             since *logical-pathname-alist* is user-mungable.
             Didn't need mac-directory-namestring-p after all...
  8/30/88 gz New regime.  Also moved *file-stream* stuff to l1-streams,
             wildcard stuff and less-used file fns to lib.
  8/20/88 gz	added fasls; to *module-search-path*.  Declarations.
                flushed %open. Don't call page-type to check structure types.
  8/14/88 gb   $iofversnum-> $iofiletype. $iomisc -> $ionewname.
  8/3/88  gz	include is not exactly the same as load...
  7/27/88 gz	added string matching fns from level-2.
  6/27/88  gb  Don't say the mpf word.

  6/24/88 as  added dummy def of file-locked-p for the sake of buffer-write-file
  6/23/88 jaj file-length works with weird byte sizes
  6/22/88 jaj overwrite-dialog returns multiple-values (and thereby so does copy-file)
              fix to file-namestring for version, merge-pathnames takes :newest
              stream-eofp works for weird byte sizes
              really bind *loading-file-source-file* for fasls in load
  6/21/88 jaj use catch/throw-cancel macros
  6/6/88  jaj include and %include are synonyms for load
  5/31/88 as  ::cancel -> :cancel
              (throw :cancel nil) -> (throw :cancel :cancel)
  5/26/88 as  yet another get-string-from-user syntax
  5/20/88 as  new get-string-from-user calling sequence
  5/20/88 jaj fns dealing with time use mac-to-universal-time and
              universal-to-mac-time.  copy-file returns values in
              correct order. mac-directory-p works with complex strings
  5/12/88 jaj  for delete-file :error-if-no-exist defaults to nil
  2/26/88 jaj  library-entry-points -> library-entry-names in load

  3/30/88  gz  New macptr scheme.  Flush pre-1.0 edit history.
  3/1/88   gz  Eliminate compiler warnings.
  2/8/88  jaj  enlarged pb for %mac-default-directory
 12/22/87 gz   Franz foreign function hooks in LOAD.
  12/15/87 cfry from patch of Jaj's to fix the format ~T bug:
          mods to (exist *file-stream*) (stream-column *file-stream*)
                   (stream-tyo *file-stream*) file-position
 10/23/87 jaj  changed %mac-filename, %mac-directory to %uvrefs
 10/22/87 jaj  moved with-file-or-dir out of eval-when
 10/15/87 jaj  added stream-column for *file-stream*
 10/13/87 cfry added INCREMENT-PATHNAME-VERSION & RENAME-FOR-OPEN
           extended rename-file to work for directories.
          %probe-file - fixed by Jaj.
 10/12/87 cfry fixed copy-file to not create target file if source doesn't exist.
          renamed *open-files* to *open-file-streams* casue that's what it is.
          fixed (exist *file-streams*) to set the above global as it should have.
          removed open-file-streams, an iv of *file-streams* not used now.
 removed the fn (defun FileStreams ()
                           (ask *file-stream* open-file-streams))
           which isn't called anywhere in CCL lisp files, and isn't documented.
          
 10/11/87 jaj added internal to *module-search-path*
  9/29/87 jaj moved %do-files-in-directory and do-files-in-directory here from
              pathnames.lisp
  9/29/87 as  find-load-file uses version without explicit type if it exists,
              rather than always merging with .lisp and .fasl
-----------------------------------Version 1.0---------------------------------
|#

(eval-when (:compile-toplevel)
  (require
   #+sparc-target "SOLARIS-RECORDS"
   #+ppc-target "LINUX-RECORDS"))

(defconstant $afpAccessDenied -5000)

(defconstant $paramErr -50)   ; put this with the rest when we find the rest

(defconstant pathname-case-type '(member :common :local :studly))
(defconstant pathname-arg-type '(or string pathname stream))


; dunno if this is what we want to do
(defmacro file-errchk (trap path)
  `(let ((errno ,trap))
     (unless (%izerop errno)
       (signal-file-error errno ,path))))


(defmacro signal-file-error (err-num &optional pathname &rest args)
  `(%err-disp (logior (ash 2 16) (the fixnum (logand #xffff (the fixnum ,err-num))))
              ,@(if pathname (list pathname))
              ,@(if args args)))


(defvar %logical-host-translations% '())
(defvar *load-pathname* nil)
(defvar *load-truename* nil)


(defparameter *default-pathname-defaults* (%cons-pathname nil nil nil))

;Right now, the only way it's used is that an explicit ";" expands into it.
;Used to merge with it before going to ROM.  Might be worth to bring that back,
;it doesn't hurt anything if you don't set it.
;(defparameter *working-directory* (%cons-pathname nil nil nil))

;These come in useful...  We should use them consistently and then document them,
;thereby earning the eternal gratitude of any users who find themselves with a
;ton of "foo.CL" files...
(defparameter *.fasl-pathname* (%cons-pathname nil nil  #+ppc-target "pfsl"
					       #+sparc-target "sfsl"
					       #-(or sparc-target ppc-target) "fasl"))
(defparameter *.lisp-pathname* (%cons-pathname nil nil "lisp"))



(defun if-exists (if-exists filename &optional (prompt "Create"))
  (case if-exists
    (:error (signal-file-error $xfileexists filename))
    ((:dialog :new-version :rename) (overwrite-dialog filename prompt))
    ((nil) nil)
    ((:ignored :overwrite :append :supersede :rename-and-delete) filename)
    (t (report-bad-arg if-exists '(member :error :dialog nil :ignored :overwrite :append :supersede :rename-and-delete)))))

(defun if-does-not-exist (if-does-not-exist filename)
  (case if-does-not-exist 
    (:error (signal-file-error $err-no-file filename)) ; (%err-disp $err-no-file filename))
    (:create filename)
    ((nil) (return-from if-does-not-exist nil))
    (t (report-bad-arg if-does-not-exist '(member :error :create nil)))))


(defun truename (path)
  (or (probe-file path) ; probe-file gets aliases right 
      (signal-file-error $err-no-file path)))



(defun probe-file (path)
  (let* ((realpath (%realpath (namestring (translate-logical-pathname path)))))
    (if realpath
      (pathname realpath))))

(defun cwd (path)  
  (let* ((realpath (%realpath (namestring (translate-logical-pathname path))))
	 (kind (if realpath (%unix-file-kind realpath))))
    (if kind
      (if (eq kind :directory)
	(let* ((error (%chdir realpath)))
	  (if (eql error 0)
	    (mac-default-directory)
	    (let* ((errno (%get-errno)))
	      (signal-posix-error errno))))
	(error "~S is not a directory pathname." path))
      (error "Invalid pathname : ~s." path))))
    
    

;Should have an option to create all directories in the path, it's not that
;hard... (could call it :if-does-not-exist, except then couldn't pass it through
;from open...)
; this is iffy re aliases

(defun create-file (path &key (if-exists :error)
                         (mac-file-type "TEXT")
                         (mac-file-creator nil))
  (declare (ignore if-exists mac-file-type mac-file-creator))
  (let* ((namestring (namestring (translate-logical-pathname path))))
    (multiple-value-bind (fd error) (fd-open namestring (logior O_WRONLY
								#+sparc-target
								solaris_O_CREAT
								#+ppc-target
								linux_O_CREAT
								#+ppc-target
								linux_O_TRUNC
								#+solaris-target
								solaris_o_TRUNC))
      (if error
	  (signal-posix-error error)
	  (fd-close fd))
      (%realpath namestring))))

(defstruct (pattern
	    (:constructor make-pattern (pieces)))
  (pieces nil :type list))

(defmethod make-load-form ((p pattern))
  (make-load-form-saving-slots p))

(defmethod print-object ((p pattern) stream)
  (print-unreadable-object (p stream :type t)
    (let* ((pieces (pattern-pieces p)))
      (if *print-pretty*
        (let ((*print-escape* t))
	  (pprint-fill stream pieces nil))
	(prin1 pieces stream)))))

(defvar *ignore-wildcards* nil)


(defun remove-backslashes (namestr start end)
  "Remove and occurences of \\ from the string because we've already
   checked for whatever they may have been backslashed."
  (declare (type simple-base-string namestr)
	   (type index start end))
  (let* ((result (make-string (- end start) :element-type 'base-char))
	 (dst 0)
	 (quoted nil))
    (do ((src start (1+ src)))
	((= src end))
      (cond (quoted
	     (setf (schar result dst) (schar namestr src))
	     (setf quoted nil)
	     (incf dst))
	    (t
	     (let ((char (schar namestr src)))
	       (cond ((char= char #\\)
		      (setq quoted t))
		     (t
		      (setf (schar result dst) char)
		      (incf dst)))))))
    (when quoted
      (error 'namestring-parse-error
	     :complaint "Backslash in bad place."
	     :namestring namestr
	     :offset (1- end)))
    (shrink-vector result dst)))

(defun maybe-make-pattern (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end))
  (if *ignore-wildcards*
      (subseq namestr start end)
      (let* ((pattern ()))
	(let* ((quoted nil)
	      (any-quotes nil)
	      (last-regular-char nil)
	      (index start))
	  (flet ((flush-pending-regulars ()
		   (when last-regular-char
		     (push (if any-quotes
			       (remove-backslashes namestr
						   last-regular-char
						   index)
			       (subseq namestr last-regular-char index)) 
			   pattern)
		     (setf any-quotes nil)
		     (setf last-regular-char nil))))
	    (loop
	      (when (>= index end)
		(return))
	      (let ((char (schar namestr index)))
		(cond (quoted
		       (incf index)
		       (setf quoted nil))
		      ((char= char #\\)
		       (setf quoted t)
		       (setf any-quotes t)
		       (unless last-regular-char
			 (setf last-regular-char index))
		       (incf index))
		      ((char= char #\?)
		       (flush-pending-regulars)
		       (push :single-char-wild pattern)
		       (incf index))
		      ((char= char #\*)
		       (flush-pending-regulars)
		       (push :multi-char-wild pattern)
		       (incf index))
		      ((char= char #\[)
		       (flush-pending-regulars)
		       (let ((close-bracket
			      (position #\] namestr :start index :end end)))
			 (unless close-bracket
			   (error 'namestring-parse-error
				  :complaint "``['' with no corresponding ``]''"
				  :namestring namestr
				  :offset index))
			 (push (list :character-set
					(subseq namestr
						(1+ index)
						close-bracket))
			  pattern)
			 (setf index (1+ close-bracket))))
		      (t
		       (unless last-regular-char
			 (setf last-regular-char index))
		       (incf index)))))
	    (flush-pending-regulars)))
	(cond ((null (setq pattern (nreverse pattern)))
	       "")
	      ((null (cdr pattern))
	       (let ((piece (first pattern)))
		 (typecase piece
		   ((member :multi-char-wild) :wild)
		   (simple-string piece)
		   (t
		    (make-pattern pattern)))))
	      (t
	       (make-pattern pattern))))))

(defun extract-name-type-and-version (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end))
  (let* ((last-dot (position #\. namestr :start (1+ start) :end end
			     :from-end t))
	 (second-to-last-dot (and last-dot
				  (position #\. namestr :start (1+ start)
					    :end last-dot :from-end t)))
	 (version nil))
    ;; If there is a second-to-last dot, check to see if there is a valid
    ;; version after the last dot.
    (when second-to-last-dot
      (cond ((and (= (+ last-dot 2) end)
		  (char= (schar namestr (1+ last-dot)) #\*))
	     (setf version :wild))
	    ((and (< (1+ last-dot) end)
		  (do ((index (1+ last-dot) (1+ index)))
		      ((= index end) t)
		    (unless (char<= #\0 (schar namestr index) #\9)
		      (return nil))))
	     (setf version
		   (parse-integer namestr :start (1+ last-dot) :end end)))
	    (t
	     (setf second-to-last-dot nil))))
    (cond (second-to-last-dot
	   (values (maybe-make-pattern namestr start second-to-last-dot)
		   (maybe-make-pattern namestr
				       (1+ second-to-last-dot)
				       last-dot)
		   version))
	  (last-dot
	   (values (maybe-make-pattern namestr start last-dot)
		   (maybe-make-pattern namestr (1+ last-dot) end)
		   version))
	  (t
	   (values (maybe-make-pattern namestr start end)
		   nil
		   version)))))

;;; Take a string and return a list of cons cells that mark the char
;;; separated subseq. The first value t if absolute directories location.
;;;
(defun split-at-slashes (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end))
  (let ((absolute (and (/= start end)
		       (char= (schar namestr start) #\/))))
    (when absolute
      (incf start))
    ;; Next, split the remainder into slash seperated chunks.
    (let* ((pieces ()))
      (loop
	(let ((slash (position #\/ namestr :start start :end end)))
	  (push (cons start (or slash end)) pieces)
	  (unless slash
	    (return))
	  (setf start (1+ slash))))
      (values absolute (nreverse pieces)))))

(defun parse-unix-namestring (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end))
  (multiple-value-bind
      (absolute pieces)
      (split-at-slashes namestr start end)
    (multiple-value-bind
	  (name type)
	(let* ((tail (car (last pieces)))
	       (tail-start (car tail))
	       (tail-end (cdr tail)))
	  (unless (= tail-start tail-end)
	    (setf pieces (butlast pieces))
	    (extract-name-type-and-version namestr tail-start tail-end)))
      ;; Now we have everything we want.  So return it.
      (values nil ; no host for unix namestrings.
	      (let* ((dirs ()))
		(dolist (piece pieces)
		  (let* ((piece-start (car piece))
			 (piece-end (cdr piece)))
		    (unless (= piece-start piece-end)
		      (cond ((string= namestr ".." :start1 piece-start
				      :end1 piece-end)
			     (push :up dirs))
			    ((string= namestr "**" :start1 piece-start
				      :end1 piece-end)
			     (push :wild-inferiors dirs))
			    (t
			     (push (maybe-make-pattern namestr
						       piece-start
						       piece-end) 
			      dirs))))))
		(setq dirs (nreverse dirs))
		(cond (absolute
		       (cons :absolute dirs))
		      (dirs
		       (cons :relative dirs))
		      (t
		       nil)))
	      name
	      type
	      nil))))

(defun unparse-unix-piece (thing)
  (etypecase thing
    ((member :wild) "*")
    (simple-string
     (let* ((srclen (length thing))
	    (dstlen srclen))
       (dotimes (i srclen)
	 (case (schar thing i)
	   ((#\* #\? #\[)
	    (incf dstlen))))
       (let ((result (make-string dstlen :element-type 'base-char))
	     (dst 0))
	 (dotimes (src srclen)
	   (let ((char (schar thing src)))
	     (case char
	       ((#\* #\? #\[)
		(setf (schar result dst) #\\)
		(incf dst)))
	     (setf (schar result dst) char)
	     (incf dst)))
	 result)))
    (pattern
     (let* ((strings ()))
       (dolist (piece (pattern-pieces thing))
	 (etypecase piece
	   (simple-string
	    (push piece strings))
	   (symbol
	    (ecase piece
	      (:multi-char-wild
	       (push "*" strings))
	      (:single-char-wild
	       (push "?" strings))))
	   (cons
	    (case (car piece)
	      (:character-set
	       (push "[" strings)
	       (push (cdr piece) strings)
	       (push "]" strings))
	      (t
	       (error "Invalid pattern piece: ~S" piece))))))
       (apply #'concatenate
	      'simple-string
	      (nreverse strings))))))

(defun unparse-unix-directory-list (directory)
  (declare (type list directory))
  (let* ((pieces ()))
    (when directory
      (ecase (pop directory)
	(:absolute
	 (push "/" pieces))
	(:relative
	 ;; Nothing special.
	 ))
      (dolist (dir directory)
	(typecase dir
	  ((member :up)
	   (push "../" pieces))
	  ((member :back)
	   (error ":BACK cannot be represented in namestrings."))
	  ((member :wild-inferiors)
	   (push "**/" pieces))
	  ((or simple-string pattern)
	   (push (unparse-unix-piece dir) pieces)
	   (push "/" pieces))
	  (t
	   (error "Invalid directory component: ~S" dir)))))
    (apply #'concatenate 'simple-string (nreverse pieces))))

(defun %pathname-host (pathname)
  (if (logical-pathname-p pathname)
      (%logical-pathname-host pathname)
      :unspecific))

(defun %pathname-version (pathname)
  (if (logical-pathname-p pathname)
      (%logical-pathname-version pathname)
      :newest))

(defun unparse-unix-file (pathname)
  (declare (type pathname pathname))
  (let* ((strings ()))
    (let* ((name (%pathname-name pathname))
	   (type (%pathname-type pathname))
	   (type-supplied (not (or (null type) (eq type :unspecific))))
	   (version (%pathname-version pathname))
	   (version-supplied (not (or (null version) (eq version :newest)))))
      (when name
	(push (unparse-unix-piece name) strings))
      (when type-supplied
	(push "." strings)
	(push (unparse-unix-piece type) strings))
      (when version-supplied
	(unless type-supplied
	  (error "Cannot specify the version without a type: ~S" pathname))
	(push (if (eq version :wild)
	     ".*"
	     (format nil ".~D" version)) 
	 strings)))
    (apply #'concatenate 'simple-string (nreverse strings))))

(defun unparse-unix-namestring (pathname)
  (declare (type pathname pathname))
  (concatenate 'simple-string
	       (unparse-unix-directory-list (%pathname-directory pathname))
	       (unparse-unix-file pathname)))

(defun unparse-logical-piece (thing)
  (etypecase thing
    (simple-string thing)
    (pattern
     (let* ((strings ()))
       (dolist (piece (pattern-pieces thing))
	 (etypecase piece
	   (simple-string (push piece strings))
	   (keyword
	    (cond ((eq piece :wild-inferiors)
		   (push "**" strings))
		  ((eq piece :multi-char-wild)
		   (push "*" strings))
		  (t (error "Invalid keyword: ~S" piece))))))
       (apply #'concatenate 'simple-string (nreverse strings))))))

(defun unparse-logical-directory (pathname)
  (declare (type pathname pathname))
  (let* ((pieces ()))
    (let ((directory (%pathname-directory pathname)))
      (when directory
	(ecase (pop directory)
	  (:absolute)	 ;; Nothing special.
	  (:relative (push ";" pieces)))
	(dolist (dir directory)
	  (cond ((or (stringp dir) (pattern-p dir))
		 (push (unparse-logical-piece dir) pieces)
		 (push ";" pieces))
		((eq dir :wild)
		 (push "*;" pieces))
		((eq dir :wild-inferiors)
		 (push "**;" pieces))
		(t
		 (error "Invalid directory component: ~S" dir))))))
    (apply #'concatenate 'simple-string (nreverse pieces))))

(defun unparse-logical-namestring (pathname)
  (declare (type logical-pathname pathname))
  (concatenate 'simple-string
	       (%pathname-host pathname) ":"
	       (unparse-logical-directory pathname)
	       (unparse-unix-file pathname)))

(defun maybe-make-logical-pattern (namestring chunks)
  (let* ((chunk (caar chunks)))
    (let* ((pattern ()))
      (let* ((last-pos 0)
	     (len (length chunk)))
	(declare (fixnum last-pos))
	(loop
	  (when (= last-pos len) (return))
	  (let ((pos (or (position #\* chunk :start last-pos) len)))
	    (if (= pos last-pos)
		(when pattern
		  (error 'namestring-parse-error
			 :complaint "Double asterisk inside of logical ~
				     word: ~S"
			 :arguments (list chunk)
			 :namestring namestring
			 :offset (+ (cdar chunks) pos)))
		(push (subseq chunk last-pos pos) pattern))
	    (if (= pos len)
		(return)
		(push :multi-char-wild pattern))
	    (setq last-pos (1+ pos)))))
      (setq pattern (nreverse pattern))
	(if (cdr pattern)
	    (make-pattern pattern)
	    (let ((x (car pattern)))
	      (if (eq x :multi-char-wild)
		  :wild
		  x))))))

(defun logical-chunkify (namestr start end)
  (let* ((chunks nil))
    (do ((i start (1+ i))
	 (prev 0))
	((= i end)
	 (when (> end prev)
	    (push (cons (subseq namestr prev end) prev) chunks)))
      (let ((ch (schar namestr i)))
	(unless (or (alpha-char-p ch) (digit-char-p ch)
		    (member ch '(#\- #\*)))
	  (when (> i prev)
	    (push (cons (subseq namestr prev i) prev) chunks))
	  (setq prev (1+ i))
	  (unless (member ch '(#\; #\: #\.))
	    (error 'namestring-parse-error
		   :complaint "Illegal character for logical pathname:~%  ~S"
		   :arguments (list ch)
		   :namestring namestr
		   :offset i))
	  (push (cons ch i) chunks))))
    (nreverse chunks)))

(defun find-logical-host (hostname &optional (errorp t))
  (let* ((found (%str-assoc hostname %logical-host-translations%)))
    (unless (or found (not errorp))
      (error "Logical host not yet defined: ~S" hostname))
    (car found)))

(defun parse-logical-namestring (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end))
  (let* ((directory ()))
    (let* ((host nil)
	  (name nil)
	  (type nil)
	  (version nil))
      (labels ((expecting (what chunks)
		 (unless (and chunks (simple-string-p (caar chunks)))
		   (error 'namestring-parse-error
			  :complaint "Expecting ~A, got ~:[nothing~;~S~]."
			  :arguments (list what (caar chunks))
			  :namestring namestr
			  :offset (if chunks (cdar chunks) end)))
		 (caar chunks))
	       (parse-host (chunks)
		 (case (caadr chunks)
		   (#\:
		    (setq host
			  (find-logical-host (expecting "a host name" chunks)))
		    (parse-relative (cddr chunks)))
		   (t
		    (parse-relative chunks))))
	       (parse-relative (chunks)
		 (case (caar chunks)
		   (#\;
		    (push :relative directory)
		    (parse-directory (cdr chunks)))
		   (t
		    (push :absolute directory) ; Assumption! Maybe revoked later.
		    (parse-directory chunks))))
	       (parse-directory (chunks)
		 (case (caadr chunks)
		   (#\;
		    (push 
		     (let ((res (expecting "a directory name" chunks)))
		       (cond ((string= res "..") :up)
			     ((string= res "**") :wild-inferiors)
			     (t
			      (maybe-make-logical-pattern namestr chunks))))
		     directory)
		    (parse-directory (cddr chunks)))
		   (t
		    (parse-name chunks))))
	       (parse-name (chunks)
		 (when chunks
		   (expecting "a file name" chunks)
		   (setq name (maybe-make-logical-pattern namestr chunks))
		   (expecting-dot (cdr chunks))))
	       (expecting-dot (chunks)
		 (when chunks
		   (unless (eql (caar chunks) #\.)
		     (error 'namestring-parse-error
			    :complaint "Expecting a dot, got ~S."
			    :arguments (list (caar chunks))
			    :namestring namestr
			    :offset (cdar chunks)))
		   (if type
		       (parse-version (cdr chunks))
		       (parse-type (cdr chunks)))))
	       (parse-type (chunks)
		 (expecting "a file type" chunks)
		 (setq type (maybe-make-logical-pattern namestr chunks))
		 (expecting-dot (cdr chunks)))
	       (parse-version (chunks)
		 (let ((str (expecting "a positive integer, * or NEWEST"
				       chunks)))
		   (cond
		    ((string= str "*") (setq version :wild))
		    ((string= str "NEWEST") (setq version :newest))
		    (t
		     (multiple-value-bind
			 (res pos)
			 (parse-integer str :junk-allowed t)
		       (unless (and res (plusp res))
			 (error 'namestring-parse-error
				:complaint "Expected a positive integer, ~
					    got ~S"
				:arguments (list str)
				:namestring namestr
				:offset (+ pos (cdar chunks))))
		       (setq version res)))))
		 (when (cdr chunks)
		   (error 'namestring-parse-error
			  :complaint "Extra stuff after end of file name."
			  :namestring namestr
			  :offset (cdadr chunks)))))
	(parse-host (logical-chunkify namestr start end)))
      (setq directory (nreverse directory))
      (values host
	      (and (not (equal directory '(:absolute)))directory)
	      name type version))))

(defun extract-logical-host-prefix (namestr start end)
  (declare (type simple-base-string namestr)
	   (type index start end)
	   (values (or logical-host null)))
  (let ((colon-pos (position #\: namestr :start start :end end)))
    (if colon-pos
	(%str-assoc (subseq namestr start colon-pos)
		    %logical-host-translations%)
	nil)))

(defun %parse-namestring (namestr host defaults start end junk-allowed)
  (declare  (type string namestr)
	   (type index start) (type (or index null) end))
  (if junk-allowed
      (handler-case
	  (%parse-namestring namestr host defaults start end nil)
	(namestring-parse-error (condition)
	  (values nil (namestring-parse-error-offset condition))))
      (let* ((end (or end (length namestr)))
	     (logical-host (car (extract-logical-host-prefix namestr start end)))
	     (parse-host (or host logical-host (pathname-host defaults))))
	(unless parse-host
	  (error "When Host arg is not supplied, Defaults arg must ~
		  have a non-null PATHNAME-HOST."))
	(if (eq host :unspecific)
	    (setq host nil))
	(setq host (or host logical-host))
	(multiple-value-bind
	    (new-host directory name type version)
	    (if host
		(parse-logical-namestring namestr start end)
		(parse-unix-namestring namestr start end))
	  (when (and host new-host (not (equal new-host host)))
	    (error "Host in namestring: ~S~@
		    does not match explicit host argument: ~S"
		   (subseq namestr start end)
		   host))
	  (cons-pathname directory name type host version)))))


(defun parse-namestring (thing
			 &optional host (defaults *default-pathname-defaults*)
			 &key (start 0) end junk-allowed)
  (declare (type pathname defaults)
	   (type index start)
	   (type (or index null) end)
	   (type (or t null) junk-allowed)
	   (values (or null pathname) (or null index)))
    (typecase thing
      (simple-string
       (%parse-namestring thing host defaults start end junk-allowed))
      (string
       (%parse-namestring (coerce thing 'simple-string)
			  host defaults start end junk-allowed))
      (pathname
       (let ((host (if host host (%pathname-host defaults))))
	 (unless (equal host (%pathname-host thing))
	   (error "Hosts do not match: ~S and ~S."
		  host (%pathname-host thing))))
       (values thing start))
      (stream
       (let ((name (stream-pathname thing)))
	 (unless name
	   (error "Can't figure out the file associated with stream:~%  ~S"
		  thing))
	 name))))

(defun logical-pathname-p (thing) (istruct-typep thing 'logical-pathname))

(defun pathname-host (thing)  ; redefined later in this file
  (declare (ignore thing))
  :unspecific)

(defun pathname-version (thing)  ; redefined later in this file
  (declare (ignore thing))
  :unspecific)

(defmethod print-object ((pathname pathname) stream)
  (let ((flags (if (logical-pathname-p pathname) 4
                   (%i+ (if (eq (%pathname-type pathname) ':unspecific) 1 0)
                        (if (equal (%pathname-name pathname) "") 2 0))))
        (name (namestring pathname)))    
    (if (and (not *print-readably*) (not *print-escape*))
      (write-string name stream)
      (progn
        (format stream (if (eql flags 0) "#P" "#~DP") flags)
        (write-escaped-string name stream #\")))))

#|
(%fhave '%expand-logical-directory  ;redefined later
        (qlfun %expand-logical-directory (file &optional flag)
          (declare (ignore flag))
          file))
|#

(defun mac-default-directory ()
  (let* ((dname (current-directory-name))
	 (len (length dname)))
    (declare (fixnum len))
    (when (and (> len 1)
	       (not (eq #\/ (schar dname (1- len)))))
      (setq dname (%str-cat dname "/")))
    (pathname dname)))


; I thought I wanted to call this from elsewhere but perhaps not
(defun absolute-directory-list (dirlist)
  ; just make relative absolute and remove ups where possible
  (when (eq (car dirlist) :relative)
    (let ((default (mac-default-directory)) default-dir)
      (when default
        (setq default-dir (%pathname-directory default))
        (when default-dir
          (setq dirlist (append default-dir (cdr dirlist)))))))
  (when (memq :up dirlist)
    (setq dirlist (copy-list dirlist))
    (remove-up dirlist))
  dirlist)

; ? is (:absolute "a" :up "b") = (:absolute "b") - seems reasonable
; destructively mungs dir
(defun remove-up (dir)
  (let ((n 0)(sub (cdr dir))(last nil))
    (loop
      (cond ((eq (car sub) :up)
             (cond ((or (eq n 0)(and (stringp last)(string= last "**")))
                    (return (when (memq :up (cdr sub))
                              (remove-up sub))))
                   (t (rplacd (nthcdr (1- n) dir) (cdr sub))
                      (setq n (- n 2))))))
      (setq last (car sub) n (1+ n) sub (cdr sub))
      (if (null sub)(return nil)))
    dir))
             

(defun namestring (path)
  (typecase path
    (logical-pathname (unparse-logical-namestring path))
    (pathname (unparse-unix-namestring path))
    (t (namestring (pathname path)))))

(defun host-namestring (path)
  (let ((host (pathname-host path)))
    (if (and host (neq host :unspecific)) host  "")))

(defun directory-namestring (path)
  (let* ((dirlist (pathname-directory path))
         (host (pathname-host path))
         ; what if its a logical-pathname whose host is explicitly :unspecific?? - beats me - shouldn't happen?
         (result (%directory-list-namestring dirlist (or  host (logical-pathname-p path))))) ; << 7/96
    (cond ((and (not host)   ; put in a quote if it is not logical but might appear to be
                (consp dirlist) 
                (eq (car dirlist) :absolute)
                (stringp (cadr dirlist))
                (null (cddr dirlist))
                (%str-assoc  (cadr dirlist) %logical-host-translations%))
           (let ((pos (%path-mem ":" result)))
             (%str-cat (%substr result 0  pos) "" 
                       (%substr result pos (length result)))))
          (t result))))
    
               

;This assumes that :'s and ;'s in components are escaped (otherwise would have to
;pre-scan for escapes, yuck).

(defun %directory-list-namestring (list &optional host)
  (when (eq host :unspecific) (setq host nil))
  (if (null list)
    ""      
    (let ((len (if (eq (car list) :absolute) 1 0))
          result)
      (declare (fixnum len)(optimize (speed 3)(safety 0)))
      (dolist (s (%cdr list))
        (when (consp s)(setq s (cadr s)))
        (case s
          (:wild (setq len (+ len 2)))
          (:wild-inferiors (setq len (+ len 3)))
          (:up (setq len (+ len 1)))
          (t (setq len (+ len 1 (length s))))))
      (setq result (make-string len :element-type 'base-char))
      (let ((i 0)
            (sep (if host (char-code #\;)(char-code #\/))))
        (declare (fixnum i))
        (when (eq (%car list) :absolute)
          (setf (%scharcode result 0) sep)
          (setq i 1))
        (dolist (s (%cdr list))
          (let ((sep sep))
            (when (consp s)
              (setq s (cadr s))
              (setq sep (char-code #\;)))
            (case s
              (:wild (setq s "*"))
              (:wild-inferiors (setq s "**"))
              (:up (setq s nil)))
            (when s
              (let ((len (length s)))
                (declare (fixnum len))
                (move-string-bytes s result 0 i len)
                (setq i (+ i len))))
            (setf (%scharcode result i) sep)
            (setq i (1+ i)))))
      result)))    


(defun file-namestring (path)
  (let* ((name (pathname-name path))
         (type (pathname-type path))
         (version (pathname-version path)))
    (case version
      (:newest (setq version ".newest"))
      (:wild (setq version ".*"))
      ((nil :unspecific) (setq version nil))
      (t (setq version (if (fixnump version)
                         (%str-cat "." (%integer-to-string version))
                         (%str-cat "." version)))))
    (if (and type (neq type :unspecific))
      (if (null name)
        (%str-cat "." type (or version ""))
        (%str-cat name "." type (or version "")))
      (if version ; version no type
        (if (null name)
          (%str-cat "." version)
          (%str-cat name "." version))
        (or name "")))))

; not used -  is CL
(defun enough-namestring (path &optional (defaults *default-pathname-defaults*))
  (if (null defaults)(namestring path)
      (let* ((path (pathname path))
             (dir (pathname-directory path))
             (nam (pathname-name path))
             (typ (pathname-type path))
             (host (pathname-host path))
             (default-dir (pathname-directory defaults))
             (real-host host))
        (when (equalp host (pathname-host defaults))
          (setq host nil))
        (setq host (if (and host (neq host :unspecific))
                     (%str-cat host ":")
                     ""))
        (cond ((equalp dir default-dir)
               (setq dir nil))
              ((and dir default-dir
                    (eq (car dir) :absolute)(eq (car default-dir) :absolute))
               (let (res) ; maybe make it relative to defaults
                 (do ((p1 (cdr dir) (cdr p1))
                      (p2 (cdr default-dir) (cdr p2)))
                     nil 
                   (cond ((null p1) (return nil))
                         ((null p2)
                          (when res
                            (setq dir (cons :relative p1)))
                          (return))
                         ((not (equalp (car p1)(car p2)))
                          (return nil))
                         (t (setq res t)))))))
        (when (equalp typ (pathname-type defaults))
          (setq typ nil))
        (when (and (null typ) (equalp nam (pathname-name defaults)))
          (setq nam nil))
        (when (and typ (neq typ :unspecific))
          (setq nam (if (null nam) (%str-cat "." typ) (%str-cat nam "." typ))))
        (cond (dir
               ; what if its a logical-pathname whose host is explicitly :unspecific?? ok
               (setq dir (%directory-list-namestring dir (or real-host (logical-pathname-p path)))) ; 7/96
               (if nam (%str-cat host dir nam)(%str-cat  host dir)))
              ((neq (length host) 0)
               (if nam (%str-cat host ";" nam)(%str-cat host ";")))
              (t (or nam ""))))))

(defun cons-pathname (dir name type &optional host version)
  (if (and host (neq host :unspecific))
    (%cons-logical-pathname dir name type host version)
    (%cons-pathname dir name type)))


(defun pathname (path)
  (etypecase path
    (pathname path)
    (stream (%path-from-stream path))
    (string (parse-namestring path))))


(defun %path-from-stream (stream)
  (or (stream-filename stream) (error "Can't determine pathname of ~S ." stream)))      ; ???

;Like (pathname stream) except returns NIL rather than error when there's no
;filename associated with the stream.
(defun stream-pathname (stream &aux (path (stream-filename stream)))
  (when path (pathname path)))



(defun make-pathname (&key (host nil host-p) 
                           device
                           (directory nil directory-p)
                           (name nil name-p)
                           (type nil type-p)
                           (version nil version-p)
                           (defaults nil defaults-p) case
                           &aux path default-dir)
  (declare (ignore device))
  (when case (setq case (require-type case pathname-case-type)))
  (when (null host-p)
    (setq host (if defaults-p defaults *default-pathname-defaults*))
    (when (or  (stringp host)(pathnamep host))(setq host (pathname-host host))))
  (if directory-p 
    (setq directory (%std-directory-component directory host)))
  (if defaults
    (setq default-dir (pathname-directory defaults)))
  (cond ((null directory)(setq directory default-dir))
        ((and default-dir (eq (car directory) ':relative))
         (setq directory (append default-dir (cdr directory)))
         (when (memq :up directory)(remove-up directory))))  
  (setq name
        (if name-p
             (%std-name-component name)
             (and defaults (pathname-name defaults))))
  (setq type
        (if type-p
             (%std-type-component type)
             (and defaults (pathname-type defaults))))
  (setq version (if version-p
                  (%logical-version-component version)
                  (and defaults (pathname-version defaults))))  
  (setq path
        (if (or (eq host :unspecific)  ; 7/96
                (and (not host-p)
                     (or (null defaults) (physical-pathname-p (pathname defaults)))))
          (%cons-pathname directory name type)
          (%cons-logical-pathname directory name type host version)))
  (when (and case (neq case :local))
    (setf (%pathname-directory path) (%reverse-component-case (%pathname-directory path) case)
          (%pathname-name path) (%reverse-component-case (%pathname-name path) case)
          (%pathname-type path) (%reverse-component-case (%pathname-type path) case)))
  path)

;  In portable CL, if the :directory argument to make pathname is a string, it should
;  be the name of a top-level directory and should not contain any punctuation characters
;  such as ":" or ";".  In MCL a string :directory argument with colons or semicolons
;  will be parsed as a directory in the obvious way.
(defun %std-directory-component (directory &optional host)
  (cond ((null directory) nil)
        ((eq directory :wild) '(:absolute :wild-inferiors)) ; or :wild-inferiors? - yes
        ((stringp directory) (%directory-string-list directory 0 (length directory) host))
        ((listp directory)
         ;Standardize the directory list, taking care not to cons if nothing
         ;needs to be changed.
         (let ((names (%cdr directory)) (new-names ()))           
           (do ((nn names (%cdr nn)))
               ((null nn) (setq new-names (if new-names (nreverse new-names) names)))
             (let* ((name (car nn))
                    (new-name (cond ((consp name)(error "Shouldnt"))
                                    (t (%std-directory-part name)))))
               (unless (eq name new-name)
                 (unless new-names
                   (do ((new-nn names (%cdr new-nn)))
                       ((eq new-nn nn))
                     (push (%car new-nn) new-names))))
               (when (or new-names (neq name new-name))
                 (push new-name new-names))))
           (if (memq :up (or new-names names))
             (setq new-names (remove-up (or new-names (copy-list names)))))
           (ecase (%car directory)
             (:relative           
                  (cond (new-names         ; Just (:relative) is the same as NIL. - no it isnt
                         (if (eq new-names names)
                           directory
                           (cons ':relative new-names)))
                        (t directory)))
             (:absolute
                  (cond ((null new-names) directory)  ; But just (:absolute) IS the same as NIL
                        ((eq (%car new-names) ':up)
                         (report-bad-arg (%car new-names)'(not (member :up))))
                        ((eq new-names names) directory)
                        (t (cons ':absolute new-names)))))))
        (t (report-bad-arg directory '(or string list (member :wild))))))

(defun %std-directory-part (name)
  (case name
    ((:wild :wild-inferiors :up) name)
    (:back :up)
    (t (cond ((string= name "*") :wild)
             ((string= name "**") :wild-inferiors)
             (t (%path-std-quotes name "/;*" "/;"))))))

; this will allow creation of garbage pathname "foo:bar;bas:" do we care?
(defun merge-pathnames (path &optional (defaults *default-pathname-defaults*)
                                       default-version)
  ;(declare (ignore default-version))
  (when (not (pathnamep path))(setq path (pathname path)))
  (when (not (pathnamep defaults))(setq defaults (pathname defaults)))
  (let* ((path-dir (pathname-directory path))
         (path-host (pathname-host path))
         (path-name (pathname-name path))
         (default-dir (and defaults (pathname-directory defaults)))
         (default-host (and defaults (pathname-host defaults)))
         ; take host from defaults iff path-dir is logical or absent - huh? 
         ; we used to turn "foo;bar" into (:absolute (:logical foo)) no mo
         (host (cond ((or (null path-host)  ; added 7/96
                          (and (memq path-host '(nil :unspecific))
                               (or (null path-dir)
                                   (null (cdr path-dir))
                                   (consp (cadr path-dir)) ; not relevant now
                                   (and (eq :relative (car path-dir))
                                        (not (memq default-host '(nil :unspecific)))))))
                          
                      default-host)
                     (t  path-host)))
         (dir (cond ((null path-dir) default-dir)
                    ((null default-dir) path-dir)
                    ((eq (car path-dir) ':relative)
                     (let ((the-dir (append default-dir (%cdr path-dir))))
                       (when (memq ':up the-dir)(remove-up the-dir))
                       the-dir))
                    (t path-dir)))
         (nam (or path-name
                  (and defaults (pathname-name defaults))))
         (typ (or (pathname-type path)
                  (and defaults (pathname-type defaults))))
         (version (cond ((not path-name)(pathname-version defaults))
                        (t (pathname-version path)))))
    (when (and default-version (or (null version)(eq version :unspecific)))
      (setq version default-version))
    (if (and (pathnamep path)
             (eq dir (%pathname-directory path))
             (eq nam path-name)
             (eq typ (%pathname-type path))
             (eq host path-host)
             (eq version (pathname-version path)))
      path 
      (cons-pathname dir nam typ host version))))

(defun directory-pathname-p (path)
  (let ((name (pathname-name path))(type (pathname-type path)))
    (and  (or (null name) (%izerop (length name)))
          (or (null type) (eq type :unspecific)))))

(defun pathname-version (path)
  (let* ((p (pathname path)))
    (if (typep p 'logical-pathname)
	(%logical-pathname-version p))))


;In CCL, a pathname is logical if and only if pathname-host is not :unspecific.
(defun pathname-host (thing &key case)
  (when (streamp thing)(setq thing (%path-from-stream thing)))
  (when case (setq case (require-type case pathname-case-type)))
  (let ((name
         (typecase thing    
           (logical-pathname (%logical-pathname-host thing))
           (pathname :unspecific)
	   (t (let* ((p (pathname thing)))
		(if (typep p 'logical-pathname)
		    (%logical-pathname-host p)
		    :unspecific))))))
    (if (and case (neq case :local))
      (%reverse-component-case name case)
      name)))


; thing is logical-host if it starts with foo: which is a defined logical host
; and it contains no other unquoted colons
; So if one has a disk with the same name as a defined logical host
; either rename the disk or access it via (make-pathname :directory "foo" )
  


; huh??
(defun pathname-device (thing &key case)
  (declare (ignore case thing))
  ;(pathname thing)
  :unspecific)


;A directory is either NIL or a (possibly wildcarded) string ending in ":" or ";"
;Quoted :'s are allowed at this stage, though will get an error when go to the
;filesystem.
(defun pathname-directory (path &key case)
  (when (streamp path) (setq path (%path-from-stream path)))
  (when case (setq case (require-type case pathname-case-type)))
  (let ((names (%pathname-directory (pathname path))))
    (if (and case (neq case :local))
      (%reverse-component-case names case)
      names)))

(defun %directory-string-list (sstr start &optional (end (length sstr)) host)
  ;This must cons up a fresh list, %expand-logical-directory rplacd's it.
  (when (eq host :unspecific)(setq host nil))
  (labels ((std-part (sstr start end)
             (%std-directory-part (if (and (eq start 0) (eq end (length sstr)))
                                    sstr (%substr sstr start end))))
           (split (sstr start end)
             (unless (eql start end)
               (if (memq (%schar sstr start) '(#\/ #\;))
                 (cons :up (split sstr (%i+ start 1) end))
                 (let* ((pos (or (%path-mem "/;" sstr start end) end))
                        (part (std-part sstr start pos)))
                   (cons part
                         (unless (eq end pos)
                           (split sstr (%i+ pos 1) end))))))))
    (unless (eq start end)
      (let* ((pos (%path-mem "/;" sstr start end)))
        (when (and pos  (< pos (1- end))) ;; << gaak
          (let ((char (schar sstr pos)))
            ; this never did anything sensible but did not signal an error
            (if (or (and (eq char #\/)(%path-mem ";" sstr (1+ pos) end))
                    (and (eq char #\;)(%path-mem "/" sstr (1+ pos) end)))
              (error "Ilegal directory string ~s" sstr))))              
        (cond ((null pos)
               (list :relative (std-part sstr start end)))
              ((eq start pos)
               (let ((rest (split sstr (%i+ pos 1) end)))
                 (cons ':absolute rest)))              
              (t  (list* (if host :absolute :relative) (std-part sstr start pos) (split sstr (%i+ pos 1) end))))))))



;A name is either NIL or a (possibly wildcarded, possibly empty) string.
;Quoted :'s are allowed at this stage, though will get an error if go to the
;filesystem.
(defun pathname-name (path &key case)
  (when (streamp path) (setq path (%path-from-stream path)))
  (when case (setq case (require-type case pathname-case-type)))
  (let ((name (%pathname-name (pathname path))))
    (if (and case (neq case :local))
      (%reverse-component-case name case)
      name)))

(defun %std-name-component (name)
  (cond ((null name) nil)
        ((eq name :wild) "*")
        (t (%path-std-quotes name ".:;*" ".:;"))))

;A type is either NIL or a (possibly wildcarded, possibly empty) string.
;Quoted :'s are allowed at this stage, though will get an error if go to the
;filesystem.
(defun pathname-type (path &key case)
  (when (streamp path) (setq path (%path-from-stream path)))
  (when case (setq case (require-type case pathname-case-type)))
  (let ((name (%pathname-type (pathname path))))
    (if (and case (neq case :local))
      (%reverse-component-case name case)
      name)))

; assumes version if any has been stripped away (i.e. is past end)
(defun pathname-type-sstr (sstr start end)
  (let ((pos (%path-mem-last ":;" sstr start end)))
    (if pos (setq start (%i+ 1 pos)))    
    (setq pos (%path-mem-last "." sstr start end))
    (when pos
      (cond ((= (%i+ 1 pos) end)  ; a lonely dot - or is it unspecific if no dot?
             (values "" (%i- end 1)))
            (t (setq start (%i+ 1 pos))
               (values (%std-type-component (%substr sstr start end))
                       (%i- start 1)))))))

(defun %std-type-component (type)
  (cond ((or (null type) (eq type :unspecific)) type)
        ((eq type :wild) "*")
        (t (%path-std-quotes type ".:;*" ".:;"))))




(defun %reverse-component-case (name case)
  (cond ((not (stringp name))
         (if (listp name)
           (mapcar #'(lambda (name) (%reverse-component-case name case))  name)
           name))
        ((eq case :studly) (string-studlify name))
        (t ; like %read-idiocy but non-destructive - need it be?
         (let ((which nil)
               (len (length name)))
           (dotimes (i len)
             (let ((c (%schar name i)))
               (if (alpha-char-p c)
                 (if (upper-case-p c)
                   (progn
                     (when (eq which :lower)(return-from %reverse-component-case name))
                     (setq which :upper))
                   (progn
                     (when (eq which :upper)(return-from %reverse-component-case name))
                     (setq which :lower))))))
           (case which
             (:lower (string-upcase name))
             (:upper (string-downcase name))
             (t name))))))

;;;;;;; String-with-quotes utilities
(defun %path-mem-last-quoted (chars sstr &optional (start 0) (end (length sstr)))
  (while (%i< start end)
    (when (and (%%str-member (%schar sstr (setq end (%i- end 1))) chars)
               (%path-quoted-p sstr end start))
      (return-from %path-mem-last-quoted end))))

(defun %path-mem-last (chars sstr &optional (start 0) (end (length sstr)))
  (while (%i< start end)
    (when (and (%%str-member (%schar sstr (setq end (%i- end 1))) chars)
               (not (%path-quoted-p sstr end start)))
      (return-from %path-mem-last end))))

(defun %path-mem (chars sstr &optional (start 0) (end (length sstr)))
  (let ((one-char (when (eq (length chars) 1) (%schar chars 0))))
    (while (%i< start end)
      (let ((char (%schar sstr start)))
        (when (if one-char (eq char one-char)(%%str-member char chars))
          (return-from %path-mem start))
        (when (eq char *pathname-escape-character*)
          (setq start (%i+ start 1)))
        (setq start (%i+ start 1))))))

; these for :  meaning this aint a logical host. Only legal for top level dir
 
(defun %path-unquote-one-quoted (chars sstr &optional (start 0)(end (length sstr)))
  (let ((pos (%path-mem-last-quoted chars sstr start end)))
    (when (and pos (neq pos 1))
      (cond ((or (%path-mem chars sstr start (1- pos))
                 (%path-mem-last-quoted chars sstr start (1- pos)))
             nil)
            (t (%str-cat (%substr sstr start (1- pos))(%substr sstr  pos end)))))))

(defun %path-one-quoted-p (chars sstr &optional (start 0)(end (length sstr)))
  (let ((pos (%path-mem-last-quoted chars sstr start end)))
    (when (and pos (neq pos 1))
      (not (or (%path-mem-last-quoted chars sstr start (1- pos))
               (%path-mem chars sstr start (1- pos)))))))
 
(defun %path-quoted-p (sstr pos start &aux (esc *pathname-escape-character*) (q nil))
  (while (and (%i> pos start) (eq (%schar sstr (setq pos (%i- pos 1))) esc))
    (setq q (not q)))
  q)



;Standardize pathname quoting, so can do EQUAL.
(defun %path-std-quotes (arg keep-quoted make-quoted)
  (when (symbolp arg)
    (error "Invalid pathname component ~S" arg))
  (let* ((str arg)
         (esc *pathname-escape-character*)
         (end (length str))
         res-str char)
    (multiple-value-bind (sstr start)(array-data-and-offset str)
      (setq end (+ start end))
      (let ((i start))
        (until (eq i end)
          (setq char (%schar sstr i))
          (cond ((or (%%str-member char make-quoted)
                     (and (null keep-quoted) (eq char esc)))
                 (unless res-str
                   (setq res-str (make-array (%i- end start)
                                             :element-type (array-element-type sstr)
                                             :adjustable t :fill-pointer 0))
                   (do ((j start (%i+ j 1))) ((eq j i))
                     (vector-push-extend (%schar sstr j) res-str)))
                 (vector-push-extend esc res-str))
                ((neq char esc) nil)
                ((eq (setq i (%i+ i 1)) end)
                 (error "Malformed pathname component string ~S" str))
                ((or (eq (setq char (%schar sstr i)) esc)
                     (%%str-member char keep-quoted))
                 (when res-str (vector-push-extend esc res-str)))
                (t
                 (unless res-str
                   (setq res-str (make-array (%i- end start)
                                             :element-type (array-element-type sstr)
                                             :adjustable t :fill-pointer 0))
                   (do ((j start (%i+ j 1)) (end (%i- i 1))) ((eq j end))
                     (vector-push-extend (%schar sstr j) res-str)))))
          (when res-str (vector-push-extend char res-str))
          (setq i (%i+ i 1)))
        (ensure-simple-string (or res-str str))))))



(defun %%str-member (char string)
  (locally (declare (optimize (speed 3)(safety 0)))
    (dotimes (i (the fixnum (length string)))
      (when (eq (%schar string i) char)
        (return i)))))

; need to keep these until world is recompiled with different fcomp-standard-source

(defvar *logical-directory-alist* nil)
#|
  `(("CCL" . ":")                       ; reset in l1-boot
    ("HOME" . ":")                      ; ditto.
))

    ("L1" . "ccl;level-1:")
    ("L1F" . "ccl;L1-fasls:")
    ("LIB" . "ccl;lib:")
    ("BIN" . "ccl;bin:"))
    ("CODE" . "ccl;lib:")
    ("FASLS"   . "ccl;bin:")
    ("COMPILER" . "ccl;compiler:")
    ("EXAMPLES" . "ccl;examples:")
    ("LIBRARY" . "ccl;library:")
    ("INTERFACES" . "library;interfaces:")
    ))
|# ; why do we crash if this is nil


(defun file-write-date (path)
  (%file-write-date (namestring (translate-logical-pathname path))))

;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_
; load, require, provide

(defun find-load-file (file-name)
  (let ((full-name (full-pathname file-name :no-error nil)))
    (when full-name
      (let ((file-type (pathname-type full-name)))
        (if (and file-type (neq file-type :unspecific))
          (values (probe-file full-name) file-name file-name)
          (let* ((source (merge-pathnames file-name *.lisp-pathname*))
                 (fasl   (merge-pathnames file-name *.fasl-pathname*))
                 (true-source (probe-file source))
                 (true-fasl   (probe-file fasl)))
            (cond (true-source
                   (if (and true-fasl
                            (> (file-write-date true-fasl)
                               (file-write-date true-source)))
                     (values true-fasl fasl source)
                     (values true-source source source)))
                  (true-fasl
                   (values true-fasl fasl fasl))
                  ((setq full-name (probe-file full-name))
                   (values full-name file-name file-name)))))))))



(defun compile-load (file-name &rest options &key
                               fasl-file force-compile ignore-compiler-warnings
                               &allow-other-keys)
  (declare (dynamic-extent options))
  (remf options :fasl-file)
  (remf options :force-compile)
  (remf options :ignore-compiler-warnings)
  (let* ((file (merge-pathnames file-name *.lisp-pathname*))
         (fasl (merge-pathnames (if fasl-file (merge-pathnames fasl-file *.fasl-pathname*) *.fasl-pathname*)
                                file)))
    (when (probe-file file)
      (when (or force-compile
                (not (probe-file fasl))
                (< (file-write-date fasl) (file-write-date file)))
        (multiple-value-bind (compiled ignore bad-warnings)
                             (apply #'compile-file file :output-file fasl options)
          (declare (ignore ignore))
          (unless compiled              ; skip compile to compiler error
            (return-from compile-load nil))
          (unless (or ignore-compiler-warnings (not bad-warnings))
            (restart-case
              (error "Compiling ~s produced warnings." file)
              (retry-compile ()
                     :report (lambda (s) (format s "Retry compiling ~s" file))
                     (return-from compile-load (apply #'compile-load file-name options)))
              (load-anyway ()
                     :report (lambda (s) (format s "Load ~s despite compiler warnings" fasl)))
              (skip-load ()
                     :report (lambda (s) (format s "Skip loading ~s" fasl))
                     (return-from compile-load nil)))))))
    (if (probe-file fasl)
      (restart-case
        (apply #'load fasl options)
        (retry-compile ()
               :report (lambda (s) (format s "Retry compiling ~s" file))
               (apply #'compile-load file-name options))
        (skip-load ()
               :report (lambda (s) (format s "Skip loading ~s" fasl))
               nil))
      (restart-case
        (signal-file-error $err-no-file file)
        (retry-compile ()
               :report (lambda (s) (format s "Retry compiling ~s" file))
               (apply #'compile-load file-name options))))))

(defun load (file-name &key (verbose *load-verbose*)
                       (print *load-print*)
                       (if-does-not-exist :error)
                       ;Franz foreign function keywords.
                       foreign-files system-libraries unreferenced-lib-names)
  "Extension: :PRINT :SOURCE means print source as well as value"
  (loop
    (restart-case
      (return (%load file-name verbose print if-does-not-exist 
                     foreign-files system-libraries unreferenced-lib-names))
      (retry-load ()
                  :report (lambda (stream) (format stream "Retry loading ~s" file-name)))
      (skip-load ()
                 :report (lambda (stream) (format stream "Skip loading ~s" file-name))
                 (return nil))
      (load-other ()
                  :report (lambda (stream) (format stream "Load other file instead of ~s" file-name))
                  (return
                   (load (choose-file-dialog)
                         :verbose verbose
                         :print print
                         :if-does-not-exist if-does-not-exist
                         :foreign-files foreign-files
                         :system-libraries system-libraries
                         :unreferenced-lib-names unreferenced-lib-names))))))

(declaim (notinline ff-load))
(defun ff-load (&rest args)
  (require "FF")
  (apply #'ff-load args))

(defun %load (file-name verbose print if-does-not-exist 
                        foreign-files system-libraries
                        unreferenced-lib-names
                        &aux type)
  (let ((*load-pathname* file-name)
        (*load-truename* file-name)
        (source-file file-name)
        constructed-source-file)
    (declare (special *load-pathname* *load-truename*))
    (unless (streamp file-name)
      (multiple-value-setq (*load-truename* *load-pathname* source-file)
        (find-load-file (merge-pathnames file-name)))
      (when (not *load-truename*)
        (return-from %load (if if-does-not-exist
                             (signal-file-error $err-no-file file-name))))
      (setq file-name *load-truename*)
      (setq type (mac-file-type file-name))
      (when (and (or foreign-files
                     system-libraries
                     unreferenced-lib-names
                     (eq type :|OBJ |))
                 (fboundp 'ff-load))
        (when (equal file-name "") (setq file-name nil))
        (return-from %load
          (ff-load (if (listp file-name)
                     (append file-name foreign-files)
                     (cons file-name foreign-files))
                   :libraries system-libraries
                   :library-entry-names unreferenced-lib-names))))
    (when (setq foreign-files (if foreign-files :foreign-files
                                  (if system-libraries :system-libraries
                                      (if unreferenced-lib-names :unreferenced-lib-names))))
      (error "Inappropriate options in ~S ." foreign-files))
    (let* ((*package* *package*)
           (*readtable* *readtable*)
           (*loading-files* (cons file-name (specialv *loading-files*)))
           (*loading-file-source-file* (namestring source-file))) ;reset by fasload to logical name stored in the file?
      (declare (special *loading-files* *loading-file-source-file*))
      (unwind-protect
        (progn
          (when verbose
            (format t "~&;Loading ~S..." *load-pathname*)
            (force-output))
          (cond ((eq type  #+ppc-target :PFSL #+sparc-target :SFSL #-(or sparc-target ppc-target) :FASL)
                 (flet ((attempt-load (file-name)
                          (multiple-value-bind (winp err) 
			      (%fasload (namestring file-name))
                            (if (not winp) 
                              (%err-disp err)))))
                   (let ((*fasload-print* print))
                     (declare (special *fasload-print*))
                     (setq constructed-source-file (make-pathname :defaults file-name :type (pathname-type *.lisp-pathname*)))
                     (when (equalp source-file *load-truename*)
                       (when (probe-file constructed-source-file)
                         (setq source-file constructed-source-file)))
                     (if (and source-file
                              (not (equalp source-file file-name))
                              (probe-file source-file))
                       ;;really need restart-case-if instead of duplicating code below
                       (restart-case
                         (attempt-load file-name)
                         #+ignore
                         (load-other () :report (lambda (x) (format s "load other file"))
                                     (return-from
                                       %load
                                       (%load (choose-file-dialog) verbose print if-does-not-exist
                                              foreign-files system-libraries unreferenced-lib-names)))
                         (load-source 
                          ()
                          :report (lambda (s) 
                                    (format s "Attempt to load ~s instead of ~s" 
                                            source-file *load-pathname*))
                          (return-from 
                            %load
                            (%load source-file verbose print if-does-not-exist 
                                   foreign-files system-libraries unreferenced-lib-names))))
                       ;;duplicated code
                       (attempt-load file-name)))))
                ((eq type :TEXT)
                 (with-open-file (stream file-name :element-type 'base-char)
                   (load-from-stream stream print)))
                ((null type)
                 (load-from-stream file-name print))
                (t (signal-file-error $xnotfaslortext file-name)))))))
  file-name)

(defun load-from-stream (stream print &aux (eof-val (list ())) val)
  (with-compilation-unit (:override nil) ; try this for included files
    (let ((env (new-lexical-environment (new-definition-environment 'eval))))
      (%rplacd (defenv.type (lexenv.parent-env env)) *outstanding-deferred-warnings*)
      (while (neq eof-val (setq val (read stream nil eof-val)))
        (when (eq print :source) (format t "~&Source: ~S~%" val))
        (setq val (cheap-eval-in-environment val env))
        (when print
          (format t "~&~A~S~%" (if (eq print :source) "Value: " "") val))))))

(defun include (filename)
  (load
   (if (null *loading-files*)
     filename
     (merge-pathnames filename (directory-namestring (car *loading-files*))))))

(%fhave '%include #'include)

(defun delete-file (path)
  (let* ((err (%delete-file (namestring (translate-logical-pathname (pathname path))))))
    (or (eql 0 err) (signal-posix-error err))))


(defun mac-file-type (f)
  (unless (probe-file f)
    (error "File not found: ~S" f))
  (let ( (type (pathname-type f)) )
    (cond
     ( (string= type "lisp") :text )
     ( (string= type "pfsl") :pfsl )
     ( (string= type "sfsl") :sfsl )
     (t (error "Unknown file type: ~S" f)))))


(defun provide (module &aux (str (string module)))
  (when (null module) (report-bad-arg module '(not (member nil))))
  (setq *modules* (adjoin str *modules* :test #'string-equal))
  (let* ((cell (assoc str *module-file-alist* :test #'string-equal))
         (path *loading-file-source-file*))
    (if cell
      (setf (cdr cell) path)
      (push (cons str path) *module-file-alist*)))
  str)

(defparameter *loading-modules* () "Internal. Prevents circularity")

(defun require (module &optional pathname &aux (str (string module)))
  (when (null module) (report-bad-arg module '(not null)))
  (when (and (not (member str *modules* :test #'string-equal))
             (not (member str *loading-modules* :test #'string-equal))
             (or pathname
                 (setq pathname (find-module-pathnames str))
                 (progn
                   (cerror "If ~S still hasn't been provided,
you will be asked to choose a file."
                           "The module ~S was required while loading ~S.
No file could be found for that module."
                           str *loading-file-source-file*)
                   (unless (member str *modules* :test #'string-equal)
                     (catch-cancel
                       (setq pathname (choose-file-dialog
                                       :mac-file-type '(#+sparc-target :sfsl
                                                        #+ppc-target :pfsl
							#(or ppc-target sparc-target) :fasl
                                                        :text)))))
                   pathname)))
    (let ((*loading-modules* (cons str *loading-modules*)))
      (if (consp pathname)
        (dolist (path pathname) (load path))
        (load pathname)))
    (setq *modules* (adjoin str *modules* :test #'string-equal)))
  str)

(defun find-module-pathnames (module)
  "Returns the file or list of files making up the module"
  (or (cdr (assoc module *module-file-alist* :test #'string-equal))
      (let ((mod-path (make-pathname :name (string-downcase module) :defaults nil)) path)
        (dolist (path-cand *module-search-path* nil)
          (when (setq path (find-load-file (merge-pathnames mod-path path-cand)))
            (return path))))))

#|
	Change History (most recent last):
	2	12/29/94	akh	merge with d13
|# ;(do not edit past this line!!)
