; -*- Mode:Lisp; Package:CCL; -*-

;;	Change History (most recent first):
;;  7 7/7/95   akh  one fred module
;;  (do not edit before this line!!)


; appgen-misc.lisp - MCL-AppGen support
; Copyright 1995 Digitool, Inc.

; This file is included in build-application.lisp,, and loaded by l1-boot-appgen.lisp

; Modification History
;
;  7/11/96 slh   provide "APPGEN-MISC"
;  5/03/96 slh   init-file field
;  7/20/95 slh   include compiler module only if found
;---------------- beta 1 release
;  6/28/95 slh   application methods here; *optional-modules*


(in-package :ccl)

(export '(*optional-modules*))

(defstruct (application-info (:constructor make-app-info)
                             (:conc-name   app-info-))
  name
  class-name
  pathname
  file-creator
  toplevel
  error-mode
  sizes
  resource-file
  optional-modules
  custom-modules
  search-path
  init-file)


;;; New application methods

; NOTE: keep *module-categories* up-to-date with this list!!
(eval-when (:execute :compile-toplevel :load-toplevel)
  (defvar *optional-modules*
    `(,@(if (probe-file "home:appgen;compiler.fasl")
          `(compiler))
      arglist
      eval
      boyer-moore
      edhardcopy
      ;fred-additions
      ;fred-misc
      fred
      pprint
      simple-db
      windoids
      )))

#| yuk, just be careful
(eval-when (:execute :compile-toplevel)
  (when (and (boundp '*module-categories*)
             *module-categories*
             (set-difference *optional-modules*
                             (mapcar #'car (cdr (assoc "Optional Modules" *module-categories*
                                                       :test #'string=)))))
    (cerror "Ignore error" "*optional-modules* and *module-categories* are out of synch")))
|#


;; New application methods

(export '(;application-toplevel-function
          application-custom-modules
          application-optional-modules
          application-menubar
          application-error-mode))

#| just use toplevel-function method (should have been called application-...)
(defmethod application-toplevel-function ((app application))
  'event-processing-loop)

(defmethod application-toplevel-function ((app lisp-development-system))
  'toplevel-function)
|#

(defmethod application-custom-modules   ((app application)) nil)
(defmethod application-optional-modules ((app application)) *optional-modules*)

(defmethod application-menubar ((app application))
  (list *apple-menu* *file-menu* *edit-menu* *windows-menu*))

(defmethod application-menubar ((app lisp-development-system))
  *default-menubar*)

(defmethod application-error-mode ((app application)) :dialog)
(defmethod application-error-mode ((app lisp-development-system)) :listener)        ; not really necessary

(provide "APPGEN-MISC")

; End of appgen-misc.lisp
