;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  17 5/20/96 akh  no more *window-object-hash*
;;  16 4/24/96 akh  remove some #-ppc-target stuff that made dialog not work
;;  10 2/23/96 akh  bill's fix to restore-pascal-functions
;;  2 10/17/95 akh  merge patches
;;  18 7/27/95 akh  merge patches
;;  16 7/7/95  akh  in kill-lisp-pointers - check fboundp kill-frec-list
;;  11 5/22/95 akh  error if size too small
;;  9 5/9/95   akh  save-application size defaults to current.
;;  8 5/1/95   akh  made default min size be 3584 (for CCL so building MCL should provide it.)
;;  2 4/4/95   akh  nullify *event-error-dialog*
;;  7 3/20/95  akh  put back old def of toplevel-function
;;  5 3/2/95   akh  use application-file-creator
;;  4 2/17/95  akh  clear *window-object-hash*
;;  (do not edit before this line!!)

; Dumplisp.lisp
; Copyright 1985-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc. The 'tool rules!

;; Modification History
;
;02/27/97 bill  Fix %save-application-internal so that passing an explicit
;               :init-file of NIL to save-application will result in no
;               init file.
;-------------  4.0
;10/04/96 bill  kill-lisp-pointers clears *window-object-alist* via
;               repeated calls to remove-window-object. This both ensures
;               that the cache is clear and that remove-lisp-wdef gets
;               called on each one.
;10/02/96 bill  save-image sets *interrupt-level* negative after, not before,
;               throwing to toplevel to eliminate the possiblity of restoring
;               a saved binding. This makes it work to call save-application
;               from within an event processing function (e.g. a menu or dialog-item
;               action function).
;08/05/96 bill  Add :errchk to #_NewHandle call in get-app-resources &
;               #_NewHandleClear call in create-lib-cfrg-handle.
;07/16/86 gb    save-library: append timestamp to fragment name.
;05/21/96 bill  eliminate the undeclared free variable warning for
;               the reference to *window-object-hash* in kill-lisp-pointers.
;05/04/96 bill  slh's fixes to load-and-detach-no-error and get-app-resources
;-------------  MCL-PPC 3.9
; 5/03/96 slh   %save-application-internal: use application-init-file
;04/10/96 gb    revive :EXCISE-COMPILER.
;03/26/96 gb    lowmem accessors.
;03/17/96 gb    save-library writes version info to cfrg after data fork written.
;03/14/96 bill  unconditionalize calls to new-version-resource and process-lsiz-options
;03/01/96 gb    save-library
;01/11/96 gb    ppc-target changes (some of them wrong.)
;12/27/95 gb    trap-pointer stuff is #-ppc-target.
;12/20/95 bill  restore some of the file for the PPC
;11/29/95 bill  New trap names. (#_PBxxx :errchk ...) -> (errchk (#_PBxxx ...))
;11/14/95 bill  restore-pascal-functions comes out-of-line from restore-lisp-pointers.
;               Separate versions for ppc & 68k.
;11/01/95 bill  initialize-shared-libraries in restore-lisp-pointers.
;               clear-shared-library-caches in kill-lisp-pointers
;10/20/95 slh   disabled for PPC
; 7/12/95 slh   Need patches here as well as patch file:
;               - restore-lisp-pointers calls initialize-ff-traps-pointer directly
;               - pass creator to create-file
;               - use _Get1IndResource; don't confuse index with id
; 6/09/95 slh   don't nuke *ff-traps* table
; 6/01/95 slh   kill-lisp-pointers: call save-trap-pointer-to-array
; 5/31/95 slh   consistently use 3.5M/4M for min/pref sizes
; 5/12/95 slh   new traps mods.
; 4/30/95 akh   increase image minimum size, remove all size resources > -1
; 4/28/95 slh   clear *module-file-alist*
; 4/27/95 slh   toplevel-function methods moved to public file
; 4/16/95 slh   require :resources at load time too; get-app-resources: check for "" -
;                (probe-file "") is returning a directory!
; 4/11/95 slh   get-app-resources here (needed during application load-for-dump)
; 3/10/95 slh   Bill's new toplevel-function has init file output go to first listener
;-------------- 3.0d17
;10/04/93 bill  save-image disables high level events in *event-mask*.
;               Will be reenabled by startup-ccl
;-------------- 3.0d13
;07/19/93 bill  kill-frec-list replaces more intimiate knowledge of %frec-list%
;-------------- 3.0d12
;07/11/93 alice *script-char...tables* => nil
;05/01/93 alice hide-listener arg to save-application is history
;05/04/93 bill  pass vrefnum to $sp-saveappl
;               toplevel-function (application) does print-application-document
;04/29/93 bill  all-processes & friends -> *all-processes* & friends
;04/24/93 bill  terminate-standin-event-processor in save-application
;04/21/93 bill  no args to event-dispatch - new *idle* handling.
;               (setq *non-idle-processes* nil) in kill-lisp-pointers
;-------------- 2.1d5
;04/29/93 alice toplevel-function (application) does open-application-document on finder-parameters.
;-------------- 2.1d4
;03/??/93 alice more options to save-application - hide-listener isn't right yet
;11/04/92 alice excise-compiler - don't die if called twice
;01/21/93 bill toplevel-function method called by default toplevel-function arg to save-application.
;12/09/92 bill In kill-lisp-pointers: remove redundant (setq *last-choose-file-directory* nil)
;------------- 2.0
;01/07/92 gb   don't require RECORDS.
;12/12/91 bill #_LoadResource after #_Get1Resource
;------------- 2.0b4
;11/24/91 bill open-dumplisp-file sets the bundle bit if there is a ('BNDL 128) resource.
;              If one of the resources passed to save-application is not a list, it
;              is funcalled by open-dumplisp-file with a single arg: the name of the new file.
;              This gives users a hook to copy another resource file into the application
;              (or do whatever they want).
;11/15/91 gb   :memory-options for setting LSIZ resource.  *patched-resources*.
;11/06/91 bill  run *save-exit-functions* before kill-lisp-pointers.
;               Run *lisp-startup-functions* before running the user toplevel function.
;               All the startup function lists get run by restore-lisp-pointers.
;10/29/91 alice nuke *restore-lisp-functions*, catch errors in *lisp-user-pointer-functions*
;10/21/91 gb   no more #_PB.
;10/10/91 gb   Deprecate :compress option a little more completely.
;------------ 2.0b3
;08/24/91 gb   KILL-OLD-TRAP-SYNTAX.
;08/14/91 gb   KILL-LISP-POINTERS: setq *help-manager-present* nil.
;07/21/91 gb   Give up on DUMPLISP.  DIsable *COMPILE-DEFINITIONS* when excising compiler.
;06/20/91 bill KILL-LISP-POINTERS: no more *grow-bm*.  Clear *event-dispatch-task*
;------------- 2.0b2
;05/20/91 gb   set *%periodic-tasks%* to nil in kill-lisp-pointers.
;04/15/91 bill /,  //, ///, %saved-ioVRefnum%, %saved-directory-path%, *open-file-streams*
;              are now initialized in kill-lisp-pointers
;03/28/91 alice save-application may change version resource
;03/05/91 bill set *selected-window* NIL in kill-lisp-pointers.
;------------ 2.0b1
;01/29/91 bill clear-killed-strings moves from save-application to kill-lisp-pointers.
;              Clear the scrap stuff in kill-lisp-pointers.
;01/02/91 gb   don't restore woi state of %pascal-functions in restore-, kill-lisp-pointers.
;              :excise-compiler, :size, :resources options to save-application.
;12/31/90 bill kill-lisp-pointers saves the without-interrupts status of defpascal
;              functions and restore-lisp-functions restores it.
;              save-application's default toplevel-function always calls startup-ccl
;12/28/90 gb   :size, :resources args to SAVE-APPLICATION & OPEN-DUMPLISP-FILE.
;12/10/90 bill *fast-help* initialization
;12/07/90 bill kill-lisp-pointers: init *fast-help*
;10/16/90 bill Remove (setq *inspect-history-items* nil) from kill-lisp-pointers.
;08/28/90 bill *%saved-method-var%* no longer exists as a variable:  it's a setfable function.
;07/23/90 gb   try letting :compress default to T, new magic compress flags, watch cursor around open-dumplisp-file.
;06/27/90 bill clear *%saved-method-var%* in kill-lisp-pointers
;06/18/90 bill in save-application: new clear-clos-caches parameter, add clear-killed-strings.
;05/04/90 bill restore-lisp-pointers sets *foreground* to T.
;03/31/90 bill kill-lisp-pointers kills frecs
;03/16/90 bill prepare-to-quit replaces in-line window closing in save-application & dumplist
;2/5/90   gz   compress lives again.
;12/26/89 bill Add t second parameter to all windows calls: must deallocate
;              ALL windows, visible or not.
;12/27/89 gz   Split off save-image...
;12/21/89 gz   Don't use lfun-name to restore %pascal-functions%.  Rely on
;              the identity of macptrs instead.
;11/14/89 gz   Don't worry about *record-types* info.
;11/06/89 gb   zap managed vector space.
;10/14/89 gz   Split off open-dumplisp-file
;10/13/89 bill Call *lisp-cleanup-functions* in save-application before
;              closing windows.
;09/25/89 gz   Reserve room for header before calling $sp-saveappl.
;11/10/89 gb? def of *lisp-system-pointer-functions* moved to l1-init
;09/16/89 bill Remove the last vestiges of object-lisp windows
;07/25/89 bill kill-lisp-pointers, dumplisp & save-application:
;              close the CLOS windows, too. This is a temporary fix while
;              CLOS and object-lisp windows need to co-exist.
;07/09/89 gz  $sp-saveappl no longer sets toplevel function.
;04/07/89 gb  $sp8 -> $sp.
;4/4/89   gz  Try to dump new defpascals.
;03/25/89 gz  No more lfundefs resource to remove. toplevel closures ok now.
;             *inest-ptr* -> *interrupt-level*
;03/15/89 gb  %save-application now a kprim.
;02/10/89 gb  :creator arg in save-application.
;01/04/89 gz  (clear-input *terminal-io*) -> (setq *eval-queue* nil)
;11/22/88 gb  restore *record-types* info.
;10/23/88 gb  new restart protocol.
;8/30/88  gb  function made by make-restart-closure sets interrupt-level after without-interrupts.
;8/29/88  gz  new filesys fns.
;8/25/88  gz  $inest-ptr-8 -> $inest, require subprims8.
;8/18/88  gb  screw pushing :stand-alone onto *features*.
;8/8/88   gb  %hput-long -> %hput-ptr ldef-proc-handle ... in restore-lisp-pointers.
;8/8/88   gb  8.1
;7/30/88  gz  new macptr scheme (sort of).
;6/23/88  jaj #-bccl save-application
;6/22/88  jaj (setq %doc-string-file nil) in restore-lisp-pointers
;6/21/88  jaj nillify *window-object-alist* in kill-lisp-pointers
;             moved exports to ccl-export-syms
;6/20/88  jaj save-application creates files of type APPL
;6/10/88  jaj (ask *terminal-io* (stream-clear-input)) in kill-lisp-pointers
;6/02/88  as  expand some logical pathnames in dumplisp and save-application
;5/26/88  jaj merged in stuff from pearl
;4/25/88  jaj reset *screen-height* and *screen-width* in restore-lisp-pointers
;             close windows first in save-application and dumplisp
;4/21/88  jaj save-application pushes :stand-alone onto *features* set
;             +,++,+++,- to nil
;4/11/88  jaj for save-application and dumplisp: simplified keywords, added watch-cursor
;             use :if-exists :supersede. In kill-lisp-pointers setq *, **, *** to nil.
;             restore-lisp-pointers calls init-logical-directories. re-init random
;4/9/88   jaj kill-lisp-pointers disposes style handles
;4/6/88   as  kill-lisp-pointers sets %doc-string-file to nil
;4/6/88   jaj Beanified save-application
;4/1/88   jaj Beanified

(in-package :ccl)

(defvar *save-exit-functions* nil 
  "List of (0-arg)functions to call before saving memory image")

(defvar *restore-lisp-functions* nil
  "List of (0-arg)functions to call after restoring saved image")


(declaim (special *lisp-system-pointer-functions*)) ; defined in l1-init.

(defun kill-lisp-pointers ()
  (setq * nil ** nil *** nil + nil ++ nil +++ nil - nil
        / nil // nil /// nil
        *open-file-streams* nil
         @ nil)
  (setq *eval-queue* nil)
  
  (if (boundp '*window-object-hash*)
    (clrhash (symbol-value '*window-object-hash*)))
  (setq *selected-window* nil)
  (setf (*%saved-method-var%*) nil)
  (setq *%periodic-tasks%* nil)
  (setq *event-dispatch-task* nil)
  (setq *module-file-alist* nil)        ; nuke paths to lisp 
  )


; this needs work for the new world order
(defun save-application (filename
                         &rest rest
                         &key init-file toplevel-function
                         error-handler application-class excise-compiler
                           clear-clos-caches )
  (declare (ignore init-file toplevel-function  excise-compiler error-handler application-class
                   resources clear-clos-caches ))
  (apply #'process-interrupt
                *initial-process*
                #'%save-application-internal
                filename
                rest))

(defun %save-application-internal (filename &key
                                            (init-file nil init-file-p)
                                            toplevel-function  ;????                                             
                                            error-handler ; meaningless unless application-class or *application* not lisp-development..
                                            application-class
                                            excise-compiler                                            
                                            (clear-clos-caches t))  
  (when (and application-class (neq  (class-of *application*)
                                     (if (symbolp application-class)
                                       (find-class application-class)
                                       application-class)))
    (setq *application* (make-instance application-class)))
  (when (not toplevel-function)
    (setq toplevel-function 
          #'(lambda ()
              (toplevel-function *application* 
                                 (if init-file-p
                                   init-file
                                   (application-init-file *application*))))))
  (when error-handler
    (make-application-error-handler *application* error-handler))
  
  (prepare-to-quit)
  (if clear-clos-caches (clear-clos-caches))
  (if excise-compiler (excise-compiler))
  (save-image (let ((fd (open-dumplisp-file filename)))
                #'(lambda () (%save-application fd )))
              ;This is a bit bogus.  Specifying an init-file arg means requesting
              ;the usual lisp startup actions (load init file, print greeting and
              ;run *lisp-startup-functions*).  Really should have some more
              ;explicit arguments for specifying this stuff.
              toplevel-function))

(defun save-image (save-function toplevel-function)
  (let ((toplevel (%set-toplevel)))
      (%set-toplevel #'(lambda ()
                         (setq *interrupt-level* -1)
                         (%set-toplevel toplevel)       ; in case *save-exit-functions* error
                         (dolist (f *save-exit-functions*)
                           (funcall f))
                         (kill-lisp-pointers)
                         (%set-toplevel
                          #'(lambda ()
                              (%set-toplevel toplevel-function)
                              (restore-lisp-pointers)))   ; do startup stuff
                         (funcall save-function)))
      (toplevel)))

(defun open-dumplisp-file (filename)
  (setq filename (create-file filename :if-exists :overwrite))          ; FIX: :supersede
  (fd-open filename (logior #o01 #o01000 #o0100)))

(defun excise-compiler ()
   (if *nx1-alphatizers* (clrhash *nx1-alphatizers*))
   (%init-misc 0 *ppc2-specials*)
   (setq *compile-definitions* nil)
   (flet ((remove-startup-function (name)
            (setq *lisp-system-pointer-functions*
                  (delete name *lisp-system-pointer-functions*
                          :key #'function-name))))
     (dolist (f '(*ppc-operand-vector-freelist*
                  *ppc-lap-instruction-freelist*
                  *ppc-lap-label-freelist*
                  *vinsn-varparts*
                  *vinsn-label-freelist*
                  *vinsn-freelist*))
       (remove-startup-function f)))
   (ff-call (%kernel-import arch::kernel-import-excise-library)
                :unsigned-fullword 2    ; magic number
                :void))

        


(defun %save-application (fd)
  (let* ((err (%%save-application fd)))
    (unless (eql err 0)
      (%err-disp err))))
  

#+ppc-target
(defppclapfunction %%save-application ((fd arg_z))
  (uuo_xalloc rzero rnil fd)
  (blr))
#+sparc-target
(defsparclapfunction %%save-application ((fd %arg_z))
  (retl)
  (uuo_xalloc %rzero %rnil fd))
   

(defun restore-lisp-pointers ()
  (restore-pascal-functions)
  (refresh-external-entrypoints)
  (dolist (f (reverse *lisp-system-pointer-functions*))
    (funcall f))
  (setq *foreground* t)                 ; Necessary if you save a world under MultiFinder and run it in UniFinder.
  (let ((restore-lisp-fns *restore-lisp-functions*)
        (user-pointer-fns *lisp-user-pointer-functions*)
        (lisp-startup-fns *lisp-startup-functions*))
    (unwind-protect
      (with-simple-restart (abort "Abort (possibly crucial) startup functions.")
        (let ((call-with-restart
               #'(lambda (f)
                   (with-simple-restart 
                     (continue "Skip (possibly crucial) startup function ~s."
                               (if (symbolp f) f (function-name f)))
                     (funcall f)))))
          (dolist (f restore-lisp-fns) (funcall call-with-restart f))
          (dolist (f (reverse user-pointer-fns)) (funcall call-with-restart f))
          (dolist (f (reverse lisp-startup-fns)) (funcall call-with-restart f))))
      (setq *interrupt-level* 0)))
  nil)


(defun  restore-pascal-functions ()
  (when (simple-vector-p %pascal-functions%)
    (dotimes (i (length %pascal-functions%))
      (let ((pfe (%svref %pascal-functions% i)))
        (when (vectorp pfe)
          (let ((trampoline (make-callback-trampoline i))
                (name (pfe.sym pfe)))
            (setf (pfe.routine-descriptor pfe) trampoline)
            (when name
              (set name trampoline))))))))

