;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  32 1/22/97 akh  add with-font macro
;;  28 9/3/96  akh  fix defpascal-code for 68K, conditionalization
;;  26 5/20/96 akh  %i- takes > 2 args
;;  21 3/9/96  akh  apply-with-method-context macro moves here
;;  20 2/19/96 akh  copyright 1996
;;  17 12/22/95 gb  init *pascal-full-longs* for ppc-target
;;  15 12/12/95 akh #-ppc-target some eval-redefs.
;;  8 11/13/95 akh  fix ppc %clear-block
;;  3 10/17/95 akh  merge patches to with-pstrs and cstrs
;;  (do not edit before this line!!)


;;	Change History (most recent first, or maybe at the bottom):
;;    09/13/95 gb   %lexpr-count, %lexpr-ref.
;;  5 2/3/95   akh  merge leibniz patches
;;  4 2/2/95   akh  merge with leibniz patches for defstruct
;;  (do not edit before this line!!)

;; Level-2.lisp
; Copyright 1985-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995-1996 Digitool, Inc. 

; This file must be loaded in order to be compiled.

;; Modification History
;
; 03/28/97 bill  fix defpascal-ppc so that AlanR's test case works:
;                (defpascal bmn (:long) (print 'hi) 0)
; 03/26/97 bill  defclass eats the :primary-p class option unless (ppc-target-p)
; -------------- 4.1b1
; 03/05/97 gb    defpascal expands to DEFINE-PPC-PASCAL-FUNCTION-2.
; 02/23/97 bill  The lisp function passed to define-pascal-function now takes
;                the stack pointer arg as a fixnum and copies it into a macptr
;                only if necessary.
; 02/17/97 bill  with-process-enqueued doesn't call process-dequeue
;                unless its call to process-enqueue returns. 
; 01/23/97 bill  point-h & point-v => integer-point-h & integer-point-v
;                Remove duplicate with-font definition.
; 01/14/97 bill  default-setf takes an environment arg which it uses to
;                pass any known types of the arguments through to the gensyms they're
;                bound to.
; 01/01/97 bill  defclass handles the new :primary-p option.
; 12/02/96 bill  AlanR's fix to defmacro, ~:a instead of ~:s in format.
; -------------  4.0
; 09/25/96 bill  defsetf's for %get-double-float & friends.
; -------------- 4.0b2
; 09/17/96 bill  with-dereferenced-handle is a copy of with-pointer except
;                it calls %dereference-handle instead of %thing-pointer
; 09/07/96 gb    restore int>0-p in DOTIMES, uncomment SEQ-DISPATCH.
; 08/27/96 bill  with-foreign-window
; -------------- 4.0b1
; akh %i- takes > 2 args
; 04/07/96 gb    a bunch of #+ppc-target eval-redef's.
; 04/03/96 bill  pfe.without-interrupts. Parse :without-interrupts argument in
;                defpascal-68k gets without-interrupts as the 4th value from defpascal-code
;                instead of by looking for a without-interrupts form.
;                PPC version of defpascal-code to prevent the compiler warning.
;                defpascal-ppc parses the :without-interrupts argument keyword and
;                passes the value in the generated call to define-ppc-pascal-function.
; 03/29/96 slh   a bit more tweaking to make-proc-info, defpascal-ppc, defccallable
; 03/29/96 bill  defccallable passes env arg to defpascal-ppc
;                slh's fixes to defpascal-ppc & make-proc-info
; 03/27/96 bill  defpascal & ppc-defpascal pass environment arg to defpascal-ppc.
;                defpascal-ppc does parse-body to properly relocate the declarations,
;                and passes the doc-string on to define-ppc-pascal-function.
; 01/05/96 gb    gz's init file now ANSI CL (lambda macro.)
; 12/27/95 gb    %typed-misc{ref,set} spelling.
; 12/13/95 gb    progv rides again
; 12/05/95 slh   update trap names
; 11/16/95 bill  bitsetf & bitclrf
; 11/15/95 bill  defpascal expands into target-specific code: defpascal-68k, defpascal-ppc
; 11/14/95 bill  warn about %currenta5 on the PPC.
; 11/14/95 gb    tweak to fix of %clear-block.
; 11/03/95 bill  def-accessor-macros, like def-accesors but generates no constants
; 10/26/95 slh   %gvector -> %istruct, vector
;  5/12/95 slh   handler-case: allow "shorthand" syntax for :no-error clause
;  5/05/95 slh   defclass: check for duplicate default initargs
;  4/26/95 slh   new ok-wptr; with-font-codes uses it
;                with-lock-grabbed: current-process -> *current-process*
;  3/30/95 slh   merge in base-app changes
;--------------  3.0d18
; 2/17/95 slh   *pascal-full-longs* & defpascal-code changes for full 32-bit longs
; 1/25/95 slh   comments indicate what to change for full defpascal longwords
;-------------  3.0d16
; defun cerrors if redefining a generic function. Ancient bug.
;--------------
;12/01/93 bill  method qualifiers can now be any non-nil atom, as specified in CLtL2.
;09/16/93 bill  zone-pointer-p no longer bombs on address 2 or 0
;09/16/93 bill  dovector propogates the type of its vector arg to the temp holding it.
;08/18/93 bill  with-clip-rect-intersect moves here from "ccl:examples;grapher".
;08/09/93 bill  defpackage much faster: uses hash tables instead of MEMBER.
;07/27/93 bill  defmethod no longer attempts to eval EQL specializers at compile time.
;-------------- 3.0d12
;06/14/93 alice with-pstr and with-cstr use byte-length
;06/02/93 alice defsetf for %scharcode
;05/17/93 bill  macptr<= & macptr-evenp move from here to l1-utils.lisp
;-------------- 3.0d8
;05/16/93 alice %code-char unsigned-byte 8 -> 16 %char-code base-character -> character
;------------ 2.1d7
;04/30/93 bill  fix compiler-let inside of defmethod: qualifiers are NOT evaluated.
;04/29/93 bill  current-process -> *current-process*
;04/28/93 bill  %eval-redef's for %get-fixnum & %hget-fixnum
;04/24/93 bill  with-background-process, with-non-background-process
;04/22/93 bill  with-standard-abort-processing now takes an abort-message arg
;-------------  2.1d5
;11/26/92 alice defmethod binds *nx-method-warning-name*  for compiler warnings
;03/18/93 bill  with-standard-abort-handling
;03/10/93 bill  zone-pointerp no longer conses. Nor does it attempt to read a long at an odd address
;01/08/92 bill  with-lock-grabbed, with-process-enqueued
;11/17/92 bill  defresource, using-resource
;11/20/92 gb    turn a lot of traditional open-coded functions into macros.  Cons-cell ordering
;               in defpascal lap.
;08/12/92 bill  defun does the right thing for inline functions when ENV is NIL.
;07/08/92 bill  defun uses nx-declared-inline-p instead of proclaimed-inline-p
;07/01/92 bill  parse-defmethod puts user declarations for #'call-next-method and
;               #'next-method-p in the right place.
;-------------- 2.0
;01/16/92 gb  allow declarations again in WITH-OPEN-FILE.
;01/11/91 alice %stack-iopb clears for good measure
;12/23/91 bill  arglist-string for a macro with no args is "()" vice "NIL".
;12/10/91 gb    %signal-error -> %err-disp; the occasional FIXNUM declaration.
;-------------- 2.0b4
;11/20/91 bill  GB's patch to DEFUN
;11/19/91 bill  defccallable really has syntax similar to defpascal this time.
;11/12/91 bill  in restart-bind - ,restarts -> ,@restarts
;11/05/91 gb   %svref, %svset are macros; declare magic method functions INLINE.
;10/29/91 bill  check-generic-function-lambda-list in parse-defgeneric
;10/24/91 bill  defccallable now has syntax similar to defpascal
;10/11/91 bill  defmacro needed to consider &optional in computing the
;               position of &body.
;10/21/91 alice with-open-file returns the right thing
;10/18/91 alice add def-ccl-pointers
;10/03/91 alice with-open-file cares whether it completed
;10/02/91 gb   make ZONE-POINTERP a little harder to fool.
;09/27/91 gb   expand MACROLET-ed macros in SETF.
;------------- 2.0b3
;08/04/91 bill parse-defgeneric - handle multiple declarations.
;08/31/91 gb   DEFPACKAGE passes package name as string.
;08/26/91 bill with-port does gworld stuff
;08/24/91 gb   Use new trap syntax.
;07/21/91 gb   more use of (eval-when (:compile-toplevel) ...) Eval-redef every open-coded function not elswhere
;              defined.  Allow multiple store-vars in SETF, use MULTIPLE-VALUE-BIND to bind them.
;06/22/91 bill defloadvar neglected to setq the variable at def-load-pointers time.
;06/17/91 bill %setport uses _SetPort vice modifying memory itself
;------------- 2.0b2
;06/03/91 bill change destructuring-bind's arglist so Fred will know how to
;              indent it.
;05/25/91 bill %eval-redef's for %put-xxx were defined in terms of %hput-xxx
;05/22/91 bill GB's fix to TYPECASE-AUX
;05/20/91 gb   CALL-NEXT-METHOD, NEXT-METHOD-P now defined via FLET; less magic.
;              Fix broken RESTART-BIND.  Use NORMALIZE-LAMBA-LIST, new arglist
;              scheme in DEFMACRO.  DEFLOADVAR (barely worth it).  Stop pretending
;              that WITH-INVISIBLE-REFERENCES works.  DOTIMES no longer assumes
;              fixnum arithmetic - (DECLARE (FIXNUM I)) advised.  EVAL-REDEF more
;              stuff.
;04/15/91 bill #.$v_istruct in %cons-restart so that the symbol isn't necessary in the distributed lisp
;04/29/91 bill remove cff-call - it didn't preserve order of evaluation
;04/09/91 bill DEFCLASS specializers can be objects as well as names.
;04/04/91 bill add start and end args to with-cstr so it parallels with-pstr
;              cff-call (C Foreign-Function Call)
;04/03/91 bill generic-function, anonymous-method
;              defclass supports the :metaclass class option.
;03/22/91 bill @, -> ,@ in handler-case
;03/12/91 bill DEFMACRO handles &whole, &environment, &optional relative to &body position
;03/06/91 bill The top-level of the real define-method-combination.
;02/20/91 bill type-check method-qualifiers in defmethod
;02/12/91 bill with-pointers scoping bug
;02/08/91 bill %cons-restart moves here from lispequ.
;03/04/91 alice some report-bad-arg => program-error
;------------- 2.0b1
;02/06/91 bill in do-symbols: pkg.shadowed -> #.pkg-shadowed
;              in with-package-iterator (pkg-iter.state x) -> (%svref x #.pkg-iter.state)
;              %cons-pkg-iter moves here from lispequ
;01/31/91 bill with-package-iterator
;01/18/91 bill reverse order of args for a :writer in defclass.  standard-slot-setf-method => standard-writer-method
;01/15/91 gb   What the hell - do [C,E]TYPECASE here as well.
;01/14/91 gb   hair up case-aux so CCASE and ECASE can live normal lives.
;01/09/91 gb   stack-cons the horrible multiple-value-list in multiple-value-bind.
;              bogus DEFINE-METHOD-COMBINATION.
;01/08/91 bill require-trap in macros that use #_xxx
;01/07/91 bill DEFCLASS generates toplevel DEFMETHOD's
;              Use new traps package in macro expansions
;12/31/90 bill defpascal looks for without-interrupts wrapped around the body.
;              defccallable passes without-interrupts through to defpascal.
;12/31/90 gb   nail down DEFCLASS to make disk space.  A few missing %eval-redefs.
;12/12/90 bill record-accessor-methods in expansion of defclass.
;11/28/90 gb   I will not rely on Steele being accurate.  I will not rely on Steele being accurate.
;              with-hash-table-iterator.
;11/19/90 bill GB's patch for pascal-regcode-code
;11/09/90 bill add :documentation slot-option to defclass (ignored for now)
;10/24/90 gb   %unbound-marker-8 expands into $unbound.
;10/12/90 bill type-check slot-name's in defclass.
;10/11/90 akh  defparameter second time save doc string
;09/24/90 bill DEFMACRO's &BODY code handles dotted arglist correctly.
;09/21/90 bill add-accessor-types in def-accessors.
;10/16/90 gb   stack-cons restarts.
;09/26/90 gb   invert pushes in handler-case per gz.
;09/13/90 bill use  make-symbol vice gensym in defclass.
;09/06/90 bill ansi-loop
;09/05/90 bill add :method-class to defmethod
;08/24/90 bill defmacro passes the position of &body to %macro for *fred-special-indent-alist*
;08/23/90 joe  moved bunch of pointer stuff (zone-pointer-p, pointer-size, wptr-to-procid,
;              etc from defrecord. Added %clear-pointer which clears a pointer and
;              %clear-block which clears a block of memory of a given size.
;08/08/90 gb    defpackage errors out on duplicates.  Defpascal-code doesn't try to
;               nreverse &rest args in local macros.
;07/18/90 alice put missing comma in WITH-SIMPLE-RESTART
;07/13/90 gb   hoist-special-decls: suitable for splicing.
;07/05/90 akh  remove print stuff from defvar and defparameter
;07/04/90 bill add :argument-precedence-order to defgeneric
;06/22/90 bill def-aux-init-functions
;06/21/90 gb   complain about quoted args to IN-PACKAGE, but unquote them.
;06/20/90 gb   *compile-print* format strings for DEFVAR, DEFPARAMETER were bogus.
;06/20/90 bill bitset & bitclr
;06/19/90 bill add optional start & end args to with-returned-pstr
; ----- 2.0a1
;06/13/90 bill add note-function-info to defgeneric.
;06/10/90 gb   :USE effectively defaults to *make-package-use-defaults* in DEFPACKAGE.
;06/08/90 gb   print-unreadable-object: keyword name is :identity, not :id.
;06/06/90 bill include doc string in parse-macro-1 expansion per GZ
;06/01/90 bill defgeneric
;06/02/90 gb   with-compilation-unit.
;05/28/90 gb   Flush %immediate accessors, vector accessors defined on them.
;05/21/90 bill Remove doubled body in UNTIL macro.
;05/16/90 gb   type-predicates off of plists, onto an alist.  WITH-STANDARD-IO-SYNTAX.
;05/14/90 gb   them thar IN-PACKAGE and DEFPACKAGE macros.
;05/05/90 gb   locally a special form now.
;05/04/90 gb   defmethod notes function info at compile-time.
;5/3/90  gz    Fix %incf-ptr. Add specialv, remove defobject.
;04/30/90 gb   condition-restarts, define-condition, hairier restart-case, def-kernel-restart,
;              test at loop bottom in while, until, do, do*.  PARSE-MACRO.  Try to make
;              incidental references to loop counters, etc., invisible in dotimes.  Worked for
;              a while, may work again.
;04/11/90 bill add start & end arg to with-pstr
;02/28/90 bill %slot-missing-marker
;02/26/90 bill Wrap without-interrupts around with-port expansion ($sp-saveport does this, too).
;01/17/90  gz  Added with-restart.
;01/05/90  gz  Don't macroexpand into %currenta5.
;12/31/89 gb   newfangled macro-parsing stuff.
;12/25/89 gb   nest a tagbody in do-loop. NTH-VALUE macro.
;12/28/89  gz  defclass-generated setf methods have new value as first arg.
;              SETF macro ignores local functions, defaults to calling #'(setf foo), as per
;              x3j13.  *>>>* This is an incompatible change *<<<* but is needed to
;              make CLOS stuff like what's below work really right.
;29-Nov-89 Mly Make compiling
;              (defclass foo () ((bar :accessor foo-bar)))
;              (setf (foo-bar baz) 'foo)
;              SORT-OF-work.
;              CCL has absolutely NO (NONE, ZERO) model of a compile-time environment.
;12/08/89 bill ignoring-without-interrupts, store-generic-setf-function was brain-damaged.
;11/18/89 gz  Don't use plists for setf stuff.
;             init-list-default here from l1-utils.
;              %structure-refs% hash-table.
;11/10/89 gz  qlfun here from l1-utils. Don't use %izerop in macros. [(eql 0 x) transforms to it].
;10/28/89 gz  (macro -> (defmacro.  Added do-present-symbols.
;11/06/89 gb do,do*,loop : gratuitous mods.
;10/03/89 gz lambda-bind, pascal-true, pascal-false, with-interrupt-level,
;             with-clip-rect, with-new-full-port, with-font-codes, from l1-macros.
;09/30/89 bill Remove def-print-exception: new printer does not use.
;09/27/89 gb simple-string -> ensure-simple-string.  Parse-macro.
;              progv not a macro.  Remove push, pop, pushnew
;              (who can compile anything with "just level-2" loaded ?)
;              remove some (most, all) object-lisp macros.
;09/16/89 bill Remove the last vestiges of object-lisp windows
;              object-lisp itself still exists.
;09/08/89 bill Remove function-binding from store-generic-setf-function
;              Make defclass return the class object
;08/21/89  gz  with-cstr, tweak with-pstr
;07/28/89 Bill "Dialog" => "Dialog-Object"
;07/28/89  gz Support :default-initargs in defclass.
;7/5/89  bill Klugey addition of (defmethod (setf x) ...)
;5/8/89    gz use coerce, debind.
;6-apr-89  as ask-named-item
;23-mar-89 as dovector
;04/07/89 gb  $sp8 -> $sp.
;04/01/89  gz New defpascal syntax, implementation.
;03/24/89  gb Still in March of 89: archived spice macro, destructuring code to
;             lib;spicemacros.lisp.
;16-apr-89 as new CASE uses eq instead of memq
;14-apr-89 as defmacro does a record-arglist
; 03/02/89 gz defmethod, defclass macros.  setf-inverse for %car, %cdr, find-class.
;             queue-fixup, type-specifier.
;             Macroexpand form in setf to avoid useless bindings.
;             Moved get-setf-method back to setf.lisp, no longer used here.
; 01/09/89 gz handler/restart-case/bind, with-simple-restart.
; 12/30/88 gz flushed with-mark
; 12/28/88 gz %structure-ref's may be non-fixnum
; 12/26/88 gz flushed %hiword, %loword, %schar.
; 12/02/88 gz made with-pstr allow decls.
; 11/25/88 gz added def-load-pointers.  Moved eq, eql to l1-utils.
; 11/16/88 gz added def-accessors.  Flushed %get/put-full-long macros.
; 11/15/88 gz Different %[v]stack-block defs. eval-redef for %new-ptr.
;             Removed remaining &key* support.
; 11/09/88 gb &whole comes first in psetq macro and in analyze1.  Don't do
;             destructuring of &body into body, decls, doc; do this ourselves
;             in macros in this file.  Stop supporting &key*. %immediate-inc-ptr,
;             %inc-ptr eval-redeffed as functions.
; 11/03/88 gb define multiple-value-setq in terms of multiple-value-bind.
; 10/29/88 gb eval-redef length, list-length.
; 9/19/88 gb lispequ is compile-time-only now.
; 9/2/88  gz No more list-reverse. Real def for with-macptrs
; 8/25/88 gz %bin-size -> %vect-byte-size, %bin-subtype -> %vect-subtype,
;            punted %bin-address. setf looks at *compile-time-structure-refs*.
;            %get/put-full-long, formerly in l1-files.  pathname structure
;            accessors. %stack-iopb.
;8/21/88 gz  %ndefvar -> %defvar
;8/13/88 gb  %pl-search -> pl-search.
;8/10/88 gz  setf-inverses for aref, svref, %svref, char, schar, symbol-value,
;	     symbol-plist, fill-pointer.  Moved some constants to lispequ.
;	     eval defs for memq, assq, eql.
;8/7/88  gz  provide at end.
;8/4/88  gz  Made defconstant typecheck the sym.
;8/3/88  gz  Less skeletal pushnew.
;8/4/88  gb  %bin-subtype doesn't %ilogand with t.
;7/28/88 gz  Added skeletal pushnew.
;7/27/88 gz  Moved the string-matching functions to l1-files.

;5/17/88 jaj added optional wild-char to %str*=
;5/13/88 jaj added ignore-if-unused for gensyms in parse-defmacro

;6/24/88 gb   %stack-block now a macro.
;5/20/88 gb   make defvar, defparameter use %ndefvar to bootstrap.
;4/22/88 gb   dotimes, dolist test at bottom.
;4/02/88  gz  New macptr scheme. Removed %ind, nremove-from-alist, %rassoc.
;             report-bad-arg can take more than one arg.
;3/29/88  gz  Added %unbound-marker, %currenta5. Flushed pre-1.0 edit history.
;2/24/88  gz  added %svref, %svset
;2/16/88 jaj removed with-pstr calls length instead of %pstr-len
;2/13/88 gb   different or; return multiple values from last form.
;             different psetq; don't require nbutlast to macroexpand.
;             require alltraps at compile time; declare *processing-setf* special.
;2/8/88  jaj  new psetq
;1/28/88 jaj fix to defmacro for dotted arglists, new or
;1/26/88 cfry fixed dotimes & dolist to error check its first arg. dotimes is
;        in 2 places
;        fixed case-aux to check for > 1 T or OTHERWISE clause.
;        fixed defconstant, defparameter, defvar to check its 3rd arg.
;        fixed analyze1 for defmacr destructured lambda-list with &optional
;             default value. bug from isi tests
; 1/6/88 cfry conditionalized analyze-key to work with defsetf 
; 12/22/87 gz  added defccallable.  Made defpascal accept :reg!!!
; 11/20/87 gz  added %word-to-int
; 10/13/87 gb  Moral equivalent of (defsetf ccl::%uvref ccl::%uvset).
; 8/21/87  gz  Made with-dereferenced-handle not expand into trap macros, so it
;              can be used without alltraps.

(in-package :ccl)

(eval-when (eval compile)
  (require "LEVEL-2")
  (require "BACKQUOTE")
  (require "DEFSTRUCT-MACROS"))



(eval-when (eval compile)
  (require "LISPEQU"))








; This incredibly essential thing is part of ANSI CL; put it in the
; right package someday.
; Like maybe when it says something about doc strings, or otherwise
; becomes useful.

(defun parse-macro (name arglist body &optional env)
  (values (parse-macro-1 name arglist body env)))

; Return a list containing a special declaration for SYM
; if SYM is declared special in decls.
; This is so we can be pedantic about binding &WHOLE/&ENVIRONMENT args
; that have been scarfed out of a macro-like lambda list.
; The returned value is supposed to be suitable for splicing ...
(defun hoist-special-decls (sym decls)
  (when sym
    (dolist (decl decls)
      (dolist (spec (cdr decl))
        (when (eq (car spec) 'special)
          (dolist (s (%cdr spec))
            (when (eq s sym)
              (return-from hoist-special-decls `((declare (special ,sym)))))))))))

(defun parse-macro-1 (name arglist body &optional env)
  (unless (verify-lambda-list arglist t t t)
    (error "Invalid lambda list ~s" arglist))
  (multiple-value-bind (lambda-list whole environment)
                       (normalize-lambda-list arglist t t)
    (multiple-value-bind (body local-decs doc)
                         (parse-body body env t)
      (unless whole (setq whole (gensym)))
      (unless environment (setq environment (gensym)))
      (values
       `(lambda (,whole ,environment)
          (declare (ignore-if-unused ,environment))
          ,@(hoist-special-decls whole local-decs)
          ,@(hoist-special-decls environment local-decs)
          (macro-bind ,lambda-list ,whole
                      ,@local-decs 
                      (block ,name ,@body)))
       doc))))









(defun apply-to-htab-syms (function pkg-vector)
  (let* ((sym nil)
         (foundp nil))
    (dotimes (i (uvsize pkg-vector))
      (declare (fixnum i))
      (multiple-value-setq (sym foundp) (%htab-symbol pkg-vector i))
      (when foundp (funcall function sym)))))

(defun iterate-over-external-symbols (pkg-spec function)
  (apply-to-htab-syms function (car (pkg.etab (pkg-arg (or pkg-spec *package*))))))

(defun iterate-over-present-symbols (pkg-spec function)
  (let ((pkg (pkg-arg (or pkg-spec *package*))))
    (apply-to-htab-syms function (car (pkg.etab pkg)))
    (apply-to-htab-syms function (car (pkg.itab pkg)))))

(defun iterate-over-accessable-symbols (pkg-spec function)
  (let* ((pkg (pkg-arg (or pkg-spec *package*)))
         (used (pkg.used pkg))
         (shadowed (pkg.shadowed pkg)))
    (iterate-over-present-symbols pkg function)
    (when used
      (if shadowed
        (flet ((ignore-shadowed-conflicts (var)
                 (unless (%name-present-in-package-p (symbol-name var) pkg)
                   (funcall function var))))
          (declare (dynamic-extent #'ignore-shadowed-conflicts))
          (dolist (u used) (iterate-over-external-symbols u #'ignore-shadowed-conflicts)))
        (dolist (u used) (iterate-over-external-symbols u function))))))

(defun iterate-over-all-symbols (function)
  (dolist (pkg %all-packages%)
    (iterate-over-present-symbols pkg function)))          


;Eval definitions for things open-coded by the compiler.
;Don't use DEFUN since it should be illegal to DEFUN compiler special forms...
;Of course, these aren't special forms.
(macrolet ((%eval-redef (name vars &rest body)
             (when (null body) (setq body `((,name ,@vars))))
             `(setf (symbol-function ',name)
                    (qlfun ,name ,vars ,@body))))
  (%eval-redef %ilsl (n x))
  (%eval-redef %ilsr (n x))
  (%eval-redef neq (x y))
  (%eval-redef not (x))
  (%eval-redef null (x))
  (%eval-redef rplaca (x y))
  (%eval-redef rplacd (x y))
  (%eval-redef set-car (x y))
  (%eval-redef set-cdr (x y))
  (%eval-redef int>0-p (x))
  (%eval-redef %get-byte (ptr &optional (offset 0)) (%get-byte ptr offset))
  (%eval-redef %get-word (ptr &optional (offset 0)) (%get-word ptr offset))
  (%eval-redef %get-signed-byte (ptr &optional (offset 0)) (%get-signed-byte ptr offset))
  (%eval-redef %get-signed-word (ptr &optional (offset 0)) (%get-signed-word ptr offset))
  (%eval-redef %get-long (ptr &optional (offset 0)) (%get-long ptr offset))
  (%eval-redef %get-fixnum (ptr &optional (offset 0)) (%get-fixnum ptr offset))
  (%eval-redef %get-point (ptr &optional (offset 0)) (%get-point ptr offset))
  (%eval-redef %get-signed-long (ptr &optional (offset 0)) (%get-signed-long ptr offset))
  (%eval-redef %get-unsigned-long (ptr &optional (offset 0)) (%get-unsigned-long ptr offset))
  (%eval-redef %get-ptr (ptr &optional (offset 0)) (%get-ptr ptr offset))
  (%eval-redef %put-byte (ptr val &optional (offset 0)) (%put-byte ptr val offset))
  (%eval-redef %put-word (ptr val &optional (offset 0)) (%put-word ptr val offset))
  (%eval-redef %put-long (ptr val &optional (offset 0)) (%put-long ptr val offset))
  (%eval-redef %put-point (ptr val &optional (offset 0)) (%put-point ptr val offset))
  (%eval-redef %put-ptr (ptr val &optional (offset 0)) (%put-ptr ptr val offset))
  (%eval-redef %get-full-long (ptr &optional (offset 0)) (%get-full-long ptr offset))
  (%eval-redef %put-full-long (ptr val &optional (offset 0)) (%put-full-long ptr val offset))
  (%eval-redef %int-to-ptr (int))
  (%eval-redef %ptr-to-int (ptr))
  (%eval-redef %ptr-eql (ptr1 ptr2))
  (%eval-redef %setf-macptr (ptr1 ptr2))
  (%eval-redef %null-ptr-p (ptr))


  (%eval-redef %newgotag ())
  (%eval-redef %iasr (x y))

  
  (%eval-redef %set-byte (p o &optional (new (prog1 o (setq o 0))))
               (%set-byte p o new))
  (%eval-redef %set-word (p o &optional (new (prog1 o (setq o 0))))
               (%set-word p o new))
  (%eval-redef %set-long (p o &optional (new (prog1 o (setq o 0))))
               (%set-long p o new))
  (%eval-redef %set-ptr (p o &optional (new (prog1 o (setq o 0))))
               (%set-ptr p o new))

  
  (%eval-redef %word-to-int (word))
  (%eval-redef %inc-ptr (ptr &optional (by 1)) (%inc-ptr ptr by))
  
  (%eval-redef char-code (x))
  (%eval-redef code-char (x))
  (%eval-redef 1- (n))
  (%eval-redef 1+ (n))

  (%eval-redef uvref (x y))
  (%eval-redef uvset (x y z))
  (%eval-redef uvsize (x))

  (%eval-redef svref (x y))
  (%eval-redef svset (x y z))
  
 
  (%eval-redef integer-point-h (x))
  (%eval-redef integer-point-v (x))
  
  (%eval-redef car (x))
  (%eval-redef cdr (x))
  (%eval-redef cons (x y))
  (%eval-redef endp (x))

  (progn
    (%eval-redef %typed-miscref (s a i))
    (%eval-redef %typed-miscset (s a i v))
    (%eval-redef typecode (x))
    (%eval-redef lisptag (x))
    (%eval-redef fulltag (x))
    (%eval-redef %unbound-marker ())
    (%eval-redef %illegal-marker ())
    (%eval-redef %alloc-misc (x y))
    (%eval-redef %typed-misc-ref (x y z))
    (%eval-redef %typed-misc-set (w x y z))
    (%eval-redef %setf-double-float (x y))
    (%eval-redef %lisp-word-ref (x y))
    (%eval-redef %temp-cons (x y))
    (%eval-redef require-fixnum (x))
    (%eval-redef require-symbol (x))
    (%eval-redef require-list (x))
    (%eval-redef require-real (x))
    (%eval-redef require-simple-string (x))
    (%eval-redef require-simple-vector (x))
    (%eval-redef require-character (x))
    (%eval-redef require-number (x))
    (%eval-redef require-integer (x))
    )
  
  (%eval-redef listp (x))
               
)

; In the spirit of eval-redef ...


;; pointer hacking stuff (moved from defrecord)
;
;

; these defvars put here (didn't have a better place?)
(defvar *record-types* nil)
(defvar %record-descriptors% (make-hash-table :test #'eq))


; expands into compiler stuff

(setf (symbol-function '%get-unsigned-byte) (symbol-function '%get-byte))
(setf (symbol-function '%get-unsigned-word) (symbol-function '%get-word))
(setf (symbol-function '%get-signed-long) (symbol-function '%get-long))



(defun %clear-pointer (pointer &aux pointer-size)
  (when (and (setq pointer-size (pointer-size pointer))
             (plusp pointer-size))
    (%clear-block pointer pointer-size)))


#+ppc-target
(defppclapfunction %clear-block ((pointer arg_y) (length arg_z))
  (unbox-fixnum imm0 length)
  (cmpwi cr0 imm0 0)  ; or unbox-fixnum. above  (this was missing its last operand.)
  (macptr-ptr imm1 pointer)
  (add imm1 imm1 imm0) ; point past last byte
  (beq @done)
  @loop  
  (cmpwi cr0 imm0 1)                    ; set cr0_eq if last time through
  (stbu rzero -1 imm1)
  (subi imm0 imm0 1)
  (bne @loop)
  @done
  (mr arg_z pointer)
  (blr))

#+sparc-target
(defsparclapfunction %clear-block ((pointer %arg_y) (length %arg_z))
  (unbox-fixnum length %imm0)
  (tst %imm0)
  (macptr-ptr pointer %imm1)
  (be @done)
    (add %imm1 %imm0 %imm1) ; point past last byte

  @loop
  (deccc %imm0)
  (dec %imm1)
  (bne @loop)
   (stb %rzero (%imm1))
  @done
  (retl)
  (mov pointer %arg_z))



; end of moved stuff









(provide 'level-2)

	


;; end of level-2.lisp

#|
	Change History (most recent last):
	2	12/29/94	akh	merge with d13
|# ;(do not edit past this line!!)
