;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  2 3/18/97  akh  fix room for 68K
;;  9 7/18/96  akh  dont remember
;;  2 10/17/95 akh  merge patches
;;  3 4/26/95  akh  dont remember
;;  3 3/2/95   akh  open-doc-string-file says element-type 'base-character
;;  (do not edit before this line!!)

; Copyright 1986-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc. The 'tool rules!

; Modification History
;
;10/04/96 slh   set-function-info back here
;10/03/96 slh   set-function-info -> l1;utils.lisp, for early inlines
;05/29/96 bill  buffer-current-symbol tries to do something reasanable if readtable-case is :preserve
;-------------  MCL-PPC 3.9
;03/29/96 bill  #+ppc-taret => #+ppc-target before purge-functions def
;03/26/96  gb   lowmem accessors.
;02/29/96 bill  PPC purge-functions stub for backward compatibility.
;02/27/96 bill  post-egc-hook-enabled-p and set-post-egc-hook-enabled-p
;11/30/95 slh   no purge-functions for PPC
; 6/06/95 slh   Bill's fix: pathname-to-window works if there is an alias in the pathname
; 4/06/95 slh   broke out doc-window.lisp
; 3/07/95 slh   ignore-errors in get-help-file-entry (help file may be corrupted)
;-------------- 3.0d17
;    ?          begin-doc-output fresh-line vs unconditional newline
;               nuke edit-anything-result-pos in begin-doc-output
;06/14/94 bill  report-time accounts for consing a bignum to sample initial-consed
;-------------- 3.0d13
;05/06/93 bill  add-gc-hook, remove-gc-hook
;-------------- 3.0d8
;01/28/93 alice added documentation-p
;11/19/92 alice changed doc stuff to take optional where arg
;12/30/92 bill show-documentation now shows DEFCLASS documentation
;12/14/92 bill some "~:D"'s in ROOM & REPORT-TIME.
;11/20/92 gb   some changes to ROOM (still need to report "stack usage" more intelligently or not at all.)
;09/07/92 bill show-documentation window now shows arglists for symbols not in the help file.
;07/31/92 bill machine-owner
;05/28/92 bill get-help-file-entry uses accessing-index-stream
;-------------  2.0
;03/10/92 bill  show-documentation now displays documentation for generic functions
;               with DEFGENERIC-supplied doc strings.
;------------- 2.0f3
;02/22/92 (bill from "post 2.0f2c5:trap-doc-patch")
;              Make c-x c-d work properly for trap definitions by fixing SHOW-TRAP-DOCUMENTATION.
;------------- 2.0f2c5
;12/24/91 gb   don't allow &LAP, etc. to inline in SET-FUNCTION-INFO.
;------------- 2.0b4
;11/20/91 bill (gb) set-function-info
;11/18/91 bill Fix bug in documentation of a macro or special form with no doc string
;11/15/91 gb   experiment with paying attention.
;11/05/91 gb   experiment with INLINE.
;10/29/91 alice def-load-pointers => def-ccl-pointers
;09/18/91 bill teach show-trap-documentation about simple traps
;08/24/91 gb   use new trap syntax.
;08/20/91 bill return $cons-area.total as third value from %cons-area-sizes
;08/07/91 bill documentation is a generic function.
;07/10/91 bill cons-area-sizes accepts :static
;07/21/91 gb   fix total-bytes-allocated.  Change TIME/REPORT-TIME to pass body as closure.
;              no buckets in hash-tables anymore.
;06/10/91 bill cons-area-sizes
;------------- 2.0b2
;05/29/91 bill only query for help-file if user explicitly says (documentation ...) or c-x c-d
;05/29/91 gb   New cons-area equates; call (GCTIME) in time macro.
;05/23/91 bill optional args to open-doc-string-file, get-doc-string-file, get-help-file-entry disable
;              user-interaction.  ignore-errors in maybe-load-help-map
;05/21/91 bill don't return null strings from MACHINE-INSTANCE
;05/20/91 gb   MACHINE-INSTANCE looks at name of mac before looking at name of user.
;              ROOM, etc. know about new heap layout.
;04/25/91 bill open-doc-string-stream checks for reindexing, then opens file for input (vice io)
;04/09/91 bill in open-doc-string-file - if open for :io fails, try :input
;04/04/91 bill keep *doc-string-stream* open
;04/04/91 bill maybe-load-help-map for use at startup.
;03/04/01 alice report-bad-arg gets 2 args
;02/07/91 alice ccl: => ccl;
;--------------- 2.0b1
;02/04/91 joe  show-trap-documentation
;01/28/91 bill prevent consing in get-help-file-entry when *fast-help* is not a hash table.
;              Also, open help file with :direction :io so that reindexing can happen.
;01/14/91 gb   use time-manager frobs in TIME, REPORT-TIME.
;01/09/91 bill "MACL Help" -> "MCL Help", "helpmap.fasl" -> "MCL Help Map.fasl"
;01/01/90 gb   mess with ROOM and TIME.
;12/13/90 bill documentation looks in the new help file.
;11/30/90 bill comment out old-describe.  New show-documentation mechanism
;09/14/90 bill describe -> old-describe: will disappear later.
;09/09/90 gb  stop using fixnum arithmetic in ROOM.
;08/23/90 bill fred-start-mark -> fred-display-start-mark
;08/17/90 akh revert def of ED so meta-. will work
;08/13/90 alms ED doesn't check pathname-to-window (it calls FRED, which checks)
;07/23/90 bill machine-instance looks up chooser name (doesn't work in System 7)
;07/13/90 gb  New ROOM.  You were warned.
;06/21/90 bill fred takes an optional new-window arg in ed.
;06/12/90 bill window-buffer -> fred-buffer, window-start-mark -> fred-start-mark
;06/04/90 bill in choose-**-dialog: :default -> :directory.
;05/30/90 gb make the world safe for democracy.
;05/24/90 bill window-position & window-size -> view-position & view-size
;5/4/90   gz Use built-in-type-p in %deftype.
;04/30/90 gb report run-time as well as real-time in TIME.
;01/05/89 gz Don't macroexpand into %currenta5.
;12/30/89 gb deftype uses newfangled macro-bind; deftype-arglist defaults &optionals to
;            * vice **.
;12/28/89 gz Allow function name lists in ED.  function specs, deftype.
;11/18/89 gz no more %doc-type-alist, all doc in hash table.
;            set-documentation clears documentation if last arg is nil.
;            sd-superclasses now include self.
;09/27/89 gb simple-string -> ensure-simple-string.
;09/11/89 bill Remove function-binding from copy-symbol
;09/11/89 gz {software,machine}-{type,version} from level-1.
;08/24/89 gb room, again.
;03/25/89 gz purge-functions from level-1.
;03/18/89 gz window-foo -> window-object-foo.
;02/28/89 gz %freepages from kernel.
;02/09/89 gb another room.
;12/30/88 gz New buffers.
;12/28/88 gz get-properties, gentemp, copy-symbol from l1-utils.
;12/11/88 gz mark-position -> buffer-position
;11/16/88 gz new fred windows
;            Changed DOCUMENTATION to return setf'ed string if there is one,
;            even if a system doc string exists.
;            Recompute *documentation-font-spec* when loading.
;            Changed *doc-output* stuff to maintain instance/class distinction.
;            Use hash tables.
;10/29/88 gb proclaimed *doc-output* special.
; 10/15/88 gb symbolic names in TIME macro.
; 9/14/88 gb  room rides again.
; 8/26/88 gz  no more sd-documentation.
; 6/28/88 jaj set-documentation returns string that was passed
; 6/27/88 jaj show documentation checks for symbol
; 6/23/88 as  fixed init-doc-string-file message, use geneva 10
;             instead of times 12 for *documentation-font-spec*
; 6/22/88 jaj removed %doc-file-refnum, close-doc-string-file
; 6/21/88 jaj fixed describe-symbol for uninterned symbols
; 6/10/88 as  handle-string -> handle-to-string
;             call buffer-set-style without length arg
; 6/9/88  as  documentation strings revamped
; 6/9/88  jaj moved defvar of %doc-string-file to l1-inits.lisp, set
;             %doc-file-refnum added close-doc-string-file
; 5/29/88 as  documentation returns a string (and other values)
; 5/25/88 jaj :pathname -> :directory in init-doc-string-file
; 5/24/88 jaj lisp heap size subtracted out of mac heap statistics in room
; 5/20/88 as doc-string stuff brought in from Pearl

; 4/11/88 gz new macptr scheme.
; 8/4/87  gz fix in room.
; 8/1/87  cfry FIXED (ed) . Also ED always returns the WINDOW or NIL
; 7/31/87 gz describe doesn't try to handle objects for now.
;            Checks for hash-table before structurep.  Fix in describe-symbol.
; 7/30/87 gb structure doc goes on plist, any symbol can have structure doc.
; 7/23/87 gz moved machine-instance, etc. to sysutils.
; 7/23/87 cfry fixed ED to accept mac-pathnames
; 7/15/87 gz Mods for new structures, fewer page types
; 7/7/87  gz try to print more stuff slashified in describe (prin1 vs. %print).
;            More informative verbose ROOM output.
;            Print gctime in TIME, not go thru EVAL.
; 6/25/87 gz removed (add-feature 'coral) and (add-feature 'logical-pathnames).
; 6/24/87 cfry describe changed call to no longer existant %pr-thing
; 6/20/87 gb time-aux returns multiple values.  Moved char, set-char to l1-utils.
; 6/08/87 gz fix in describe-symbol
; 5/27/87 gz added misc. string fns formerly in strings.lisp
; 5 19 87 cfry extended ED to edit buffer if it exists, and also to
;              do edit-definition as per CLtL.
; 4/18/87 cfry cleaned up ROOM's message
;4/14/87  gz  removed rm: symbols.
;87 04 08 am  removed identity.
;87 03 24 gb  print-plist terpri's to stream
;87 03 03 am  took out the rm: calls and added #'get-internal-run-time
;87 01 24 gz  lisp:xxx -> xxx, %put -> put, %member -> memq
;             DESCRIBE needs to be redone for Lisp-7 but I didn't bother.
;87 01 21 am took out the CL time functions.

(eval-when (eval compile)
  (require 'defstruct-macros))

(defun short-site-name  () (or *short-site-name* "unspecified"))
(defun long-site-name   () (or *long-site-name* "unspecified"))

(defun machine-instance ()
  "fix machine-instance")





(defun machine-type ()
  #+ppc-target
  "POWERPC"
  #+sparc-target
  "SPARC")



(defun machine-version () "Unknown")

(defun software-type ()
  (software-version))

(defun software-version ())

(defvar %doc-res-ids nil)

(defvar %documentation
  (make-hash-table :weak t :size 100 :test 'eq :rehash-threshold .95))

(defmethod documentation ((symbol symbol) &optional (doc-type nil doc-type-p))
  "returns a string or nil"
  (unless doc-type-p
    (doc-type-supplied-p-wrong t))
  (or (cdr (assoc doc-type (gethash symbol %documentation)))
      (let ((thing (case doc-type
                     (function (and (not (macro-function symbol))
                                    (not (special-form-p symbol))
                                    (fboundp symbol)))
                     (type (find-class symbol nil)))))
        (and thing (method-exists-p #'documentation thing) (documentation thing)))
))

; For compatibility
(defun set-documentation (symbol doc-type string)
  (if (or (symbolp symbol) (listp symbol))
    (setf (documentation symbol doc-type) string)
    (setf (documentation symbol) string)))

(defun set-function-info (symbol info)
  (let* ((doc-string (if (consp info) (car info) info)))
    (if (and *save-doc-strings* (stringp doc-string))
      (set-documentation symbol 'function doc-string)))
  (let* ((cons (assq symbol *nx-globally-inline*))
         (lambda-expression (if (consp info) (cdr info))))
    (if (and (proclaimed-inline-p symbol)
             (not (compiler-special-form-p symbol))
             (lambda-expression-p lambda-expression)
             (let* ((lambda-list (cadr lambda-expression)))
               (and (not (memq '&lap lambda-list))
                    (not (memq '&method lambda-list))
                    (not (memq '&lexpr lambda-list)))))
      (if cons 
        (%rplacd cons lambda-expression)
        (push (cons symbol lambda-expression) *nx-globally-inline*))
      (if cons (setq *nx-globally-inline* (delete cons *nx-globally-inline*)))))
  symbol)

(unless (standard-generic-function-p #'(setf documentation))
  (fmakunbound '(setf documentation)))

(defmethod (setf documentation) (string (symbol symbol) &optional (doc-type nil doc-type-p))
  (unless doc-type-p
    (doc-type-supplied-p-wrong t))
  (let* ((documentation (gethash symbol %documentation))
         (pair (assoc doc-type documentation)))
    (if pair 
      (if string
        (%rplacd pair string)
        (puthash symbol %documentation (delete pair documentation)))
      (when string
        (puthash symbol %documentation
                 (cons (cons doc-type string) documentation)))))
  string)

(defun doc-type-supplied-p-wrong (should-be-supplied)
  (error (if should-be-supplied "~s not supplied to ~s." "~s supplied to ~s.")
         'doc-type 'documentation))

(defun lookup-documentation (thing doc-type-p)
  (when doc-type-p (doc-type-supplied-p-wrong nil))
  (gethash thing %documentation))

(defun (setf lookup-documentation) (documentation thing doc-type-p)
  (when doc-type-p (doc-type-supplied-p-wrong nil))
  (setf (gethash thing %documentation) documentation))

(defmethod documentation ((method standard-method) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (lookup-documentation method doc-type-p))

(defmethod (setf documentation) (documentation (method standard-method) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (setf (lookup-documentation method doc-type-p) documentation))

(defmethod documentation ((generic-function standard-generic-function) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (lookup-documentation generic-function doc-type-p))

(defmethod (setf documentation) (documentation (generic-function standard-generic-function)
                                               &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (setf (lookup-documentation generic-function doc-type-p) documentation))

(defmethod documentation ((class standard-class) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (lookup-documentation class doc-type-p))

(defmethod (setf documentation) (documentation (class standard-class) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (setf (lookup-documentation class doc-type-p) documentation))

(defmethod documentation ((method-combination standard-method-combination) &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (lookup-documentation method-combination doc-type-p))

(defmethod (setf documentation) (documentation (method-combination standard-method-combination)
                                               &optional (doc-type nil doc-type-p))
  (declare (ignore doc-type))
  (setf (lookup-documentation method-combination doc-type-p) documentation))

; We have no slot-description objects yet.

(defmethod documentation ((list list) &optional doc-type)
  (fboundp list)                        ; check for legal function spec
  (documentation (setf-function-spec-name list) doc-type))

(defmethod (setf documentation) (documentation (list list) &optional doc-type)
  (fboundp list)                        ; check for legal function spec
  (setf (documentation (setf-function-spec-name list) doc-type) documentation))



#|
(setf (documentation 'car 'variable) "Preferred brand of automobile")
(documentation 'car 'variable)
(setf (documentation 'foo 'structure) "the structure is grand.")
(documentation 'foo 'structure)
(setf (documentation 'foo 'variable) "the metasyntactic remarker")
(documentation 'foo 'variable)
(setf (documentation 'foo 'obscure) "no one really knows what it means")
(documentation 'foo 'obscure)
(setf (documentation 'foo 'structure) "the structure is solid")
(documentation 'foo 'function)
|#



(defun report-time (form thunk)
  (flet ((integer-size-in-bytes (i)
           (if (typep i 'fixnum)
             0
             (* (logand (+ 2 (uvsize i)) (lognot 1)) 4))))         
    (let* ((initial-real-time (get-internal-real-time))
           (initial-run-time (get-internal-run-time))
           (initial-gc-time (gctime))
           (initial-consed (total-bytes-allocated))           
           (initial-overhead (integer-size-in-bytes initial-consed)))
    (multiple-value-prog1 (funcall thunk)
      (let* ((s *trace-output*)
             (new-consed (total-bytes-allocated))
             (bytes-consed (- new-consed (+ initial-overhead initial-consed)))
             (elapsed-real-time (- (get-internal-real-time) initial-real-time))
             (elapsed-run-time (- (get-internal-run-time) initial-run-time))
             (elapsed-gc-time (- (gctime) initial-gc-time))
             (elapsed-mf-time (- elapsed-real-time elapsed-run-time)))
        (format s "~&~S took ~:D milliseconds (~,3F seconds) to run."
                form elapsed-real-time (/ elapsed-real-time internal-time-units-per-second))
        (when (> elapsed-mf-time 0)
          (format s "~%Of that, ~:D milliseconds (~,3F seconds) were spent in The Cooperative Multitasking Experience."
                  elapsed-mf-time (/ elapsed-mf-time internal-time-units-per-second)))
        (unless (eql elapsed-gc-time 0)
          (format s "~%")
          (unless (> elapsed-mf-time 0)
            (format *trace-output* "Of that, "))
          (format s
                  "~:D milliseconds (~,3F seconds) was spent in GC."
                  elapsed-gc-time (/ elapsed-gc-time internal-time-units-per-second)))
        (unless (eql 0 bytes-consed)
          (format s "~% ~:D bytes of memory allocated." bytes-consed))
        (format s "~&"))))))

;(rm:heading 2 "Other Environment Inquiries")


; site names and machine-instance is in the init file.

(defun add-feature (symbol)
  "Not CL but should be."
  (if (symbolp symbol)
      (if (not (memq symbol *features*))
          (setq *features* (cons symbol *features*)))))

; (dotimes (i 5000) (declare (fixnum i)) (add-feature 'junk))



(defvar *function-specs* ())

(defun function-spec-p (spec)
  (or (symbolp spec)
      (and (consp spec)
           (symbolp (setq spec (%car spec)))
           (neq spec 'lambda)
           (getf *function-specs* spec))))

(defun function-spec-handler (spec)
  (or (function-spec-p spec)
      (error "~s isn't a valid function name." spec)))

(defmacro def-function-spec-handler (keyword arglist &body body)
  `(setf (getf *function-specs* ',keyword)
         (nfunction ,keyword (lambda ,arglist ,@body))))

;(def-function-spec-handler :property (spec &optional (def nil def-p))
;  (debind (keyword sym property) spec
;    (declare (ignore keyword))
;    (if def-p
;      (put sym property def)
;      (get sym property))))

;This is often handled directly in critical sections, so it's not enough
;to just change this definition...
(def-function-spec-handler setf (spec &optional (def nil def-p))
  (debind (keyword sym) spec
    (declare (ignore keyword))
    (if def-p
      (fset spec def)
      (fboundp (setf-function-name sym)))))

; ed is a CL fn so it must get loaded before tools, but it
; should be able to take advantage of tools if tools are loaded. - what tools?



; Misc string functions


(defun string-left-trim (char-bag string &aux end)
  "Given a set of characters (a list or string) and a string, returns
  a copy of the string with the characters in the set removed from the
  left end."
  (setq string (string string))
  (setq end (length string))
  (do ((index 0 (%i+ index 1)))
      ((or (eq index end) (not (find (aref string index) char-bag)))
       (subseq string index end))))

(defun string-right-trim (char-bag string &aux end)
  "Given a set of characters (a list or string) and a string, returns
  a copy of the string with the characters in the set removed from the
  right end."
  (setq string (string string))
  (setq end (length string))
  (do ((index (%i- end 1) (%i- index 1)))
      ((or (%i< index 0) (not (find (aref string index) char-bag)))
       (subseq string 0 (%i+ index 1)))))

(defun string-trim (char-bag string &aux end)
  "Given a set of characters (a list or string) and a string, returns a
  copy of the string with the characters in the set removed from both
  ends."
  (setq string (string string))
  (setq end (length string))
  (let ((left-end) (right-end))
     (do ((index 0 (%i+ index 1)))
	 ((or (eq index end) (not (find (aref string index) char-bag)))
	  (setq left-end index)))
     (do ((index (%i- end 1) (%i- index 1)))
	 ((or (%i< index left-end) (not (find (aref string index) char-bag)))
	  (setq right-end index)))
      (subseq string left-end (%i+ right-end 1))))

(defun get-properties (place indicator-list)
  "Like GETF, except that Indicator-List is a list of indicators which will
  be looked for in the property list stored in Place.  Three values are
  returned, see manual for details."
  (do ((plist place (cddr plist)))
      ((null plist) (values nil nil nil))
    (cond ((atom (cdr plist))
	   (error "~S is a malformed proprty list."
		  place))
	  ((memq (car plist) indicator-list) ;memq defined in kernel
	   (return (values (car plist) (cadr plist) plist))))))

(defun copy-symbol (symbol &optional (copy-props nil) &aux new-symbol def)
  "Make and return a new uninterned symbol with the same print name
  as SYMBOL.  If COPY-PROPS is null, the new symbol has no properties.
  Else, it has a copy of SYMBOL's property list."
  (setq new-symbol (make-symbol (symbol-name symbol)))
  (when copy-props
      (when (boundp symbol)
            (set new-symbol (symbol-value symbol)))
      (when (setq def (fboundp symbol))
            ;Shouldn't err out on macros/special forms.
            (%fhave new-symbol def))
      (set-symbol-plist new-symbol (copy-list (symbol-plist symbol))))
  new-symbol)


(defvar %gentemp-counter 0
  "Counter for generating unique GENTEMP symbols.")

(defun gentemp (&optional (prefix "T") (package *package*))
  "Creates a new symbol interned in package Package with the given Prefix."
  (loop
    (let* ((new-pname (%str-cat (ensure-simple-string prefix) 
                                (%integer-to-string %gentemp-counter)))
           (sym (find-symbol new-pname package)))
      (if sym
        (setq %gentemp-counter (%i+ %gentemp-counter 1))
        (return (values (intern new-pname package))))))) ; 1 value.




(defun add-gc-hook (hook-function &optional (which-hook :pre-gc))
  (ecase which-hook
    (:pre-gc
     (pushnew hook-function *pre-gc-hook-list*)
     (setq *pre-gc-hook* #'(lambda ()
                             (dolist (hook *pre-gc-hook-list*)
                               (funcall hook)))))
    (:post-gc
     (pushnew hook-function *post-gc-hook-list*)
     (setq *post-gc-hook* #'(lambda ()
                             (dolist (hook *post-gc-hook-list*)
                               (funcall hook))))))
  hook-function)

(defun remove-gc-hook (hook-function &optional (which-hook :pre-gc))
  (ecase which-hook
    (:pre-gc
     (unless (setq *pre-gc-hook-list* (delq hook-function *pre-gc-hook-list*))
       (setq *pre-gc-hook* nil)))
    (:post-gc
     (unless (setq *post-gc-hook-list* (delq hook-function *post-gc-hook-list*))
       (setq *post-gc-hook* nil)))))

(defun post-egc-hook-enabled-p ()
  (declare (fixnum *gc-event-status-bits*))
  (logbitp $gc-post-egc-hook-bit *gc-event-status-bits*))

(defun set-post-egc-hook-enabled-p (value)
  (declare (fixnum *gc-event-status-bits*))
  (setq *gc-event-status-bits* 
        (if (setq value (not (null value)))
          (the fixnum (bitset $gc-post-egc-hook-bit *gc-event-status-bits*))
          (the fixnum (bitclr $gc-post-egc-hook-bit *gc-event-status-bits*))))
  value)




(defun find-method-by-names (name qualifiers specializers)
  (let ((gf (fboundp name)))
    (when gf
      (if (not (standard-generic-function-p gf))
        (error "~S is not a generic-function." gf)
        (let ((methods (%gf-methods gf)))
          (when methods
            (let* ((spec-len (length (%method-specializers (car methods))))
                   (new-specs (make-list spec-len :initial-element (find-class t))))
              (declare (dynamic-extent new-specs))
              (do ((specs specializers (cdr specs))
                   (nspecs new-specs (cdr nspecs)))
                  ((or (null specs) (null nspecs)))
                (let ((s (car specs)))
                  (rplaca nspecs (if (consp s) s (find-class s nil)))))
              (find-method gf qualifiers new-specs nil))))))))


;; Fred functions from optional modules



#|
	Change History (most recent last):
	2	12/29/94	akh	merge with d13
|# ;(do not edit past this line!!)
