;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  2 3/12/97  akh  path-pstr-sub - ** => *
;;  17 9/13/96 akh  fix physical-pathname-p for nwo
;;  16 9/4/96  akh  dont remember
;;  13 7/30/96 akh  fix find-pstr-pattern - dont run off the end
;;  12 7/26/96 akh  fix %path-pstr*=
;;  10 5/20/96 akh  path-pstr*= fix for false alarm on match with *
;;  7 1/28/96  akh  back-translate-pathname takes optional allowable hosts arg
;;  3 11/17/95 akh  #_hxx => #_PBHxx
;;  2 10/11/95 akh  no lap if ppc
;;  7 9/14/95  akh  path-pstr*=  - firstbyte => singlebyte
;;  6 7/27/95  akh  merge patches - set-xtab-lfun and redefmethod
;;  5 6/8/95   slh  make load-all-patches really do that
;;  2 4/28/95  akh  fix path-pstr*= - aref char-byte-table (not svref)
;;  3 3/2/95   akh  say element-type 'base-character
;;  (do not edit before this line!!)

;;pathnames.lisp Pathnames for Coral Common LISP
;; Copyright 1987-1988 Coral Software Corp.
;; Copyright 1989-1994 Apple Computer, Inc.
;; Copyright 1995 Digitool, Inc.

(in-package "CCL")

; Modification History:
;
; akh fix physical-pathname-p for nwo
; 08/05/96 bill (errchk (#_NewHandle ...)) => (#_NewHandle :errchk ...) in new-version-resource & patch-resource
;  7/31/96 slh  cond. out def-logical-directory (see comment)
; 04/25/96 bill load-patches says (make-pathname :name :wild :defaults *.fasl-pathname*)
;               instead of "*.fasl".
; 04/25/96 bill flush-volume resolves aliases.
; akh path-pstr*= fix for false alarm on match with *
; ------------- MCL-PPC 3.9
; 03/26/96  gb  lowmem accessors.
; 02/26/96 gb    #-ppc-target functions-match-p
; 12/05/95 slh   update trap names (a few more)
; 11/29/95 bill  New trap names to avoid emulator.
;                (#_PBxxx :errchk ...) -> (errchk (#_PBxxx ...))
; 11/30/95 slh   no patch-subprim for PPC
; 10/06/93 bill  register-patch, list-patches
; 10/04/93 bill  patch-resource can now lengthen the resource
; -------------- 3.0d13
; 07/13/93 alice rename-file, create-directory load-patches call full-pathname with no-error nil
; 06/16/93 alice fs-cons-pathname is no more, %dir-sub-file uses %std-name-and-type
; 06/12/93 alice %path-pstr*= deals with fat strings and assumes pstr is in system script.
; 04/13/93 bill  record-source-file in %redefmethod
; 02/09/93 bill  #_allocate -> #_SetEof. This makes Harold Haig's file server happy.
; 12/09/92 bill  #_allocate returns to %copy-fork
; 11/25/92 bill  patch-resource, patch-subprim
; 08/25/92 bill  in %copy-fork: use autoloaded records & constants, not sysequ.lisp constants
; 07/09/92 bill  added run-time for "ccl:lib;patchenv"
; 11/05/92 alice once again %directory, %one-wild, %all-directories - avoid indirect alias circles
;		while not avoiding good stuff (patch 2)
; 08/27/92 alice bigger block size in copy-file
; 04/29/92 alice %one-wild - dont resolve alias unless it matches
;		directory, %directory, %all-directories avoid indirect circles when resolving aliases
; 04/23/92 alice directory - fix (directory "*:abcd:" :directories t)
; 04/16/92 alice %file*= - ALWAYS put the length back (fixes a crock in directory)
; 02/28/92 alice directory dtrt when no directory provided
; 02/07/92 alice volume-number does something useful with 0
;--------------- 2.0
; 01/12/92 alice copy-file revert
; 12/16/91 alice eject-disk and friends allow volume-number too
; 12/12/91 gb    %err-disp -> signal-file-error, with fixnum args.
; 12/12/91 bill  #_LoadResource after #_Get1Resource
;--------------- 2.0b4
; 11/04/91 alice fs-cons-pathname quotes dots iff could be construed as having a version .0 or .newest
; 11/01/91 alice undo 09/12/91 - it is WRONG
; 10/10/91 alice rename-file use gen-file-name
; 10/21/91 gb    no more #_PB
; 09/24/91 alice fix load-logical-pathname-translations a) dont if already defined b) return T if loaded
; 09/20/91 alice another fix to rename-file 
; 09/12/91 alice files-in-directory if :directories t, also include dir if name is "*" - NO
; 09/12/91 alice create-directory failed to create intermediate dirs (result of alias mods)
; 09/11/91 alice copy-file obey :if-exists nil, rename-file was ill, create-directory recurse FULL PHYSICAL dir
;--------------- 2.0b3
; 08/29/91 alice %files-in-directory and %all-directories with no name or type heed directories argument
; 08/26/91 bill  copy-file reported some errors on wrong pathname
; 08/22/91 alice %copy-fork had another typo
; 08/21/91 bill  %copy-fork had a typo
; 08/21/91 alice forgot to pass along resolve-aliases in a few places.
; 08/01/91 alice adapt for aliases (to do:  rename-file, copy-file)
; 07/29/91 alice do dirids as 1 long
; 07/21/91 gb    use :clear option in %stack-block.  Use _Allocate when copying forks.
; 07/12/91 alice directory escape dots in name (so dont lose .0 etc)
; 07/09/91 alice simpler back-translate-pathname
; 07/03/91 alice fix bogosity in back-translate-pathname
; 06/28/91 alice make backtranslate-pathname do the old style logical dirs too.
; 06/10/91 alice backtranslate-pathname deal with :wild in directory list
; 06/07/91 alice new-version-resource read 'vers' from curaprefnum.
;------------ 2.0b2
; 06/04/91 alice add some more vars to load-patches
; 05/20/91 bill translate-logical-pathname in dirpath-to-filepath
; 05/16/91 bill add a :fork keyword to copy-file.
; 05/15/91 bill copy-file does _FlushVol.  %copy-fork clears the ioMisc field before open.
; 04/02/91 alice drive-name takes neg num to serve as volume-name
; 03/28/91 alice put load-patches here for lack of a better place
; 03/08/91 alice rename-file do directories too, deal with catmove + rename.
; 02/26/91 alice copy-file - dont create new before know old exists!
; 02/22/91 alice %err-disp => file-error
; 02/08/91 alice added back-translate-pathname
; 02/07/91 alice moved some stuff to l1-pathnames
; 02/06/91 alice %pathname-match-dir1 - logical match physical?
;---------- 2.0b1
; 02/06/91 alice load-logical-pathname-translations
; 01/30/91 alice dir etal don't call dir-path-from-iopb because GatorShare the Caymen/NFS thing doesnt
;          work right for protected dirs (can _getcatinfo via iofdirindex but not by ioDirID)
; 01/28/91 alice directory and friends use #files instead of waiting for fnferr
; 01/25/91 alice directory and friends - if unexpected error just quit/continue, dont error
; 01/25/91 alice set-logical-pathname-translations - fix so call to parse-namestring wont error
;----------------- 2.0a5
; 01/06/90 alice directory - do error if called upon undefined (ccl) logical directory
; 01/03/90 alice translate-component and %split-component
; 01/01/91 alice %component-match-p nothing matches **, %pathname-match-directory (abs vs. relative?)
; 01/01/90        translate-directory relative=>absolute is relative (??)
; 12/20/90 alice change call to %directory-list-namestring
; 12/13/90 alice fix %all-directories when ** matches nothing
; 12/11/90 alice change %some-specific
; 12/10/90 alice fix %logical-directory-component (then nuke it)
;   flush-volume and some others like eject-disk call make-pathname with host nil (or defaults nil)
;   verify-logical-host-name - check for defined logical host
;   deal with $afpAccessDenied errors in directory and friends
;--------------- 2.0a4
; 11/06/90 alice %pathname-match-dir0 fix to fix of 10/18/90 (so hd: matches hd:**:)
; 10/25/90 alice directory just call full-pathname instead of doing the same thing in line
; 10/23/90 alice create-directory just thought it was doing translate-logical-pathname
; 10/19/90 alice fix translate-directory for null source, %pathname-match-directory
;                let nil match **
; 10/18/90 alice %pathname-match-directory - dont match if one is longer - from alanr
; 10/16/90 gb   no more %str-length.
; 08/20/90 bill %%path*= per GZ
; 07/25/90 alice directory work for relative pathnames too
; 07/18/90 alice let create-directory create multiple sub-directories
; ---------- 2.0d48
; 07/12/90 alice make copy-file preserve creation and modification date
; 07/06/90 alice create-directory and directory call translate-logical-pathname
; 07/06/90 alice add eject&unmount-disk (name?? - useful ??)
; 07/01/90 alice The definitive and final version of directory
; 06/29/90 alice added volume-number
; 06/28/90 alice ever more fixes to directory
; 06/22/90 bill found the ugly bug in copy-file
; 06/21/90 alice fix directory **
; 06/19/90 alice make copy-file lots faster
; 06/11/90 alice pathname-match-p check logical host too
; 06/01/90 alice add translate-pathname (yuck) and logical-pathname
; 05/29/90 add pathname-match-p - fix kludge in file*=
;05/25/90 alice Added %all-directories - kludged a fix in %file*= for *.*
;05/21/90 bill Gails fix to %path-pstr*=
;5/7/90   gz  Logical pathnames, modulo a parser.  %path*= -> %path-pstr*=, add
;             %path-str*= for matching strings.
;04/14/90 gz  %substr now takes start/end args.
;             Logical-pathname -> logical-directory.
;             Structured directories.
;02/13/90 gz  Fix in rename-file:  _CatMove wants ioNewName null, not "".
;09/30/89 bill Fixed cache clearing in %one-directory
;09/27/89 gb simple-string -> ensure-simple-string.
;09/25/89 bill Added mode line.  Add use-cache-p arg to %path-from-iopb calls in
;              %one-directory.  Clear the cache at the beginning.
;01/05/89 gz Don't pass empty strings to traps.
;10/24/88 gz added def-logical-pathname, formerly in record-source(??)
;9/23/88 gb %path-[to,from]-pb -> %path-[to,from]-iopb.
;9/01/88 gz directory done except for "**" matching.
;8/30/88 gz new regime.  Directory not done yet.
;8/16/88 gz $ioNamePtr -> $ioFileName. %str= -> string=.
;9/29/87 jaj moved %do-files-in-directory and do-files-in-directory to l1-files
;------------------------------------Version 1.0-----------------------------
;8/21/87 gz  Made do-devices et. al. not expand into trap macros, so alltraps
;            isn't needed to use them.
;7/27/87 gz  Made file-locked-p return nil if file is not locked...
;7/26/87 am  lock-file unlock-file locked-filep now return their args.
;7/26/87 am  fixed directory to merge with *default-pathname-defaults*, and
;            use the mac-default directory if there is still no dir specified.
;7/24/87 gz  moved merge-pathnames and support to l1-files.
; 7/24/87 am pathnamep -> lisp-pathnamep
;7/22/87 am  modified pathname string-parsing per gz. made modules follow.
;            the global vars like *default-pathname-defaults* start with nil
;             made (pathname "foo") have nil directory component.
;             twidled some arguments to %filename-matcher and %str*=
; 7/18/87  gz try not to leave symbolic $constants in macroexpansions.
; 7/11/87  gz added find-module-pathnames (which is called by require),
;             *module-search-path*.
;             Made user-homedir-pathname return the "home;" dir, rather than
;             *working-directory*.
; 7/ 6/87  am user-home-dir-pathname return *working-directory* + tiny changes:
;             like hfs-volume-p -> %hfs-volume-p.
;             with-pstrs -> with-returned-pstrs in files/directories-in-directory
; 6/30/87  gz added some bccl conditionalizations.
; 06/21/87 am changed file immensely for new file-system. put file in lib.
; 06/21/87 gb moved pathmnamep, mac-pathnamep to l1-utils.  Made %pr-pathname
;             call CCL printer.
; 06/12/87 gb moved *pathname-escape-character* to level-2.  aux vars in
;             directory, %filename-matcher.
; 06/04/87 gb fixed pathnamep and mac-pathnamep when passed random uvectors.
; 87 05 24 cfry fixed pathnamep and mac-pathnamep when passed ""
;;87 05 16 am made directory-list look for ESCAPED semicolons.
;;87 05 06 am Made all components be strings, made pathnames be implemented as
;             structures. Moved %str-mem-bak %str-member-i 
;             toggle-case %str*= %str*=-aux %str-mem-esc %rem-unnecess-esc
;             %ins-esc to level-2. %parse-filename-str now returns multiple-values
;             instead of a list. + added many functions prefixed by mac- and %mac-
;             mac-to-lisp-namestring -> %mac-to-lisp-namestring
;;87 04 29 gb lexical variable name conflict in namestring.
;;87 04 27 am added %str-member-i and toggle-case. made %str*=-aux use them.
;;87 04 07 am fixed make-pathname and directory-namestring .
; 4/5/87   gz string-to-simple-string* -> simple-string. %member -> memq.
;;87 03 20 am expand-logical-pathnames -> expand-logical-namestring
;;87 03 17 am file-streamp -> stream-has-file-p
;;87 03 17 am string-to-simple-string* -> simple-string  #\ -> *pathname-escape-character*
;             %str-length -> length;  added file-streamp. Hacked truename again.
;;87 03 02 am Added a correct truename %truename defvared *working-directory*
;;87 02 26 am added printing and reading, escape-chars; changed merging and
;             expanding; no more downcasing.
;;87 02 25 am (based on gz's changes of 1/30/87) %str-char ->schar,
;             return -> return-from in %str*=,%str*=-aux,file-namestring,proper-dir-nam
;             truename -> %truename, %i-path-string-truename -> %truename,
;             am:truename -> truename.

;87 02 24 am changed much to make work in code-0. removed #'directory!
;87 02 23 am changed names for files-in-directory and directories-in-directory,
;            put in a differeent user-home-dir function and changed #'devices
;87 02 06 am added the fboundp cluase in the clause that defines truename.


(eval-when (eval compile)
  (require 'level-2)
  (require 'backquote)
)
;(defconstant $accessDenied -5000) ; put this with other errnos
(defconstant $afpAccessDenied -5000) ; which name to use?



;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_
;ANSI CL logical pathnames


(defvar *pathname-translations-pathname*
  (make-pathname :host "ccl" :type "pathname-translations"))

(defun load-logical-pathname-translations (host)
  ;(setq host (verify-logical-host-name host))
  (when (not (%str-assoc host %logical-host-translations%))
    (setf (logical-pathname-translations host)
          (with-open-file (file (merge-pathnames (make-pathname :name host :defaults nil)
                                                 *pathname-translations-pathname*)
                                :element-type 'base-char)
            (read file)))
    T))

(defun back-translate-pathname (path &optional hosts)
  (declare (ignore hosts))
  path)




(defun back-translate-pathname-1 (path &optional hosts)
  (dolist (host %logical-host-translations%)
    (when (or (null hosts) (member (car host) hosts :test 'string-equal))
      (dolist (trans (cdr host))
        (when (pathname-match-p path (cadr trans))
          (let* (newpath)          
            (setq newpath (translate-pathname path (cadr trans) (car trans) :reversible t))
            (return-from back-translate-pathname-1 
              (if  (equalp path newpath) path (back-translate-pathname-1 newpath hosts))))))))
  path)



; must be after back-translate-pathname
(defun physical-pathname-p (path)
  (let* ((path (pathname path))
         (dir (pathname-directory path)))
    (and dir
         (or (not (logical-pathname-p path))
             (not (null (memq (pathname-host path) '(nil :unspecific))))))))



;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_
;File or directory Manipulations

(defun unix-rename (old-name new-name)
  (with-cstrs ((old old-name)
               (new new-name))
    (let* ((res (external-call "rename" :address old :address new :signed-fullword)))
      (declare (fixnum res))
      (if (zerop res)
        (values t nil)
        (values nil res)))))

(defun rename-file (file new-name)
  "Rename File to have the specified New-Name.  If file is a stream open to a
  file, then the associated file is renamed."
  (let* ((original (truename file))
	 (original-namestring (namestring (translate-logical-pathname original)))
	 (new-name (merge-pathnames new-name original))
	 (new-namestring (namestring (translate-logical-pathname new-name))))
    (unless new-namestring
      (error "~S can't be created." new-name))
    (multiple-value-bind (res error)
			 (unix-rename original-namestring
					   new-namestring)
      (unless res
	(error "Failed to rename ~A to ~A: ~A"
	       original new-name error))
      (when (streamp file)
	(file-name file new-namestring))
      (values new-name original (truename new-name)))))


(defun copy-file (old-path new-path &key (if-exists :error))
  (break "Copy-file ? ~s ~s ~s" old-path new-path if-exists))

(defun lock-file (path)
  (break "lock-file ? ~s" path))

(defun unlock-file (path)
  (break "unlock-file ? ~s" path))

(defun create-directory (path &key (if-exists :error))
  (break "create-directory ? ~s ~s" path if-exists))


(defun dirpath-to-filepath (path)
  (setq path (translate-logical-pathname path))
  (let* ((dir (pathname-directory path))
         (super (butlast dir))
         (name (car (last dir))))
      ;Gotta pick the dir name out of the path, e.g. "hd:ccl:new:" ->
      ;"hd:ccl:new".  Problem is e.g. if it ends in "::"... Can't use
      ;traps since the darn thing doesn't exist yet, so just punt on
      ;the dubious cases...
      (when (or (null super)            ; ":"
                (eq name ':up)        ; "....::"
                (and (eq (car super) ':absolute) (null (%cdr super))))  ; "hd:"
        (signal-file-error $xnocreate path))
      (setq path (make-pathname :directory super :name name :defaults nil))))

(defun filepath-to-dirpath (path)
  (let* ((dir (pathname-directory path))         
         (rest (file-namestring path)))
    (make-pathname :directory (append dir (list rest)) :defaults nil)))
  


;Takes a pathname, returns the truename of the directory if the pathname
;names a directory, NIL if it names an ordinary file, error otherwise.
;E.g. (directoryp "ccl;:foo:baz") might return #P"hd:mumble:foo:baz:" if baz
;is a dir. - should we doc this - its exported?
(defun directoryp (path)
  ;; This should be pretty easy.
  (break "Directoryp ? ~s" path))

;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_
;Wildcards
(defun wild-pathname-p (pathname &optional field-key)
  (flet ((wild-p (name) (or (eq name :wild)
                            (eq name :wild-inferiors)
			    (typep name 'pattern))))
    (let* ((pathname (pathname pathname)))
    (case field-key
      ((nil)
       (or (some #'wild-p (pathname-directory pathname))
           (wild-p (pathname-name pathname))
           (wild-p (pathname-type pathname))
           (wild-p (pathname-version pathname))))
      (:host nil)
      (:device nil)
      (:directory (some #'wild-p (pathname-directory pathname)))
      (:name (wild-p (pathname-name pathname)))
      (:type (wild-p (pathname-type pathname)))
      (:version (wild-p (pathname-version pathname)))
      (t (wild-pathname-p pathname
                          (require-type field-key 
                                        '(member nil :host :device 
                                          :directory :name :type :version))))))))


 
;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_
;Directory Traversing

(defmacro enumerate-matches ((var pathname &optional result
				  &key (verify-existance t))
			     &body body)
  (let ((body-name (gensym)))
    `(block nil
       (flet ((,body-name (,var)
		,@body))
	 (%enumerate-matches (pathname ,pathname)
			     ,verify-existance
			     #',body-name)
	 ,result))))

(defun %enumerate-matches (pathname verify-existance function)
  (when (pathname-type pathname)
    (unless (pathname-name pathname)
      (error "Cannot supply a type without a name:~%  ~S" pathname)))
  (when (and (integerp (pathname-version pathname))
	     (member (pathname-type pathname) '(nil :unspecific)))
    (error "Cannot supply a version without a type:~%  ~S" pathname))
  (let ((directory (pathname-directory pathname)))
    (if directory
	(ecase (car directory)
	  (:absolute
	   (%enumerate-directories "/" (cdr directory) pathname
				   verify-existance function))
	  (:relative
	   (%enumerate-directories "" (cdr directory) pathname
				   verify-existance function)))
	(%enumerate-files "" pathname verify-existance function))))

(defun %enumerate-directories (head tail pathname verify-existance function)
  (declare (simple-string head))
  (if tail
      (let ((piece (car tail)))
	(etypecase piece
	  (simple-string
	   (%enumerate-directories (concatenate 'string head piece "/")
				   (cdr tail) pathname verify-existance
				   function))
	  ((or pattern (member :wild :wild-inferiors))
	   (let ((dir (%open-dir head)))
	     (when dir
	       (unwind-protect
		   (loop
		     (let ((name (%read-dir dir)))
		       (cond ((null name)
			      (return))
			     ((string= name "."))
			     ((string= name ".."))
			     ((pattern-matches piece name)
			      (let ((subdir (concatenate 'string
							 head name "/")))
				(when (eq (%unix-file-kind subdir)
					  :directory)
				  (%enumerate-directories
				   subdir (cdr tail) pathname verify-existance
				   function)))))))
		 (close-dir dir)))))
	  ((member :up)
	   (%enumerate-directories (concatenate 'string head "../")
				   (cdr tail) pathname verify-existance
				   function))))
      (%enumerate-files head pathname verify-existance function)))

(defun %enumerate-files (directory pathname verify-existance function)
  (declare (simple-string directory))
  (let ((name (%pathname-name pathname))
	(type (%pathname-type pathname))
	(version (pathname-version pathname)))
    (cond ((member name '(nil :unspecific))
	   (when (or (not verify-existance)
		     (%unix-file-kind directory))
	     (funcall function directory)))
	  ((or (pattern-p name)
	       (pattern-p type)
	       (eq name :wild)
	       (eq type :wild))
	   (let ((dir (%open-dir directory)))
	     (when dir
	       (unwind-protect
		   (loop
		     (let ((file (%read-dir dir)))
		       (if file
			   (unless (or (string= file ".")
				       (string= file ".."))
			     (multiple-value-bind
				 (file-name file-type file-version)
				 (let ((*ignore-wildcards* t))
				   (extract-name-type-and-version
				    file 0 (length file)))
			       (when (and (components-match file-name name)
					  (components-match file-type type)
					  (components-match file-version
							    version))
				 (funcall function
					  (concatenate 'string
						       directory
						       file)))))
			   (return))))
		 (close-dir dir)))))
	  (t
	   (let ((file (concatenate 'string directory name)))
	     (unless (or (null type) (eq type :unspecific))
	       (setf file (concatenate 'string file "." type)))
	     (unless (member version '(nil :newest :wild))
	       (setf file (concatenate 'string file "."
				       (quick-integer-to-string version))))
	     (when (or (not verify-existance)
		       (%unix-file-kind file t))
	       (funcall function file)))))))

(defun quick-integer-to-string (n)
  (declare (type integer n))
  (cond ((not (fixnump n))
	 (write-to-string n :base 10 :radix nil))
	((zerop n) "0")
	((eql n 1) "1")
	((minusp n)
	 (concatenate 'simple-string "-"
		      (the simple-string (quick-integer-to-string (- n)))))
	(t
	 (do* ((len (1+ (truncate (integer-length n) 3)))
	       (res (make-string len))
	       (i (1- len) (1- i))
	       (q n)
	       (r 0))
	      ((zerop q)
	       (incf i)
	       (replace res res :start2 i :end2 len)
	       (shrink-vector res (- len i)))
	   (declare (simple-string res)
		    (fixnum len i r q))
	   (multiple-value-setq (q r) (truncate q 10))
	   (setf (schar res i) (schar "0123456789" r))))))

(defun directory (pathname &key (all t) (check-for-subdirs t)
			   (follow-links t))
  "Returns a list of pathnames, one for each file that matches the given
   pathname.  Supplying :ALL as nil causes this to ignore Unix dot files.  This
   never includes Unix dot and dot-dot in the result.  If :FOLLOW-LINKS is NIL,
   then symblolic links in the result are not expanded.  This is not the
   default because TRUENAME does follow links, and the result pathnames are
   defined to be the TRUENAME of the pathname (the truename of a link may well
   be in another directory.)"
  (let ((results nil))
    (enumerate-matches (name (translate-logical-pathname
			      (merge-pathnames pathname
					       (make-pathname :name :wild
							      :type :wild
							      :version :wild))))
       (when (or all
		 (let ((slash (position #\/ name :from-end t)))
		   (or (null slash)
		       (= (1+ slash) (length name))
		       (char/= (schar name (1+ slash)) #\.))))
	 (push name results)))
    (let ((*ignore-wildcards* t))
      (mapcar #'(lambda (name)
		  (let ((name (if (and check-for-subdirs
				       (eq (%unix-file-kind name)
					   :directory))
				  (concatenate 'string name "/")
				  name)))
		    (if follow-links (truename name) (pathname name))))
	      (sort (delete-duplicates results :test #'string=) #'string<)))))


(provide "PATHNAMES")
