;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  5 6/7/96   akh  dont remember
;;  4 5/20/96  akh  read-line-raw from Shannon Spires
;;  3 11/9/95  akh  fix read-line-raw again
;;  2 10/17/95 akh  merge patches
;;  2 4/28/95  akh  fix string-to-extended-string for non simple-string
;;  2 3/2/95   akh  string-output-stream will promote string to fat if necessary
;;  (do not edit before this line!!)

; streams.lisp
; Copyright 1986-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc.

(in-package :ccl)

; Modification History
;
; 03/10/97 bill Fix dribble-untyi
; ------------  4.0
; 4/27/95 slh   eof errors signal end-of-file
;06/21/93 alice truncating-string-stream element-type defaults to base-character
;04/27/93 bill indentation in read-line-raw
;11/20/92 gb   echo-stream/stream-tyi: don't echo NIL on EOF.
;------------- 2.0
;01/14/92 gb   READ-BYTE does eof processing; STREAM-READ-BYTE returns byte or NIL.
;              STREAM-WRITER is on output-binary-file-stream vice input-.
;12/10/91 alice %err-disp => signal-file-error !&!%*!!!!
;-------------- 2.0b4
;11/04/91 bill stream-reader & stream-writer for binary-file-stream's
;10/11/91 gb   changes for new l1-sysio.
;09/19/91 alice define stream-column for broadcast stream, synonym-stream, and two-way-stream 
;------------- 2.0b3
;07/21/91 gb   READ-BYTE isn't generic, STREAM-READ-BYTE is.
;06/12/91 bill GB's fix to DEFCLASS for input-binary-file-stream & output-binary-file-stream
;------------- 2.0b2
;05/31/91 gb   (mostly) generalize binary streams.
;03/13/91 bill input-binary-file-stream, output-binary-file-stream, io-binary-file-stream
;03/05/91 alice report-bad-arg gets 2 args 
;--------------- 2.0b1
;01/22/91 bill in read-line - downward-function
;              in read-line-raw - speed up with stream-reader & stream-writer
;12/06/90 bill string-input-stream inherits from string-stream
;10/31/90 bill slot-makunbound takes two args.
;09/12/90 bill maybe-default-stream-reader/writer
;09/08/90 bill add stream-reader and stream-writer methods
;08/18/90 bill (method stream-write-string (truncating-string-stream t t t))
;08/17/90 bill (method stream-position (string-input-stream))
;08/02/90 gb   (partially ?) fix binary io problems.
;07/06/90 bill Remove &allow-other-keys from instance-initialize
;03/20/90 bill initialize-instance => instance-initialize
;12/29/89 gz   Made read-line go thru stream-rubout-handler.
;              Added stream-filename method for synonym streams, so
;              pathname will work on them per x3j13/PATHNAME-STREAM.
;12/22/89 gb   prinX-to-string were (identically) defined in l1-io.lisp.
;12/21/89 gz   added some readers per STREAM-ACCESS issue.
;09/16/89 bill Remove the last vestiges of object-lisp windows
;09/15/89 bill remove object-lisp
;8/20/89  gb   typo in (initialize-instance :after ((stream binary-file-stream)) ...)
;03/10/89 gz   CLOSified somewhat.  assume tyi/tyo deal in chars.
;01/10/89 gb   Try a different approach in READ-CHAR. Flush INPUT-STREAM-ARG,
;              OUTPUT-STREAM-ARG.
;12/30/88 gz   Flushed stream-has-file-p.  See stream-pathname in l1-files.
;              macro -> defmacro. input-stream-arg is in level-1.
;11/24/88 gb   read-line assumes tream-tyi returns characters.
;11/08/88 gb   truncating-string-stream mods.
; 8/17/88 gz   libfasl -> require
; 6/22/88 jaj  check to make sure args are strings in make-broadcast-stream
;              read-byte works for weird byte sizes
; 6/01/88 as   truncating-string-streams throw to :truncate on overflow

; 3/02/88  gz  Lots of declarations.
; 2/16/88 jaj  define %draw-cell-string-stream here
; 2/01/88 as   truncating-string-streams fixed slightly
; 1/29/88 as   make-truncating-string-stream has optional re-use-string arg
; 1/25/88 cfry fixed (stream-untyi *string-input-stream*) to error correctly
; 12/17/87 cfry fixed read-from-string and (exist *string-input-stream*)
;               as per AS patch for defaultingand checking the END arg.
; 12/11/87 cfry fixed read-line, read-char, unread-char, peek-char,
;             read-char-no-hang for T and NIL input streams.
;             fixed finish-output and force-output for T and NIL output streams
; 8/05/87 jaj wrap objvar around reference to index in with-input-from-string.
; 8/04/87 gz made read-line, read-char, peek-char, read-char-no-hang ignore
;            recursive-p again, as per the ISI test suite and a more careful
;            reading of CLtL...
; 8/04/87 jaj added "-iv" to variables: byte-size, length, stream-element-type
; 8/03/87 jaj made all of these streams double-closable
; 7/31/87 gb  bounds-check start, end args in read-from-string.
; 7/18/87 gz  added *truncating-string-stream*
; 7/13/87 jaj init-lists use keywords
; 7/1/87  gz  new exist arg scheme. Use defobject.
; 6/30/87 gz  use recursive-p in read-line, read-char, peek-char, read-char-no-hang.
; 6/21/87 am  removed COPY-FILE FILE-WRITE-DATE. new defs in L1.
; 6/21/87 gb  moved streamp, string-output-stream functions to l1-streams.
; 6/19/87 gb  %have -> have.
; 6/17/87 cfry fixed stream-peek again. Did somebody change stream-untyi out
;              from under me?
; 6/09/87 gz  &aux bits-to-go, size in write-byte. put 'version.
; 6/8/87 cfry fixed stream-peek and peek-char
; 5/20/87 gz  init-list-extract -> getf
; 4/15/87 am stream-has-file-p has changed.
; 4/12/87  cfry fixed read-line bug with value returned upon eof
;               same bug in peek-char, read-char-no-hang
;04/09/87 am  removed inoperative write-to-string. Added stream-has-file-p.
;3/31/87   gz   added libfasl alltraps.
;               class -> class-name
;3/30/87   gz   made macros take an env arg, pass it to parse-body.
;03/24/87  gz   no libfasl makearray (in level-1 now)
;               %ilsl -> ash in file-write-date to avoid losing hi bits.
;03/13/87  jaj  he put in a fresh-line  for string-streams + the function 
;               column for string-streams, + a dummy column for *streams*

;;;General io-functions

(eval-when (:execute :compile-toplevel)
  (require :level-2)
  (require :streams)
  (require :backquote)

  (defmacro signal-eof-error (stream)
    `(error 'end-of-file :stream ,stream))
  )

(defun read-line (&optional input-stream (eof-error-p t) eof-value recursive-p)
  (declare (ignore recursive-p))
  (read-line-raw (cond ((null input-stream) *standard-input*)
		       ((eq input-stream t) *terminal-io*)
		       (t input-stream))
		 eof-error-p eof-value))


; from Shannon Spires slightly modified
(defun read-line-raw (input-stream eof-error-p eof-value)
    "A faster way to do read-line-raw than that in streams.lisp. The speedup
     comes from avoiding with-output-to-string. Conses less too."
    (declare (optimize (speed 3) (safety 1)))
    (if (eofp input-stream)
      (if eof-error-p
        (signal-eof-error input-stream)
        (values eof-value (or eof-value t)))
      (let ((char nil)
            (str (make-array 20
                             :element-type 'base-char
                             :adjustable t :fill-pointer 0)))
        (while (and (setq char (tyi input-stream))
                    (neq char #\newline))
          (vector-push-extend char str))
        (values (ensure-simple-string str) (null char)))))

(defun get-string-from-user (prompt)
  (format t "~a" prompt)
  (values (read-line t)))

(defun select-item-from-list (list &key (window-title "Select one of the following")
				   (table-print-function #'prin1)
				   &allow-other-keys)
  (format *query-io* "~a:~%" window-title)
  (do* ((l list (cdr l))
	(i 0 (1+ i))
	(item (car l) (car l)))
       ((null l))
    (declare (fixnum i))
    (format *query-io* "~&~d: " i)
    (funcall table-print-function item *query-io*)
    (loop
	(fresh-line *query-io*)
	(let* ((string (get-string-from-user "Selection:"))
	       (value (ignore-errors
			(let* ((*package* *keyword-package*))
			  (read-from-string string nil)))))
	  (cond ((eq value :q) (throw :cancel t))
		((and (typep value 'unsigned-byte)
		      (< value (length list)))
		 (return (nth value list))))))))

(defun read-char (&optional input-stream (eof-error-p t) eof-value recursive-p)
  (declare (ignore recursive-p))
  (if input-stream
    (if (eq t input-stream) (setq input-stream *terminal-io*))
    (setq input-stream *standard-input*))
  (or (tyi input-stream)
      (if eof-error-p
        (signal-eof-error input-stream)
        eof-value)))


(defun unread-char (char &optional input-stream)
  (if input-stream
    (if (eq t input-stream) (setq input-stream *terminal-io*))
    (setq input-stream *standard-input*))
  (untyi char input-stream)
  nil)

(defun peek-char (&optional peek-type input-stream
                            (eof-error-p t) eof-value recursive-p)
  (declare (ignore recursive-p))
  (if input-stream
    (if (eq t input-stream) (setq input-stream *terminal-io*))
    (setq input-stream *standard-input*))
  (let* ((char (read-char input-stream eof-error-p eof-value)))
    (cond ((eq char eof-value) char)
	  ((typep peek-type 'character)
	   (do* ((char char (read-char input-stream eof-error-p eof-value)))
		((or (eq char eof-value) (eq char peek-type))
		 (unless (eq char eof-value)
		   (unread-char char input-stream))
		 char)))
	  ((eq peek-type t)
	   (do* ((char char (read-char input-stream eof-error-p eof-value)))
		((or (eq char eof-value) (not (whitespacep char)))
		 (unless (eq char eof-value)
		   (unread-char char input-stream))
		 char)))
	  ((null peek-type)
	   (unread-char char input-stream)
	   char)
	  (t
	   (report-bad-arg peek-type '(or character (member nil t)))))))	   

(defun read-char-no-hang (&optional input-stream (eof-error-p t) eof-value recursive-p)
  (declare (ignore recursive-p))
  (if input-stream
    (if (eq t input-stream) (setq input-stream *terminal-io*))
    (setq input-stream *standard-input*))
  (if (eofp input-stream)
    (if eof-error-p
      (signal-eof-error input-stream)
      (return-from read-char-no-hang eof-value)))
  (if (listen input-stream) (tyi input-stream)))


;;;;;;;;;;;; OUTPUT STREAMS

(defun clear-output (&optional stream)
  (if stream
    (if (eq stream t) (setq stream *terminal-io*))
    (setq stream *standard-output*))
  (stream-clear-output stream))

(defun finish-output (&optional stream)
  (if stream
    (if (eq stream t) (setq stream *terminal-io*))
    (setq stream *standard-output*))
  (etypecase stream
    (clos-stream (stream-finish-output stream))
    (sstream (force-output stream))))

(defun column (&optional stream)
  (if stream
    (if (eq stream t) (setq stream *terminal-io*))
    (setq stream *standard-output*))
  (etypecase stream
    (sstream (funcall (sstream-misc stream) stream :charpos))
    (clos-stream (stream-column stream))))

(defun line-length (stream)
  (declare (ignore stream))
  80)

;;;Binary Streams

;This stuff needs work.  Also, I don't think the MOD is meant the way this
;takes it...

(defclass binary-stream (clos-stream) ())

(defclass input-binary-stream (binary-stream input-stream) ())
(defclass output-binary-stream (binary-stream output-stream) ())
(defclass io-binary-stream (input-binary-stream output-binary-stream) ())


(defun read-byte (stream &optional (eof-error-p t) eof-value)
  (let* ((b (etypecase stream
              (sstream (funcall (sstream-bin stream) stream))
              (clos-stream (stream-read-byte stream)))))
    (or b
        (if eof-error-p 
            (error 'end-of-file :stream stream)
            eof-value))))

;Until we can specialize the second arg...
(defun write-byte (integer stream)
  (etypecase stream
    (sstream (funcall (sstream-bout stream) stream integer))
    (clos-stream (stream-write-byte stream integer)))
  integer)


;;; Binary file streams.
(defclass binary-file-stream (binary-stream file-stream) ())
(defclass input-binary-file-stream (input-binary-stream input-file-stream) ())
(defclass output-binary-file-stream (output-binary-stream output-file-stream) ())
(defclass io-binary-file-stream (input-binary-file-stream output-binary-file-stream) ())

(defmethod stream-write-byte ((stream output-binary-file-stream) integer)
  (%fwrite-byte (slot-value stream 'fblock) integer))

(defmethod stream-read-byte ((stream input-binary-file-stream))
  (%fread-byte (slot-value stream 'fblock)))

(defvar *input-binary-file-stream-class* (find-class 'input-binary-file-stream))
(defvar *output-binary-file-stream-class* (find-class 'output-binary-file-stream))



;;;General stream functions

(defmethod stream-column ((stream clos-stream)) 0)

(defmethod stream-clear-output ((stream output-stream)) ())

(defmethod stream-finish-output ((stream output-stream))
  (force-output stream))



;;

(defmacro with-open-stream ((var stream) &body body &aux (svar (gensym)))
  `(let (,svar)
     (unwind-protect
       (let ((,var (setq ,svar ,stream)))
         ,@body)
       (when ,svar (close ,svar)))))

(defun input-stream-p (thing)
  (and (streamp thing)
       (memq (stream-direction thing) '(:io :input))))

(defun output-stream-p (thing)
  (and (streamp thing)
       (memq (stream-direction thing) '(:io :output))))

; what is this for?
(defmethod stream-element-type ((stream clos-stream)) 'base-char)

;;;synonym-streams

(defclass synonym-stream (clos-stream)
  ((stream-symbol :initarg :symbol :reader synonym-stream-symbol)))

(defun make-synonym-stream (symbol)
  (make-instance 'synonym-stream :symbol symbol))

;we really need delegation for these puppies

(defmethod stream-direction ((stream synonym-stream))
  (stream-direction (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-column ((stream synonym-stream))
  (column (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-element-type ((stream synonym-stream))
  (stream-element-type (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-tyo ((stream synonym-stream) char)
  (tyo char (symbol-value (synonym-stream-symbol stream))))

(defvar *synonym-stream-class* (find-class 'synonym-stream))


(defmethod stream-tyi ((stream synonym-stream))
  (tyi (symbol-value (synonym-stream-symbol stream))))

(defmethod stream-untyi ((stream synonym-stream) char)
  (untyi char (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-eofp ((stream synonym-stream))
  (eofp (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-force-output ((stream synonym-stream))
  (force-output (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-finish-output ((stream synonym-stream))
  (finish-output (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-close :after ((stream synonym-stream))
  (when (slot-boundp stream 'stream-symbol)
    (close (symbol-value (slot-value stream 'stream-symbol)))
    (slot-makunbound stream 'stream-symbol)))

(defmethod stream-fresh-line ((stream synonym-stream))
  (fresh-line (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-clear-input ((stream synonym-stream))
  (clear-input (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-listen ((stream synonym-stream))
  (listen (symbol-value (slot-value stream 'stream-symbol))))

(defmethod stream-filename ((stream synonym-stream))
  (stream-filename (symbol-value (slot-value stream 'stream-symbol))))

;;;broadcast-streams

(defclass broadcast-stream (output-stream)
  ((streams :initarg :streams :reader broadcast-stream-streams)))

(defun make-broadcast-stream (&rest streams)
  (make-instance 'broadcast-stream :streams streams))

(defmethod initialize-instance :after ((stream broadcast-stream) &key)
  (dolist (stream (slot-value stream 'streams))
    (unless (streamp stream)
      (error "~s is not a stream" stream))))

(defmethod stream-tyo ((stream broadcast-stream) char)
  (dolist (stream (slot-value stream 'streams))
    (tyo char stream)))

(defvar *broadcast-stream-class* (find-class 'broadcast-stream))

(defmethod stream-column ((stream broadcast-stream))
  (let ((streams (slot-value stream 'streams)))
    (if streams (column (car streams)) 0)))


(defmethod stream-force-output ((stream broadcast-stream))
  (dolist (stream (slot-value stream 'streams))
    (force-output stream)))

(defmethod stream-finish-output ((stream broadcast-stream))
  (dolist (stream (slot-value stream 'streams))
    (finish-output stream)))

(defmethod stream-fresh-line ((stream broadcast-stream))
  (dolist (stream (slot-value stream 'streams))
    (stream-fresh-line stream)))

(defmethod stream-close :after ((stream broadcast-stream))
  (when (slot-boundp stream 'streams)
    (dolist (stream (slot-value stream 'streams)) (close stream))
    (slot-makunbound stream 'streams)))

;;;concatenated-streams

;;

;;;echo streams

(defclass echo-stream (two-way-stream)
  ((untyip :initform nil)))

(defmethod echo-stream-input-stream ((stream echo-stream))
  (slot-value stream 'input-stream))

(defmethod echo-stream-output-stream ((stream echo-stream))
  (slot-value stream 'output-stream))

(defun make-echo-stream (input-stream output-stream)
  (make-instance 'echo-stream
                 :input-stream input-stream :output-stream output-stream))

(defmethod stream-tyi ((stream echo-stream))
  (let ((char (tyi (slot-value stream 'input-stream))))
    (if (slot-value stream 'untyip)
      (set-slot-value stream 'untyip nil)
      (if char
        (tyo char (slot-value stream 'output-stream))))
    char))

(defmethod stream-untyi ((stream echo-stream) char)
  (untyi char (slot-value stream 'input-stream))
  (set-slot-value stream 'untyip t))

(defmethod stream-clear-input :after ((stream echo-stream))
  (set-slot-value stream 'untyip nil))


;;; from i/o chapter of steele
;;; Ever notice that -much- of this code is from the i/o chapter
;;; of steele ?  Strange but true ...

(defun read-from-string (string &optional (eof-error-p t) eof-value
                                &key (start 0) end preserve-whitespace
                                &aux idx)
  (values
   (with-input-from-string (stream string :index idx :start start :end end)
     (if preserve-whitespace
       (read-preserving-whitespace stream eof-error-p eof-value)
       (read stream eof-error-p eof-value)))
   idx))


;;;File Stuff here

(defvar *dribble-untyiedp*)

(defun dribble (&optional filename)
  (if *dribble-stream* (close *dribble-stream*))
  (setq *dribble-stream* 
     (if filename
         (open filename :direction :output :if-exists :append 
                        :if-does-not-exist :create)))
  (setq *dribble-untyiedp* nil)
  *dribble-stream*)

(defun dribble-tyi (char)
  (if *dribble-untyiedp*
      (setq *dribble-untyiedp* nil)
      (tyo *dribble-stream* char)))

(defun dribble-untyi ()
  (setq *dribble-untyiedp* t))
