; conditions caught

unknown-host-name  ; super class of tcp-unknown-domain-name - ok sort of

unauthorized-client-access ; ok
host-stopped-responding
network-error ; subclass of error - ok
ccl:connection-lost

mactcp-error  ; subclass of error - not directly signaled ? ; ok
domain-error  ; not directly signaled ok 
remote-network-error
tcp-invalid-data-structure
bad-connection-state ; maybe never happens


tcp-connection-state-timeout  ;  is internal
; this p.o.s is the fucker who signals tcp-connection-state-timeout 
 
(defun %tcp-wait-for-connection-state (conn states &optional timeout (whostate "TCP State Wait") &aux state)
  (check-type states cons)
  (with-pb-copy (pb (conn-pb conn))
    (flet ((connection-in-state-p ()
             (setq state (%tcp-connection-state pb t))
             (member state states :test #'eql)))
      (declare (dynamic-extent #'close-complete-p))
      (or (connection-in-state-p)
          (progn (process-wait-with-timeout whostate timeout #'connection-in-state-p)
                 (unless (member state states :test #'eql)
                   (error 'tcp-connection-state-timeout :state state :states states)))))))

; conditions signaled from xmactcp


tcp-insufficient-resources
tcp-unknown-connection-state


; anything from tcp-err-disp
(defparameter *tcp-error-class-alist*
  '((-23000 . tcp-bad-network-connection)
    (-23001 . tcp-bad-ip-configuration)
    (-23002 . tcp-missing-ip-or-lap-configuration)
    (-23003 . error-loading-mactcp)
    (-23004 . tcp-bad-ip-address)
    (-23005 . tcp-connection-closed)
    (-23006 . tcp-invalid-ip-packet-length)
    (-23007 . tcp-connection-conflict)
    (-23008 . tcp-connection-does-not-exist)
    (-23009 . tcp-insufficient-resources)
    (-23010 . tcp-invalid-stream-pointer)
    (-23011 . tcp-stream-already-open)
    (-23012 . tcp-connection-reset)
    (-23013 . tcp-invalid-buffer-pointer)
    (-23014 . tcp-invalid-data-structure)
    (-23015 . tcp-connection-refused)
    (-23016 . tcp-command-timeout)
    (-23017 . tcp-duplicate-socket)
    (-23032 . tcp-ip-packet-too-large)
    (-23033 . tcp-host-stopped-responding)
    (-23036 . tcp-insufficient-memory-for-packet-size)
    (-23037 . tcp-insufficient-memory-for-packet-size)
    (-23041 . tcp-syntax-error)
    (-23042 . tcp-domain-cache-fault)
    ;;#define noResultProc  -23043
    (-23044 . tcp-domain-server-not-found)
    (-23045 . tcp-unknown-domain-name)
    (-23046 . tcp-no-response-from-domain-server)
    (-23047 . domain-resolver-error)
    (-23048 . tcp-out-of-memory)
    ;; AppleTalk errors follow
    (-97 . appletalk-port-already-in-use)
    (-98 . appletalk-inactive)))