; -*- Mode:Lisp; Package:CCL; -*-

;;	Change History (most recent first):
;;  1 5/7/95   slh  new file
;;  (do not edit before this line!!)

;; dialog-macros.lisp
;; Convenience macros for laying out dialogs.
;; Copyright 1995 Digitool, Inc.

(in-package :ccl)

; makes dialog description less verbose and if params are constants we do
; arithmetic at compile time rather than run time
(defmacro vertical-labeled-items (&key dialog-width delta lmargin col2 vpos (font '("chicago" 12)) lastvar items)
  (let ((n 0) result)
    (dolist (vitem items)
      (destructuring-bind (title type nickname &optional width &rest keys) vitem
        (let* ((adjust (if (memq type '(pop-up-menu typein-menu)) 4 0))
               (height (font-line-height font)))
          (setq result
                (nconc result
                       `(,@(when title
                             `((make-dialog-item 
                                'static-text-dialog-item                                
                                ,(make-point lmargin (+ vpos  (* delta n)))
                                nil 
                                ,title
                                )))
                         (make-instance ',type
                           :view-position                         
                           ,(make-point (if title (- col2 (/ adjust 2)) lmargin)
                                        (+ vpos (/ adjust -2) (* delta n)))
                           :view-size
                           ,(make-point (or width (+ adjust  (- dialog-width col2 10)))
                                        (+ height adjust))  ; editable-text of 16 is really 20                              
                           :view-nick-name ',nickname
                           ,@(if (eq type 'editable-text-dialog-item) '(:draw-outline -2))
                           ,@keys))))
          (setq n (1+ n)))))
    `(progn
       ,(if lastvar `(setq ,lastvar ,(+ vpos (* delta n))))
       (list ,@result))))

; End of dialog-macros.lisp
