	
/* 01/29/97 gb  GCC wants a __main function.  Don't ask. */
/* 03/26/96 gb  float->unsigned runtime support for MWC */
/* 03/10/96 gb  set_fpscr; use macros for prolog, epilog */
/* 03/04/96 gb  find_interrupt_context */
/* 12/27/95 gb  count_leading_zeros */
/* 12/13/95 gb  zero_cache_lines fencepost, mwc glue */

	include(m4macros.m4)

	_beginfile
/* Zero R4 cache lines, starting at address in R3.  Each line is assumed to be 
   R5 bytes wide. */
_exportfn(zero_cache_lines)
	cmpwi cr0,r4,0
	mtctr r4
	beqlr
1:	dcbz 0,r3
	add r3,r3,r5
	bdnz 1b
	blr
_endfn(zero_cache_lines)

/* Flush R4 cache lines, starting at address in R3.  Each line is
   assumed to be R5 bytes wide. */
_exportfn(flush_cache_lines)
	cmpwi cr0,r4,0
	mtctr r4
	beqlr
1:	dcbf 0,r3
	sync
	icbi 0,r3
	isync
	add r3,r3,r5
	bdnz 1b
	blr
_endfn(flush_cache_lines)

_exportfn(current_stack_pointer)
	mr r3,sp
	blr
	b exp
_endfn(current_stack_pointer)
	

_exportfn(count_leading_zeros)
	cntlzw r3,r3
	blr
_endfn(count_leading_zeros)


_exportfn(set_fpscr)
	stwu sp,-16(sp)
	stw r3,12(sp)
	lfd f0,8(sp)
	mtfsf 0xff,f0
	la sp,16(sp)
	blr
_endfn(set_fpscr)

_exportfn(save_fp_context)
	subi r4,r3,8
	stfdu f0,8(r4)
	stfdu f1,8(r4)
	stfdu f2,8(r4)
	stfdu f3,8(r4)
	stfdu f4,8(r4)
	stfdu f5,8(r4)
	stfdu f6,8(r4)
	stfdu f7,8(r4)
	stfdu f8,8(r4)
	stfdu f9,8(r4)
	stfdu f10,8(r4)
	stfdu f11,8(r4)
	stfdu f12,8(r4)
	stfdu f13,8(r4)
	stfdu f14,8(r4)
	stfdu f15,8(r4)
	stfdu f16,8(r4)
	stfdu f17,8(r4)
	stfdu f18,8(r4)
	stfdu f19,8(r4)
	stfdu f20,8(r4)
	stfdu f21,8(r4)
	stfdu f22,8(r4)
	stfdu f23,8(r4)
	stfdu f24,8(r4)
	stfdu f25,8(r4)
	stfdu f26,8(r4)
	stfdu f27,8(r4)
	stfdu f28,8(r4)
	stfdu f29,8(r4)
	stfdu f30,8(r4)
	stfdu f31,8(r4)
	mffs f0
	stfd f0,8(r4)
	lfd f0,0(r3)
	blr
_endfn(save_fp_context)

_exportfn(restore_fp_context)
	mr r4,r3
	lfdu f1,8(r4)
	lfdu f2,8(r4)
	lfdu f3,8(r4)
	lfdu f4,8(r4)
	lfdu f5,8(r4)
	lfdu f6,8(r4)
	lfdu f7,8(r4)
	lfdu f8,8(r4)
	lfdu f9,8(r4)
	lfdu f10,8(r4)
	lfdu f11,8(r4)
	lfdu f12,8(r4)
	lfdu f13,8(r4)
	lfdu f14,8(r4)
	lfdu f15,8(r4)
	lfdu f16,8(r4)
	lfdu f17,8(r4)
	lfdu f18,8(r4)
	lfdu f19,8(r4)
	lfdu f20,8(r4)
	lfdu f21,8(r4)
	lfdu f22,8(r4)
	lfdu f23,8(r4)
	lfdu f24,8(r4)
	lfdu f25,8(r4)
	lfdu f26,8(r4)
	lfdu f27,8(r4)
	lfdu f28,8(r4)
	lfdu f29,8(r4)
	lfdu f30,8(r4)
	lfdu f31,8(r4)
	lfd f0,8(r4)
	mtfsf 0xff,f0
	lfd f0,0(r3)
	blr
_endfn(restore_fp_context)

_exportfn(getHID0)
	mfspr r3,1008		/* get HID0 */
	blr
_endfn(getHID0)

_exportfn(setHID0)
	mtspr 1008,r3
	blr
_endfn(setHID0)
	_endfile
