	include(m4macros.m4)

/* Frame needs room for backlink, lr, 18 GPRs, FPSCR, + 18 FPRs */

QT_FRAMESIZE = (8 + ((32-14)*4) + 8 + ((32-14)*8))
/*
	In general, a frame looks like:
+---------+
| backptr |	back link to previous frame
+---------+
| save lr |	slot for CALLEE to save lr in
+---------+
| save r14|	user function param 'pu'
+---------+
| save r15|	user function param 'pt'
+---------+
| save r16|	user function 'userf'
+---------+
| save r17|	'only'
+---------+
    ...
+---------+
| save r31|
+---------+
| fpscr   |	64 bits
|	  |
+---------+
| save f14|
|	  |
+---------+
   ...
+---------+
| save f31|
|	  |
+---------+

		When 'qt_start' runs, there should be a backlink
		and save_lr slot underneath the top frame.
*/

	_beginfile
_exportfn(qt_block)
	stwu sp,-QT_FRAMESIZE(sp)
	mflr r0
	stw r0,QT_FRAMESIZE+4(sp)
	stmw r14,8(sp)
	la r14,8+(18*4)-8(sp)
	mffs f0
	stfdu f0,8(r14)
	stfdu f14,8(r14)
	stfdu f15,8(r14)
	stfdu f16,8(r14)
	stfdu f17,8(r14)
	stfdu f18,8(r14)
	stfdu f19,8(r14)
	stfdu f20,8(r14)
	stfdu f21,8(r14)
	stfdu f22,8(r14)
	stfdu f23,8(r14)
	stfdu f24,8(r14)
	stfdu f25,8(r14)
	stfdu f26,8(r14)
	stfdu f27,8(r14)
	stfdu f28,8(r14)
	stfdu f29,8(r14)
	stfdu f30,8(r14)
	stfdu f31,8(r14)
	mtctr r3
	mr r3,sp
	mr sp,r6
	bctrl
	la r14,8+(18*4)-8(sp)
	lfdu f0,8(r14)
	mtfsf 0xff,f0
	lfdu f14,8(r14)
	lfdu f15,8(r14)
	lfdu f16,8(r14)
	lfdu f17,8(r14)
	lfdu f18,8(r14)
	lfdu f19,8(r14)
	lfdu f20,8(r14)
	lfdu f21,8(r14)
	lfdu f22,8(r14)
	lfdu f23,8(r14)
	lfdu f24,8(r14)
	lfdu f25,8(r14)
	lfdu f26,8(r14)
	lfdu f27,8(r14)
	lfdu f28,8(r14)
	lfdu f29,8(r14)
	lfdu f30,8(r14)
	lfdu f31,8(r14)
	lmw r14,8(sp)
	lwz sp,0(sp)
	lwz r0,4(sp)
	mtlr r0
	blr
_endfn(qt_block)

_exportfn(qt_start)
	mtctr r17		/* Ready to call 'only' */
	mr r3,r14		/* Load up user function pu. */
	mr r4,r15		/* ... user function pt */
	mr r5,r16		/* ... user function userf */
	bctrl			/* Call only(pu,pt,userf) */
	b qt_error		/* should never get here */
_endfn(qt_start)

	_endfile

	