

/*	Change History (most recent first): 
    5 12/22/95 gb   progvsave makes an emptier empty frame 
    3 11/21/95 gb   .SPbind_nil expects symbol in arg_z, not temp0 
    (do not edit before this line!!) 
   Binding, unbinding, special variables in general. */

/* 09/06/96 gb bind/unbind don't memoize after after all. 
   -- 4.0b1 
   06/20/96 bill progvsave initializes initptr from new, not old TSP frame 
   06/20/96 gb memoize the setfs after all. 
   --- 3.9 
  <end of added text> 
   12/27/95 gb  progvrestore called from cleanup, needs to skip a frame. 
   12/22/95 bill  progvsave's emptier empty frame is big enough. 
   12/13/95 gb progvsave, progvrestore 
   11/13/95 gb all binding subprims set db_link to vsp on exit. */

	include(lisp.s)
	_beginfile
	.globl ksignalerr

/* Set the special variable in arg_y to the value in arg_z. 
   Error if arg_y is a constant. 
   arg_y is a known, non-nil symbol. */
_spentry(setqsym)
	lwz imm0,symbol.flags(arg_y)
	andi. imm0,imm0,(1<<sym_vbit_const)
	bne- cr0,1f
	la loc_g,symbol.vcell(arg_y)
	push loc_g,memo
	stw arg_z,0(loc_g)
	blr
1:
	mr arg_z,arg_y
	lwi arg_y,XCONST
	set_nargs 2
	b ksignalerr
	
/* Bind special symbol in arg_y to value in arg_z. */
_spentry(bind)
	lwz temp1,symbol.vcell(arg_y)
	ref_global imm1,db_link
	vpush temp1
	vpush arg_y
	vpush imm1
	set_global vsp,db_link
	stw arg_z,symbol.vcell(arg_y)
	blr

/* Bind special symbol in arg_z to its current value. */
_spentry(bind_self_boundp_check)
	lwz temp1,symbol.vcell(arg_z)
	tweqi temp1,unbound_marker
	b bind_self_aux
	
_spentry(bind_self)
	lwz temp1,symbol.vcell(arg_z)
bind_self_aux:	
	ref_global imm1,db_link
	vpush temp1
	vpush arg_z
	vpush imm1
	set_global vsp,db_link
	blr

/* Bind special symbol in arg_z to  NIL.	 */
_spentry(bind_nil)
	lwz temp1,symbol.vcell(arg_z)
	ref_global imm1,db_link
	vpush temp1
	vpush arg_z
	vpush imm1
	set_global vsp,db_link
	stw rnil,symbol.vcell(arg_z)
	blr

/* Undo one special binding. */
_spentry(unbind)
	ref_global imm1,db_link
	lwz temp0,4(imm1)
	lwz temp1,8(imm1)
	lwz imm1,0(imm1)
	set_global imm1,db_link
	stw temp1,symbol.vcell(temp0)
	blr

/* Undo N special bindings: imm0 = n, unboxed and >0. */
_spentry(unbind_n)
.unbind_n:
	ref_global imm1,db_link
1:
	subi imm0,imm0,1
	cmpwi cr0,imm0,0
	lwz temp0,4(imm1)
	lwz temp1,8(imm1)
	lwz imm1,0(imm1)
	stw temp1,symbol.vcell(temp0)
	bne cr0,1b
	set_global imm1,db_link
	blr

/* Unwind special bindings until the head of the linked list = imm0. 
   Clobbers arg_x, arg_y, imm2, imm1. */
_spentry(unbind_to)
	ref_global imm1,db_link
1:
	lwz imm2,0(imm1)
	lwz arg_x,4(imm1)
	cmpw cr0,imm0,imm2
	lwz arg_y,8(imm1)
	mr imm1,imm2
	stw arg_y,symbol.vcell(arg_x)
	bne cr0,1b
	set_global imm1,db_link
	blr

/* save the values of a list of special variables (arg_y); set them 
   to the corresponding values in the list in arg_z. 
   We've checked to make sure that arg_y is a proper list of bindable 
   symbols, but we're not sure what's in arg_z. 
   Save the special binding triplets on the tstack.  If there's not 
   enough room, die.  Prepend the triplets with a boxed triplet 
   count. */
_spentry(progvsave)
        /* First, determine the length of arg_y.  We */
        /* know that it's a proper list. */
        li imm0,-4
        mr temp0,arg_y
1:
	cmpw cr0,temp0,rnil
	la imm0,4(imm0)
	cdr temp0,temp0
	bne 1b
	/* imm0 is now (boxed) triplet count. */
	/* Determine word count, add 1 (to align), and make room. */
	/* if count is 0, make an empty tsp frame and exit */
	cmpwi cr0,imm0,0
	add imm1,imm0,imm0
	add imm1,imm1,imm0
	la imm1,4+7(imm1)
	clrrwi imm1,imm1,3
	bne+ cr0,2f
	 stwu tsp,-16(tsp)
	 stw rzero,4(tsp)
	 stw rzero,8(tsp)
	 stw rzero,12(tsp)
	 blr
2:
	neg imm1,imm1
	la imm1,-8(imm1)	/* tsp header */
	mr initptr,tsp          /* uninterruptable */
	stwux tsp,tsp,imm1
	stw rzero,4(tsp)
	sub initptr,tsp,imm1	/* in case we just overflowed the stack segment */
	stw imm0,8(tsp)
	stw rzero,12(tsp)
	mr temp0,arg_y
	ref_global imm1,db_link
	/*  Save all bindings, then do the setqs. */
3:	
	car temp1,temp0
	cdr temp0,temp0
	cmpw cr0,temp0,rnil
	lwz temp2,symbol.vcell(temp1)
	push temp2,initptr
	push temp1,initptr
	push imm1,initptr
	mr imm1,initptr
	bne cr0,3b
	set_global imm1,db_link
	/* Now do assignments.  The TSP frame is gc-safe, */
	/* so it's safe to error if arg_z isn't a proper list. */
	mr initptr,freeptr
	mr temp0,arg_z

4:
	trap_unless_lisptag_equal temp0,tag_list,imm0
	car temp1,arg_y
	cdr arg_y,arg_y
	cmpw cr1,arg_y,rnil
	car temp2,temp0
	cdr temp0,temp0
	stw temp2,symbol.vcell(temp1)
	bne cr1,4b
	blr

/*
   Restore the special bindings from the top of the tstack, 
   leaving the tstack frame allocated. 
   Note that there might be 0 saved bindings, in which case 
   do nothing. 
   Note also that this is -only- called from an unwind-protect 
   cleanup form, and that .SPnthrowXXX is keeping one or more 
   values in a frame on top of the tstack. 
*/
	
_spentry(progvrestore)
	lwz imm0,0(tsp)		/* ignore .SPnthrowXXX values frame */
	lwz imm0,8(imm0)
	cmpwi cr0,imm0,0
	unbox_fixnum imm0,imm0
	bne+ cr0,.unbind_n
	blr	
	
	
	_endfile
