	
/* sp_builtin.s - builtin functions support */

/* 02/01/97 gb  more of EQL inline */
/* --- 4.0 */
/* 09/07/96 gb  more of LENGTH inline */
/* --- 4.0b1 */
/* 06/10/96 gb  new file. */

	include(lisp.s)
	_beginfile

	.macro jump_builtin builtin,argcount
	ref_nrs_value fname,builtin_functions
	set_nargs \argcount
	vref32 fname,fname,\builtin
	jump_fname
	.endm
	
_spentry(builtin_plus)
	extract_2_lisptags_ imm0,arg_y,arg_z
	bne- cr0,1f
	mcrxr cr0
	addo. arg_z,arg_y,arg_z
	bnslr+
	uuo_fixnum_overflow arg_z,arg_z
	blr
1:
	jump_builtin _builtin_plus,2

_spentry(builtin_minus)
	extract_2_lisptags_ imm0,arg_y,arg_z
	bne- cr0,1f
	mcrxr cr0
	subo. arg_z,arg_y,arg_z
	bnslr+
	uuo_fixnum_overflow arg_z,arg_z
	blr
1:
	jump_builtin _builtin_minus,2

_spentry(builtin_times)
	jump_builtin _builtin_times,2

_spentry(builtin_div)
	jump_builtin _builtin_div,2

_spentry(builtin_eq)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	bnelr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_eq,2

_spentry(builtin_ne)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	beqlr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_ne,2
	
_spentry(builtin_gt)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	bnglr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_gt,2
	
_spentry(builtin_ge)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	bltlr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_ge,2
	
_spentry(builtin_lt)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	bnllr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_lt,2
	
_spentry(builtin_le)
	extract_2_lisptags_ imm0,arg_y,arg_z
	cmpw cr1,arg_y,arg_z
	bne- cr0,1f
	mr arg_z,rnil
	bgtlr cr1
	la arg_z,t_offset(rnil)
	blr
1:	
	jump_builtin _builtin_le,2
	
	
_spentry(builtin_eql)
	cmpw cr0,arg_y,arg_z
	extract_lisptag imm0,arg_y
	extract_lisptag imm1,arg_z
	cmpw cr1,imm0,imm1
	beq cr0,1f
	cmpwi cr0,imm0,tag_misc
	bne cr1,2f
	bne cr0,2f
	jump_builtin _builtin_eql,2
1:	la arg_z,t_offset(rnil)
	blr
2:	mr arg_z,rnil
	blr

_spentry(builtin_length)
	cmpw cr1,arg_z,rnil
	extract_typecode imm0,arg_z
	cmpwi cr0,imm0,min_vector_subtag
	beq cr1,1f
	beq- cr0,2f
	blt- cr0,3f
	/* (simple-array * (*)) */
	vector_length arg_z,arg_z,imm0
	blr
2:
	lwz arg_z,vectorH.logsize(arg_z)
	blr
1:
	li arg_z,0
	blr
3:	
	jump_builtin _builtin_length,1

_spentry(builtin_seqtype)
	extract_typecode imm0,arg_z
	cmpwi cr0,imm0,tag_list
	cmpwi cr1,imm1,min_vector_subtag
	beq cr0,1f
	blt- cr1,2f
	mr arg_z,rnil
	blr
1:	la arg_z,t_offset(rnil)
	blr
2:
	jump_builtin _builtin_seqtype,1

_spentry(builtin_assq)
	jump_builtin _builtin_assq,2

_spentry(builtin_memq)
	jump_builtin _builtin_memq,2

_spentry(builtin_logbitp)
	/* Call out unless both fixnums,0 <=  arg_y < 30 */
	cmplwi cr1,arg_y,30<<fixnum_shift
	extract_2_lisptags_ imm0,arg_y,arg_z
	unbox_fixnum imm0,arg_y
	subfic imm0,imm0,30
	rlwnm imm0,arg_z,imm0,31,31
	rlwimi imm0,imm0,4,27,27
	bnl cr1,1f
	bne cr0,1f
	add arg_z,rnil,imm0
	blr
1:
	jump_builtin _builtin_logbitp,2
	
_spentry(builtin_logior)
	extract_2_lisptags_ imm0,arg_y,arg_z
	bne- cr0,1f
	or arg_z,arg_y,arg_z
	blr
1:
	jump_builtin _builtin_logior,2
	
_spentry(builtin_logand)
	extract_2_lisptags_ imm0,arg_y,arg_z
	bne- cr0,1f
	and arg_z,arg_y,arg_z
	blr
1:
	jump_builtin _builtin_logand,2

_spentry(builtin_ash)
	jump_builtin _builtin_ash,2

_spentry(builtin_negate)
	extract_lisptag_ imm0,arg_z
	bne- cr0,1f
	mcrxr cr0
	nego. arg_z,arg_z
	bnslr+
	uuo_fixnum_overflow arg_z,arg_z
	blr
1:
	jump_builtin _builtin_negate,1

_spentry(builtin_logxor)
	extract_2_lisptags_ imm0,arg_y,arg_z
	bne- cr0,1f
	xor arg_z,arg_y,arg_z
	blr
1:
	jump_builtin _builtin_logxor,2
	
_spentry(builtin_aref1)
	.globl _SPsubtag_misc_ref
	extract_typecode imm0,arg_y
	cmpwi cr0,imm0,min_vector_subtag
	box_fixnum arg_x,imm0
	bgt cr0,1f
	jump_builtin _builtin_aref1,2
1:	b _SPsubtag_misc_ref

_spentry(builtin_aset1)
	.globl _SPsubtag_misc_set
	extract_typecode imm0,arg_x
	cmpwi cr0,imm0,min_vector_subtag
	box_fixnum temp0,imm0
	bgt cr0,1f
	jump_builtin _builtin_aset1,3
1:	b _SPsubtag_misc_set

	_endfile
