	
/* Heap-consing subprims, except for those associated with &rest args. */

/* 06/19/96 bill  misc_alloc_init restores VSP in case there was a stack overflow */
/* -------------  MCL-PPC 3.9 */
/* 01/22/96 gb fix (unsigned-byte 24) check in misc_alloc. */
/* 11/29/95 gb misc_alloc_init */
/* 10/28/95 gb fencepost in init_list_from_stack_loop. */

	include(lisp.s)
	_beginfile
	
_spentry(conslist)
	mr arg_z,rnil
/* do list*: last arg in arg_z, all others vpushed, nargs set to #args vpushed. */
_spentry(conslist_star)
	.globl init_list_from_stack
	cmpwi nargs,0
	add imm0,nargs,nargs
	stwux rzero,freeptr,imm0
	la initptr,-8+fulltag_cons(freeptr)
	b init_list_from_stack
init_list_from_stack_loop:
	lwz temp0,0(vsp)
	cmpwi nargs,fixnum_one
	la vsp,4(vsp)
	stw arg_z,cons.cdr(initptr)
	subi nargs,nargs,fixnum_one
	stw temp0,cons.car(initptr)
	mr arg_z,initptr
	subi initptr,initptr,8
init_list_from_stack:
	bne init_list_from_stack_loop
	mr initptr,freeptr
	blr
	

_spentry(newblocktag)
	ref_global imm0,block_tag_counter
	addi imm0,imm0,1<<num_subtag_bits
	cmpwi imm0,0
	ori arg_z,imm0,subtag_block_tag
	beq- 1f
	set_global imm0,block_tag_counter
	blr
1:
cons_nil_nil:	
	stwu rzero,cons.size(freeptr)
	la arg_z,fulltag_cons(initptr)
	stw rnil,cons.car(arg_z)
	stw rnil,cons.cdr(arg_z)
	mr initptr,freeptr
	blr

_spentry(newgotag)
	ref_global imm0,go_tag_counter
	addi imm0,imm0,1<<num_subtag_bits
	cmpwi imm0,0
	ori arg_z,imm0,subtag_go_tag
	beq- cons_nil_nil
	set_global imm0,go_tag_counter
	blr

/* Allocate a "fulltag_misc" object.  On entry, arg_y contains the element */
/* count (boxed) and  arg_z contains the subtag (boxed).  Both of these  */
/* parameters must be "reasonable" (the  subtag must be valid, the element */
/* count must be of type (unsigned-byte 24).  */
/* On exit, arg_z contains the (properly tagged) misc object; it'll have a */
/* proper header on it and its contents will be 0.  initptr and freeptr will  */
/* both have advanced to the following doubleword boundary.  imm0 contains  */
/* the object's header (fulltag = fulltag_immheader or fulltag_nodeheader.) */
/* This is intended for things like "make-array" and "%make-bignum" and the  */
/* like.  Things that involve creating small objects of known size can usually */
/* do so inline with less hair. */

/* If this has to go out-of-line (to GC or whatever), it should do so via a  */
/* trap (or should otherwise ensure that both the LR and CTR are preserved  */
/* where the GC can find them.) */


_spentry(misc_alloc)
	extract_unsigned_byte_bits_ imm2,arg_y,24
	unbox_fixnum imm0,arg_z
	extract_fulltag imm1,imm0
	bne- cr0,9f
	cmpwi cr0,imm1,fulltag_nodeheader
	mr imm3,imm0
	cmplwi cr1,imm0,max_32_bit_ivector_subtag
	rlwimi imm0,arg_y,num_subtag_bits-fixnum_shift,0,31-num_subtag_bits	/* imm0 now = header */
	mr imm2,arg_y
	beq cr0,1f	/* do probe if node object (fixnum element count = byte count). */
	cmplwi cr0,imm3,max_16_bit_ivector_subtag
	bng cr1,1f	/* do probe if 32-bit imm object */
	cmplwi cr1,imm3,max_8_bit_ivector_subtag
	srwi imm2,imm2,1
	bgt cr0,2f
	bgt cr1,1f
	srwi imm2,imm2,1
/* imm2 now = byte count.  Add 4 for header, 7 to align, then clear low three bits. */
1:
	addi imm2,imm2,4+7
	clrrwi imm2,imm2,3
/* The freepointer needs to advance by imm2 bytes, if possible.  Advancing it may write to a protected */
/* group of 8 4K pages, and doing so may trigger a GC.  That's all transparent to us. */
/* What's not transparent is that we can only do this if we're allocating 32K bytes or less; otherwise, */
/* we'll have to think a bit harder. */
	cmplwi imm2,0x8000
	bgt 3f
	stwux rzero,freeptr,imm2
	stw imm0,0(initptr)
	la arg_z,fulltag_misc(initptr)
	mr initptr,freeptr
	blr
2:
	cmplwi imm3,subtag_double_float_vector
	slwi imm2,arg_y,1
	beq 1b
	addi imm2,arg_y,7<<fixnumshift
	srwi imm2,imm2,fixnumshift+3
	b 1b
/* We're trying to allocate 32K bytes or more.  First, we should see if that's sensible; then, if so, we */
/* should see if we need to "manually" invoke a full gc, then we should touch each page group between  */
/* here and there and we're done. */
3:
	uuo_xalloc arg_z,arg_y,arg_z
	blr
9: uuo_interr error_object_not_unsigned_byte_24,arg_y
	
/* Like misc_alloc (a LOT like it, since it does most of the work), but takes */
/* an initial-value arg in arg_z, element_count in arg_x, subtag in arg_y. */
/* Calls out to %init-misc, which does the rest of the work. */

_spentry(misc_alloc_init)
	mflr loc_pc
	create_lisp_frame
	stw fn,lisp_frame.savefn(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	li fn,0
	mr temp0,arg_z		/* initval */
	mr arg_z,arg_y		/* subtag */
	mr arg_y,arg_x		/* element-count */
	bl misc_alloc
	lwz loc_pc,lisp_frame.savelr(sp)
	mtlr loc_pc
	lwz fn,lisp_frame.savefn(sp)
	lwz vsp,lisp_frame.savevsp(sp) /* vsp may have moved to the bottom of a new stack segment */
	discard_lisp_frame
	la fname,nrs.init_misc(rnil)
	set_nargs 2
	mr arg_y,temp0
	jump_fname

	_endfile

	