

/*	Change History (most recent first): 
    8 2/19/96  akh  fix from gb for destructuring bind 
    6 1/28/96  akh  spread_lexprz uses temp3 because: 
                     %apply-lexpr uses temp0 for fn to apply 
                     %apply-lexpr-with-method-context needs temp1 (next-method-context) and temp2 (nfn) 
    3 12/22/95 gb   lotsa destucturing/&key fixes; keyword arg error signalling. 
    (do not edit before this line!!) 
   Lambda-list processing, destructuring-bind. */

/* 10/21/96 bill  stack_cons_rest_arg heap conses if the list is too long to stack cons. 
   -------------  4.0 
   06/20/96 bill  Comments in spread_argz & spread_lexprz to preserve temp1 
                  keyword_bind handles stack overflow in @push_pairs_loop 
   06/14/96 bill  stack_cons_rest_arg computes initptr after instead of before pushing new tsp frame 
   -------------  MCL-PPC 3.9 
   03/19/96 bill  @req_loop: cmpwi -> cmpw 
                  This makes destructuring-bind and macro-bind notice when too 
                  few required args are passed. 
   02/01/96  gb   spread_lexprz: lotso hair 
   01/10/96  gb   spread_lexprz was totally wrong 
   12/28/95  gb   lots more destucturing/&key fixes 
   10/28/95  gb   fencepost in stack_cons_rest_arg. */

	include(lisp.s)
	_beginfile

	.globl ksignalerr
/* Provide default (NIL) values for &optional arguments; imm0 is 
   the (fixnum) upper limit on the total of required and &optional 
   arguments.  nargs is preserved, all arguments wind up on the 
   vstack. */
_spentry(default_optional_args)
	cmplw cr7,nargs,imm0
	vpush_argregs
	mr imm1,nargs
	bgelr cr7
1:	addi imm1,imm1,fixnum_one
	cmpw cr0,imm1,imm0
	vpush rnil
	bne cr0,1b
	blr

/* Indicate whether &optional arguments were actually supplied.  nargs 
   contains the actual arg count (minus the number of required args); 
   imm0 contains the number of &optional args in the lambda list. 
   Note that nargs may be > imm0 if &rest/&key is involved. */
_spentry(opt_supplied_p)
	li imm1,0
1:
	/* (vpush (< imm1 nargs)) */
	xor imm2,imm1,nargs
	srawi imm2,imm2,31
	or imm2,imm2,imm1
	addi imm1,imm1,fixnumone
	cmpw cr0,imm1,imm0
	subf imm2,nargs,imm2
	srwi imm2,imm2,31
	insrwi imm2,imm2,1,27
	add imm2,rnil,imm2
	vpush imm2
	bne cr0,1b
	blr



/* If nargs is <= imm0, vpush a nil.  Otherwise, cons a list of length 
   (- nargs imm0) and vpush it. 
   Use this entry point to heap-cons a simple &rest arg. */
_spentry(heap_rest_arg)
	li imm0,0

/* And this entry point when the argument registers haven't yet been 
   vpushed (as is typically the case when required/&rest but no &optional/&key.) */
_spentry(req_heap_rest_arg)
	vpush_argregs

_spentry(heap_cons_rest_arg)
	sub imm1,nargs,imm0
	cmpwi cr0,imm1,0
	mr arg_z,rnil
	ble cr0,2f
	add imm1,imm1,imm1
	stwux rzero,freeptr,imm1
	la arg_y,-cons.size+fulltag_cons(freeptr)
	mr initptr,freeptr
1:	subi imm1,imm1,8
	cmpwi cr0,imm1,0
	vpop arg_x
	rplacd arg_y,arg_z
	rplaca arg_y,arg_x
	mr arg_z,arg_y
	la arg_y,-cons.size(arg_y)
	bne cr0,1b
2:	vpush arg_z
	blr

/* As in the heap-consed cases, only stack-cons the &rest arg */
_spentry(stack_rest_arg)
	li imm0,0

_spentry(req_stack_rest_arg)
	vpush_argregs

_spentry(stack_cons_rest_arg)
	sub imm1,nargs,imm0
	cmpwi cr0,imm1,0
	cmpwi cr1,imm1,(4096-8)/2
	mr arg_z,rnil
	ble cr0,2f		/* always temp-push something. */
        bge cr1,3f
	add imm1,imm1,imm1
	neg imm2,imm1
	subi imm2,imm2,8
	mr initptr,tsp		/* uninterruptable */
	stwux tsp,tsp,imm2
	sub initptr,tsp,imm2
	la arg_y,-cons.size+fulltag_cons(initptr)
0:	cmpwi cr0,imm1,8	/* last time through ? */
	subi imm1,imm1,8
	vpop arg_x
	rplacd arg_y,arg_z
	rplaca arg_y,arg_x
	mr arg_z,arg_y
	la arg_y,-cons.size(arg_y)
	bne cr0,0b
	stw rzero,4(tsp)
	mr initptr,freeptr
	vpush arg_z
	blr
2:	stwu tsp,-8(tsp)
	stw rzero,4(tsp)
	vpush arg_z
	blr
3:
	stwu tsp,-8(tsp)
	stw rzero,4(tsp)
	b heap_cons_rest_arg

/* Treat the last (- nargs imm0) values on the vstack as keyword/value 
   pairs.  There'll be imm3 keyword arguments.  Imm2 contains flags 
   that indicate whether &allow-other-keys was specified and whether 
   or not to leave the keyword/value pairs on the vstack for an &rest 
   argument.  Temp3 contains a vector of keyword specifiers which we 
   must (in general) match. 
   If the number of arguments is greater than imm0, the difference must 
   be even. 
   Note that the caller hasn't yet saved its caller's context and that 
   the temp registers used to pass closure_data (temp0) and next_method_context 
   (temp1) may still have "live" values in them, as does nfn (temp2). */

keyword_flags = imm2
keyword_vector = temp3
keyword_count = imm3

_spentry(simple_keywords)
	li imm0,0

_spentry(keyword_args)
	vpush_argregs

varptr = save0
valptr = save1
limit = save2

_spentry(keyword_bind)
	/* Before we can really do anything, we have to */
	/* save the caller's context.  To do so, we need to know */
	/* how many args have actually been pushed.  Ordinarily, that'd */
	/* be "nargs", but we may have pushed more args than we received */
	/* if we had to default any &optionals. */
	/* So, the number of args pushed so far is the larger of nargs */
	/* and the (canonical) total of required/&optional args received. */
	cmpw cr0,nargs,imm0
	add arg_z,vsp,nargs
	bge+ cr0,1f
	add arg_z,vsp,imm0
1:
	create_lisp_frame
	stw loc_pc,lisp_frame.savelr(sp)
	stw arg_z,lisp_frame.savevsp(sp)
	stw fn,lisp_frame.savefn(sp)
	mr fn,nfn
	/* If there are key/value pairs to consider, we slide them down */
	/* the vstack to make room for the value/supplied-p pairs. */
	/* The first step in that operation involves pushing imm3 pairs */
	/* of NILs. */
	/* If there aren't any such pairs, the first step is the last */
	/* step. */
	cmpwi cr0,imm3,0
	li arg_z,0
	sub imm1,nargs,imm0
	mr imm4,vsp                            /* in case odd keywords error */
	cmpwi cr1,imm1,0
	b 3f
2:
	addi arg_z,arg_z,fixnum_one
	cmplw cr0,arg_z,imm3
	vpush rnil
	vpush rnil
3:
	bne cr0,2b
	andi. arg_z,imm1,fixnum_one
	blelr cr1		/* no keyword/value pairs to consider. */
	bne cr0,odd_keywords
	/* We have key/value pairs.  Move them to the top of the vstack, */
	/* then set the value/supplied-p vars to NIL. */
	/* Have to use some save regs to do this. */
	vpush limit
	vpush valptr
	vpush varptr
	/* recompute ptr to user args in case stack overflowed */
	add imm4,vsp,imm3
	add imm4,imm4,imm3
	addi imm4,imm4,12
	/* error if odd number of keyword/value args */
	mr varptr,imm4
	la limit,12(vsp)
	mr valptr,limit
	mr arg_z,imm1
4:
	subi arg_z,arg_z,2<<fixnumshift
	cmplwi cr0,arg_z,0
	lwz arg_x,0(varptr)
	lwz arg_y,4(varptr)
	stw rnil,0(varptr)
	stw rnil,4(varptr)
	la varptr,8(varptr)
	stw arg_x,0(valptr)
	stw arg_y,4(valptr)
	la valptr,8(valptr)
	bne cr0,4b


/* Now, iterate through each supplied keyword/value pair.  If 
   it's :allow-other-keys and the corresponding value is non-nil, 
   note that other keys will be allowed. 
   Find its position in the function's keywords vector.  If that's 
   nil, note that an unknown keyword was encountered. 
   Otherwise, if the keyword arg hasn't already had a value supplied, 
   supply it. 
   When done, complain if any unknown keywords were found and that 
   situation was unexpected. */
	mr imm4,valptr
5:
	lwzu arg_z,-4(valptr)
	lwzu arg_y,-4(valptr)
	cmpw cr1,arg_y,rnil
	la arg_x,nrs.kallowotherkeys(rnil)
	cmpw cr0,arg_x,arg_z
	cmpw cr7,valptr,limit
	beq cr1,6f
	bne cr0,6f
	ori keyword_flags,keyword_flags,fixnum_one
6:
	cmpwi cr1,imm3,0
	li imm1,misc_data_offset
	li imm0,0
	b 8f
7:
	addi imm0,imm0,fixnum_one
	cmpw cr1,imm0,imm3
	lwzx arg_x,keyword_vector,imm1
	cmpw cr0,arg_x,arg_z
	addi imm1,imm1,fixnum_one
	bne cr0,8f
	add imm0,imm0,imm0
	sub imm0,varptr,imm0
	lwz arg_x,0(imm0)
	cmpw cr0,arg_x,rnil
	la arg_z,t_offset(rnil)
	bne cr0,9f
	stw arg_y,4(imm0)
	stw arg_z,0(imm0)
	b 9f
8:
	bne cr1,7b
	/* Unknown keyword. */
	ori keyword_flags,keyword_flags,2<<fixnumshift
9:
	bne cr7,5b
	vpop varptr
	vpop valptr
	vpop limit
	/* All keyword/value pairs have been processed. */
	/* If we saw an unknown keyword and didn't expect to, error. */
	/* Unless bit 2 is set in the fixnum in keyword_flags, discard the */
	/* keyword/value pairs from the vstack. */
	andi. imm0,keyword_flags,(fixnum_one)|(2<<fixnumshift)
	cmpwi cr0,imm0,2<<fixnumshift
	beq- cr0,badkeys
	andi. imm2,keyword_flags,4<<fixnumshift
	bnelr cr0
	mr vsp,imm4
	blr

/* Signal an error.  We saved context on entry, so this thing doesn't 
   have to. 
   The "unknown keywords" error could be continuable (ignore them.) 
   It might be hard to then cons an &rest arg. 
   In the general case, it's hard to recover the set of args that were 
   actually supplied to us ... */
	/* For now, just cons a list out of the keyword/value pairs */
	/* that were actually provided, and signal an "invalid keywords" */
	/* error with that list as an operand. */
odd_keywords:
	mr vsp,imm4
	mr nargs,imm1
	b 1f
badkeys:
	sub nargs,imm4,vsp
1:
	.globl _SPconslist
	bl _SPconslist
	li arg_y,XBADKEYS
	set_nargs 2
	b ksignalerr



/* Destructuring-bind, macro-bind. 
   */
whole_reg = temp1
arg_reg = temp3
keyvect_reg = temp2
mask_req_start = 24
mask_req_width = 8
mask_opt_start = 16
mask_opt_width = 8
mask_key_start = 8
mask_key_width = 8
mask_initopt = 7
mask_keyp = 6		/*  note that keyp can be true even when 0 keys. */
mask_aok = 5
mask_restp = 4
/* OK to use arg_x, arg_y for whatever (tagged) purpose; 
   likewise immX regs. 
   arg_z preserved, nothing else in particular defined on exit. 
   nargs contains req count (0-255) in PPC bits mask_req_start/mask_req_width, 
                  opt count (0-255) in PPC bits mask_opt_start/mask_opt_width, 
                  key count (0-255) in PPC bits mask_key_start/mask_key_width, 
                  opt-supplied-p flag in PPC bit mask_initopt, 
                  keyp flag in PPC bit mask_keyp, 
                  &allow-other-keys flag in PPC bit mask_aok, 
   		   &rest flag in PPC bit mask_restp. 
   When mask_keyp bit is set, keyvect contains vector of keyword symbols, 
	length key count. */

_spentry(macro_bind)
	mr whole_reg,arg_reg
	extract_lisptag imm0,arg_reg
	cmpwi cr0,imm0,tag_list
	bne- cr0,1f
	cdr arg_reg,arg_reg
	b destbind1
1:
	li arg_y,XCALLNOMATCH
	mr arg_z,whole_reg
	set_nargs 2
	b ksignalerr
	
_spentry(destructuring_bind_inner)
	mr whole_reg,arg_z
	b destbind1

_spentry(destructuring_bind)
	mr whole_reg,arg_reg
	/* b destbind1 */
	
destbind1:
	/* Extract required arg count. */
	.ifeq (mask_req_width+mask_req_start)-32
	 /* A bug in gas: can't handle shift count of "32" (= 0 */
	 clrlwi. imm0,nargs,mask_req_start
	.else
	 extrwi. imm0,nargs,mask_req_width,mask_req_start
	.endif
	extrwi  imm1,nargs,mask_opt_width,mask_opt_start
	rlwinm  imm2,nargs,0,mask_initopt,mask_initopt
	rlwinm  imm4,nargs,0,mask_keyp,mask_keyp
	cmpwi cr4,imm4,0
	rlwinm imm4,nargs,0,mask_restp,mask_restp
	cmpwi cr5,imm4,0
	cmpwi cr1,imm1,0
	cmpwi cr2,imm2,0
	/* Save entry vsp in case of error. */
	mr imm4,vsp
	beq cr0,2f
1:
	cmpw cr7,arg_reg,rnil
	extract_lisptag imm3,arg_reg
	cmpwi cr3,imm3,tag_list
	subi imm0,imm0,1
	cmpwi cr0,imm0,0
	beq cr7,toofew
	bne cr3,badlist
	lwz arg_x,cons.car(arg_reg)
	lwz arg_reg,cons.cdr(arg_reg)
	vpush arg_x
	bne cr0,1b
2:	
	beq cr1,rest_keys
	bne cr2,opt_supp
	/* 'simple' &optionals:	 no supplied-p, default to nil. */
simple_opt_loop:
	cmpw cr0,arg_reg,rnil
	extract_lisptag imm3,arg_reg
	cmpwi cr3,imm3,tag_list
	subi imm1,imm1,1
	cmpwi cr1,imm1,0
	beq cr0,default_simple_opt
	bne cr3,badlist
	lwz arg_x,cons.car(arg_reg)
	lwz arg_reg,cons.cdr(arg_reg)
	vpush arg_x
	bne cr1,simple_opt_loop
	b rest_keys
default_simple_opt_loop:
	subi imm1,imm1,1
	cmpwi cr1,imm1,0
default_simple_opt:
	vpush rnil
	bne cr1,default_simple_opt_loop
	b rest_keys
	/* Provide supplied-p vars for the &optionals. */
opt_supp:
	la arg_y,t_offset(rnil)
opt_supp_loop:
	cmpw cr0,arg_reg,rnil
	extract_lisptag imm3,arg_reg
	cmpwi cr3,imm3,tag_list
	subi imm1,imm1,1
	cmpwi cr1,imm1,0
	beq cr0,default_hard_opt
	bne cr3,badlist
	lwz arg_x,cons.car(arg_reg)
	lwz arg_reg,cons.cdr(arg_reg)
	vpush arg_x
	vpush arg_y
	bne cr1,opt_supp_loop
	b rest_keys
default_hard_opt_loop:
	subi imm1,imm1,1
	cmpwi cr1,imm1,0
default_hard_opt:
	vpush rnil
	vpush rnil
	bne cr1,default_hard_opt_loop
rest_keys:
	cmpw cr0,arg_reg,rnil
	bne cr5,have_rest
	bne cr4,have_keys
	bne cr0,toomany
	blr
have_rest:	
	vpush arg_reg
	beqlr cr4
have_keys:
	/* Ensure that arg_reg contains a proper,even-length list. */
	/* Insist that its length is <= 512 (as a cheap circularity check.) */
	li imm0,256
	mr arg_x,arg_reg
count_keys_loop:
	extract_lisptag imm3,arg_x
	cmpwi cr3,imm3,tag_list
	cmpw cr0,arg_x,rnil
	subi imm0,imm0,1
	cmpwi cr4,imm0,0
	bne cr3,badlist
	beq cr0,counted_keys
	lwz arg_x,cons.cdr(arg_x)
	extract_lisptag imm3,arg_x
	cmpwi cr3,imm3,tag_list
	blt cr4,toomany
	cmpw cr0,arg_x,rnil
	bne cr3,badlist
	beq cr0,db_badkeys
	lwz arg_x,cons.cdr(arg_x)
	b count_keys_loop	
counted_keys:
	/* 
	  We've got a proper, even-length list of key/value pairs in
	arg_reg. For each keyword var in the lambda-list, push a pair
	of NILs on the vstack. */
	extrwi. imm0,nargs,mask_key_width,mask_key_start 
	mr imm2,imm0 	/* save number of keys */ 
	b push_pair_test
push_pair_loop:
	cmpwi cr0,imm0,1
	subi imm0,imm0,1
	vpush rnil
	vpush rnil
push_pair_test:
	bne cr0,push_pair_loop
	slwi imm2,imm2,3		/* pairs -> bytes */
	add imm2,vsp,imm2		/* imm2 points below pairs */
	li imm0,0			/* count unknown keywords so far */
	extrwi imm1,nargs,1,mask_aok	/* unknown keywords allowed */
	extrwi nargs,nargs,mask_key_width,mask_key_start
	/* Now, for each keyword/value pair in the list */
	/*  a) if the keyword is found in the keyword vector, set the */
	/*     corresponding entry on the vstack to the value and the */
	/*     associated supplied-p var to T. */
	/*  b) Regardless of whether or not the keyword is found, */
	/*     if the keyword is :ALLOW-OTHER-KEYS and the value is non-nil, */
	/*     set imm1 to a non-zero value to indicate that unknown keywords */
	/*     are acceptable. */
	/*  c) If the keyword is not found (and isn't :ALLOW-OTHER-KEYS), increment */
	/*     the count of unknown keywords in imm0. */
	/* At the end of the list, signal an error if any unknown keywords were seen */
	/* but not allowed.  Otherwise, return. */

match_keys_loop:
	cmpw cr0,arg_reg,rnil
	li imm0,0
	li imm3,misc_data_offset
	beq cr0,matched_keys
	lwz arg_x,cons.car(arg_reg)
	la arg_y,nrs.kallowotherkeys(rnil)
	cmpw cr3,arg_x,arg_y	/* :ALLOW-OTHER-KEYS ? */
	lwz arg_reg,cons.cdr(arg_reg)
	lwz arg_y,cons.car(arg_reg)
	cmpw cr0,arg_y,rnil
	cmpw cr4,imm0,nargs
	lwz arg_reg,cons.cdr(arg_reg)
	bne cr3,match_test
	beq cr0,match_test
	ori imm1,imm1,1
	b match_test
match_loop:
	lwzx temp0,keyvect_reg,imm3
	cmpw cr0,arg_x,temp0
	addi imm0,imm0,1
	cmpw cr4,imm0,nargs
	addi imm3,imm3,4
	bne cr0,match_test
	/* Got a hit.  Unless this keyword's been seen already, set it. */
	slwi imm0,imm0,3
	subf imm0,imm0,imm2
	lwz temp0,0(imm0)
	cmpw cr0,temp0,rnil
	la temp0,t_offset(rnil)
	bne cr0,match_keys_loop	/* already saw this */
	stw arg_y,4(imm0)
	stw temp0,0(imm0)
	b match_keys_loop
match_test:
	bne cr4,match_loop
	oris imm1,imm1,0x8000
	b match_keys_loop
matched_keys:	
	cmpwi cr1,imm1,0
	add imm1,imm1,imm1
	cmpwi cr0,imm1,0
	bgelr cr1
	bnelr cr0
	/* Some unrecognized keywords.  Complain generically about */
	/* invalid keywords. */
db_badkeys:
	li arg_y,XBADKEYS
	b destructure_error
toomany:
	li arg_y,XCALLTOOMANY
	b destructure_error
toofew:
	li arg_y,XCALLTOOFEW
	b destructure_error
badlist:
	li arg_y,XCALLNOMATCH
	/* b destructure_error */
destructure_error:	
	mr vsp,imm4		/* undo everything done to the stack */
	mr arg_z,whole_reg
	set_nargs 2
	b ksignalerr

/* Everything up to the last arg has been vpushed, nargs is set to 
   the (boxed) count of things already pushed. 
   On exit, arg_x, arg_y, arg_z, and nargs are set as per a normal 
   function call (this may require vpopping a few things.) 
   ppc2-invoke-fn assumes that temp1 is preserved here. */
_spentry(spreadargz)
	extract_lisptag imm1,arg_z
	cmpwi cr1,imm1,tag_list
	cmpw cr0,arg_z,rnil
	li imm0,0
	mr arg_y,arg_z		/*  save in case of error */
	beq cr0,2f
1:	bne- cr1,3f
	car arg_x,arg_z
	cdr arg_z,arg_z
	cmpw cr0,arg_z,rnil
	extract_lisptag imm1,arg_z
	cmpwi cr1,imm1,tag_list
	vpush arg_x
	addi imm0,imm0,fixnum_one
	bne cr0,1b
2:	add. nargs,nargs,imm0
	cmpwi cr2,nargs,2<<fixnumshift
	beqlr- cr0
	vpop arg_z
	bltlr cr2
	vpop arg_y
	beqlr cr2
	vpop arg_x
	blr
/*  Discard whatever's been vpushed already, complain. */
3:	add vsp,vsp,imm0
	mr arg_z,arg_y		/* recover original arg_z */
	li arg_y,XNOSPREAD
	set_nargs 2
	b ksignalerr

/* "spread" the lexpr in arg_z. 
   ppc2-invoke-fn assumes that temp1 is preserved here. */
_spentry(spread_lexprz)
	lwz imm0,0(arg_z)
	cmpwi cr3,imm0,3<<fixnumshift
	cmpwi cr4,imm0,2<<fixnumshift
	add imm1,arg_z,imm0
	cmpwi cr0,imm0,0
	add nargs,nargs,imm0
	cmpwi cr1,nargs,0
	cmpwi cr2,nargs,2<<fixnumshift
	la imm1,4(imm1)
	bge cr3,9f
	beq cr4,2f
	bne cr0,1f
	/* lexpr count was 0; vpop the arg regs that */
	/* were vpushed by the caller */
	beqlr cr1
        vpop arg_z
        bltlr cr2
        vpop arg_y
        beqlr cr2
        vpop arg_x
        blr

	/* vpush args from the lexpr until we have only */
	/* three left, then assign them to arg_x, arg_y, */
	/* and arg_z. */
8:
	cmpwi cr3,imm0,4<<fixnumshift
	subi imm0,imm0,fixnumone
	lwzu arg_z,-4(imm1)
	vpush arg_z
9:
	bne cr3,8b
	lwz arg_x,-4(imm1)
	lwz arg_y,-8(imm1)
	lwz arg_z,-12(imm1)
	blr

	/* lexpr count is two: set arg_y, arg_z from the */
	/* lexpr, maybe vpop arg_x */
2:	lwz arg_y,-4(imm1)
	lwz arg_z,-8(imm1)
	beqlr cr2		/* return if (new) nargs = 2 */
	vpop arg_x
	blr

	/* lexpr count is one: set arg_z from the lexpr, */
	/* maybe vpop arg_y, arg_x */
1:	lwz arg_z,-4(imm1)
	bltlr cr2		/* return if (new) nargs < 2 */
	vpop arg_y
	beqlr cr2		/* return if (new) nargs = 2 */
	vpop arg_x
	blr

	_endfile

