
/*	Change History (most recent first): */
/*  3 11/19/95 gb   mvslide fix */
/*  (do not edit before this line!!) */
/* Multiple values, or maybe just one ... */

/* 10/22/96 bill return_values signals an XTOOMANYVALUES error if more values */
/*               than will fit in a TSP frame. */
/* ------------- 4.0 */
/* 06/15/96 bill save_values, add_values, recover_values updated to push */
/*               a new values segment for each call of add_values. */
/*               This makes it work even if a stack overflow allocates a new */
/*               TSP segment. */
/* 01/29/96  gb  export .nvalret */
/* 12/22/95 bill add_values now moves the tsp in the proper direction */
/*               by the proper amount. It also no longer overwrites */
/*               the last saved value if there are no new values. */
/* 11/17/95  gb mvslide fix */
/* 11/09/95  gb nthvalue fix */

	include(lisp.s)
	_beginfile
	.globl funcall

/* funcall temp0, returning multiple values if it does. */
_spentry(mvpass)
	mflr loc_pc
	mr imm0,vsp
	cmpwi cr0,nargs,4*nargregs
	create_lisp_frame
	stw loc_pc,lisp_frame.savelr(sp)
	stw fn,lisp_frame.savefn(sp)
	ref_global loc_pc,ret1val_addr
	ble+ cr0,1f
	 subi imm0,imm0,4*nargregs
	 add imm0,imm0,nargs
1:
	stw imm0,lisp_frame.savevsp(sp)
	li fn,0
	mtlr loc_pc
	b funcall
	


/* ret1valn returns "1 multiple value" when a called function does not */
/* return multiple values.  Its presence on the stack (as a return address) */
/* identifies the stack frame to code which returns multiple values. */

_exportfn(.ret1valn)
	lwz loc_pc,lisp_frame.savelr(sp)
	lwz vsp,lisp_frame.savevsp(sp)
	mtlr loc_pc
	lwz fn,lisp_frame.savefn(sp)
	discard_lisp_frame
	vpush arg_z
	set_nargs 1
	blr
_endfn(.ret1valn)

	/* Come here with saved context on top of stack. */
_spentry(nvalret)
	.globl .nvalret
.nvalret:
	lwz loc_pc,lisp_frame.savelr(sp)
	lwz temp0,lisp_frame.savevsp(sp)
	lwz fn,lisp_frame.savefn(sp)
	discard_lisp_frame
	b return_values

	/* Come here to return multiple values when */
	/* the caller's context isn't saved in a lisp_frame. */
	/* lr, fn valid; temp0 = entry vsp */

_spentry(values)
	mflr loc_pc
return_values:
	ref_global imm0,ret1val_addr
	mr arg_z,rnil
	/* max tsp frame is 4K. 8+8 is overhead for save_values_to_tsp below */
	/* and @do_unwind in nthrowvalues in "sp_catch.s". */
	cmpwi cr2,nargs,4096-(8+8)
	cmpw cr1,imm0,loc_pc
	cmpwi cr0,nargs,fixnum_one
	bge cr2,2f
	beq+ cr1,3f
	mtlr loc_pc
	add imm0,nargs,vsp
	blt- cr0,1f
	 lwz arg_z,-4(imm0)
1:	mr vsp,temp0
	blr

2:
	uuo_interr error_too_many_values,nargs
	b 2b

/* Return multiple values to real caller. */
3:	lwz loc_pc,lisp_frame.savelr(sp)
	add imm1,nargs,vsp
	mtlr loc_pc
	lwz imm0,lisp_frame.savevsp(sp)
	cmpw cr0,imm1,imm0		/* a fairly common case */
	lwz fn,lisp_frame.savefn(sp)
	cmpwi cr1,nargs,fixnum_one	/* sadly, a very common case */
	discard_lisp_frame
	beqlr cr0			/* already in the right place */
	bne cr1,4f
	 lwz arg_z,0(vsp)
	 mr vsp,imm0
	 vpush arg_z
	 blr
4:
	blt cr1,6f
	li imm2,fixnum_one
5:
	cmpw cr0,imm2,nargs
	addi imm2,imm2,fixnum_one
	lwzu arg_z,-4(imm1)
	push arg_z,imm0
	bne cr0,5b
6:	mr vsp,imm0
	blr

_spentry(fitvals)
	subf. imm0,nargs,imm0
	bge 2f
	sub vsp,vsp,imm0
	blr
1:	subic. imm0,imm0,4
	vpush rnil
	addi nargs,nargs,4
2:	bne 1b
	blr

_spentry(nthvalue)
	add imm0,vsp,nargs
	lwz imm1,0(imm0)
	cmplw imm1,nargs	/*  do unsigned compare:	 if (n < 0) => nil. */
	mr arg_z,rnil
	neg imm1,imm1
	subi imm1,imm1,4
	bge 1f
	lwzx arg_z,imm0,imm1
1:	la vsp,4(imm0)
	blr
	


/* "slide" nargs worth of values up the vstack.  IMM0 contains */
/* the difference between the current VSP and the target. */
_spentry(mvslide)
	cmpwi cr0,nargs,0
	mr imm3,nargs
	add imm2,vsp,nargs
	add imm2,imm2,imm0
	add imm0,vsp,nargs
	beq 2f
1:	cmpwi cr0,imm3,1<<fixnumshift
	subi imm3,imm3,1<<fixnumshift
	lwzu temp0,-4(imm0)
	stwu temp0,-4(imm2)
	bne cr0,1b
2:	mr vsp,imm2
	blr

/* Build a new TSP area to hold nargs worth of multiple-values. */
/* Pop the multiple values off of the vstack. */
/* The new TSP frame will look like this: */
/* */
/* +--------+-------+-------+---------+--------+--------+--------+======+----------+ */
/* | ptr to | zero  | nargs | ptr to  | valn-1 | valn-2 | val-0  | ???? | prev TSP | */
/* |  prev  |       |       |  prev   |        |        |        | fill |          | */
/* | TSP    |       |       | segment |        |        |        |      |          | */
/* +--------+-------+-------+---------+--------+--------+--------+------+----------+ */
/* */
/* e.g., the first multiple value goes in the last cell in the frame, the */
/* count of values goes in the first word, and the word after the value count */
/* is 0 if the number of values is even (for alignment). */
/* Subsequent calls to .SPadd_values preserve this alignment. */
/* .SPrecover_values is therefore pretty simple. */

_spentry(save_values)
	mr imm1,tsp

/* common exit: nargs = values in this set, imm1 = ptr to tsp before call to save_values */
save_values_to_tsp:
	li imm0,-(8+8)		/* space for backptr, zero, count, link */
	mr imm2,tsp
	sub imm0,imm0,nargs
	bitclr imm0,imm0,2	/* down to dword boundary */
	mr initptr,tsp		/* uninterruptable */
	stwux imm1,tsp,imm0     /* keep one tsp "frame" as far as rest of lisp is concerned */
	sub initptr,tsp,imm0	/* correct for stack overflow */
	stw rzero,-4(initptr)   /* just in case odd values */
	stw rzero,4(tsp)        /* lisp frame */
	stw nargs,8(tsp)
	stw imm2,12(tsp)        /* previous tsp */
	la initptr,16(tsp)
	add initptr,initptr,nargs
	add imm0,vsp,nargs
	cmpw cr0,imm0,vsp
	b 2f
1:	lwzu arg_z,-4(imm0)
	cmpw cr0,imm0,vsp
	stwu arg_z,-4(initptr)
2:	bne cr0,1b
	mr initptr,freeptr
	add vsp,vsp,nargs	/*  discard values */
	blr

/* Add the multiple values that are on top of the vstack to the set */
/* saved in the top tsp frame, popping them off of the vstack in the */
/* process.  It is an error (a bad one) if the TSP contains something */
/* other than a previously saved set of multiple-values. */
/* Since adding to the TSP may cause a new TSP segment to be allocated, */
/* each add_values call adds another linked element to the list of */
/* values. This makes recover_values harder. */

_spentry(add_values)
	cmpwi cr0,nargs,0
	lwz imm1,0(tsp)
	bne cr0,save_values_to_tsp
	blr

/* vpush the values in the value set atop the vsp, incrementing nargs. */
/* Discard the tsp frame; leave values atop the vsp. */

_spentry(recover_values)

/* First, walk the segments reversing the pointer to previous segment pointers */
/* Can tell the end because that previous segment pointer is the prev tsp pointer */
	lwz imm0,0(tsp)         /* previous tsp */
	mr imm1,tsp             /* current segment */
	mr imm2,tsp             /* last segment */
walkloop:
	lwz imm3,12(imm1)       /* next segment */
	cmpw cr0,imm0,imm3      /* last segment? */
	stw imm2,12(imm1)       /* reverse pointer */
	mr imm2,imm1            /* last segment <- current segment */
	mr imm1,imm3            /* current segment <- next segment */
	bne cr0,walkloop

/* the final segment ptr is now in imm2 */
/* walk backwards, pushing values on VSP and incrementing NARGS */
pushloop:
	lwz imm0,8(imm2)        /* nargs in segment */
	cmpwi cr0,imm0,0
	cmpw cr1,imm2,tsp
	la initptr,16(imm2)
	add initptr,initptr,imm0
	add nargs,nargs,imm0
	b 2f
1:	lwzu arg_z,-4(initptr)
	cmpwi cr0,imm0,fixnum_one
	subi imm0,imm0,fixnum_one
	vpush arg_z
2:	bne cr0,1b
	lwz imm2,12(imm2)       /* previous segment */
	bne cr1,pushloop
	mr initptr,freeptr
	unlink tsp
	blr

	_endfile

	