

/*	Change History (most recent first): */
/*  5 12/22/95 gb   getXlong does UUO, not dc.l */
/*  3 11/15/95 gb   toplevel-loop allows throwing to toplevel */
/*  (do not edit before this line!!) */

/* 05/18/97 gb   fix integer_sign again. */
/* --- 4.1 */
/* 02/14/97 gb   maintain NV FP regs. */
/* --- 4.0 */
/* 09/10/96 gb   fix integer_sign. */
/* 06/19/96 bill call_closure computes old top of VSP as index from new top instead of */
/*               remembering the old top. This makes it work if vpushing the extra nils */
/*               causes a stack segment overflow. */
/* 06/13/96 gb  maintain fp_zero in start_lisp */
/* --- 3.9 release --- */
/* 03/20/96 gb  start_lisp gets a reset_p arg, calls .SPreset when true. */
/* 03/07/96 bill getxlong handles extended strings */
/* 12/13/95 gb  toplevel-loop: return nil, init fn to 0. */
/* 11/15/95 gb  toplevel-loop different. */
/* 11/04/95 gb  getxlong uses symbolic header constants */

	include(lisp.s)
	_beginfile
	.globl jmpsym
	.globl _SPmkcatch1v
	.globl _SPfuncall
	.globl _SPnthrow1value

/* If arg_z is an integer, return in imm0 something whose sign */
/* is the same as arg_z's.  If not an integer, error. */
_spentry(integer_sign)
	extract_typecode imm0,arg_z
	cmpwi cr1,imm0,tag_fixnum
	cmpwi cr0,imm0,subtag_bignum
	mr imm0,arg_z
	beqlr+ cr1
	bne- cr0,1f
	getvheader imm0,arg_z
	header_length imm0,imm0	/* boxed length = scaled size */
	addi imm0,imm0,misc_data_offset-4  /* bias, less 1 element */
	lwzx imm0,arg_z,imm0
	cmpwi cr0,imm0,0
	li imm0,1
	bgelr cr0
	li imm0,-1
	blr
1:
	uuo_interr error_object_not_integer,arg_z
	

/* Prepend all but the first two (closure code, fn) and last two */
/* (function name, lfbits) elements of nfn to the "arglist". */
/* Doing things this way (the same way that 68K MCL does) lets */
/* functions which take "inherited arguments" work consistently */
/* even in cases where no closure object is created. */
_spentry(call_closure)
	cmpwi cr0,nargs,nargregs<<fixnumshift
	cmpwi cr1,nargs,fixnum_one
	vector_length imm0,nfn,imm0
	subi imm0,imm0,4<<fixnumshift		# imm0 = inherited arg count
	li imm1,misc_data_offset+(2<<fixnumshift)	# point to 1st arg
	ble+ cr0,.L_no_insert
	/* Some arguments have already been vpushed.  Vpush imm0's worth */
	/* of NILs, copy those arguments that have already been vpushed from */
	/* the old TOS to the new, then insert all of the inerited args */
	/* and go to the function. */
	li imm2,0
.L_push_nil_loop:
	addi imm2,imm2,fixnum_one
	cmpw cr2,imm2,imm0
	vpush rnil
	bne cr2,.L_push_nil_loop

	mr imm3,vsp
	add imm4,vsp,imm0
	subi imm2,nargs,nargregs<<fixnumshift
.L_copy_already_loop:	
	cmpwi cr2,imm2,fixnum_one
	subi imm2,imm2,fixnum_one
	lwz fname,0(imm4)
	addi imm4,imm4,fixnum_one
	stw fname,0(imm3)
	addi imm3,imm3,fixnum_one	
	bne cr2,.L_copy_already_loop

.L_insert_loop:
	cmpwi cr2,imm0,fixnum_one
	lwzx fname,nfn,imm1
	addi imm1,imm1,fixnum_one
	addi nargs,nargs,fixnum_one
	subi imm0,imm0,fixnum_one
	push fname,imm4
	bne cr2,.L_insert_loop
	b .L_go
.L_no_insert:	
	/* nargregs or fewer args were already vpushed. */
	/* if exactly nargregs, vpush remaining inherited vars. */
	add imm2,imm1,imm0
	bne cr0,.L_set_regs
.L_vpush_remaining:
	cmpwi cr2,imm0,fixnum_one
	lwzx fname,nfn,imm1
	addi imm1,imm1,fixnum_one
	vpush fname
	subi imm0,imm0,fixnum_one
	addi nargs,nargs,fixnum_one
	bne cr2,.L_vpush_remaining
	b .L_go
.L_set_regs:
	/* if nargs was > 1 (and we know that it was < 3), it must have */
	/* been 2.  Set arg_x, then vpush the remaining args. */
	ble cr1,.L_set_y_z
.L_set_arg_x:	
	subi imm0,imm0,fixnum_one
	cmpw cr0,imm0,0
	subi imm2,imm2,fixnum_one
	lwzx arg_x,nfn,imm2
	addi nargs,nargs,fixnum_one
	bne cr0,.L_vpush_remaining
	b .L_go
	/* Maybe set arg_y or arg_z, preceding args */
.L_set_y_z:
	bne cr1,.L_set_arg_z
	/* Set arg_y, maybe arg_x, preceding args */
.L_set_arg_y:
	subi imm0,imm0,fixnum_one
	cmpwi cr0,imm0,0
	subi imm2,imm2,fixnum_one
	lwzx arg_y,nfn,imm2
	addi nargs,nargs,fixnum_one
	bne cr0,.L_set_arg_x
	b .L_go
.L_set_arg_z:
	subi imm0,imm0,fixnum_one
	cmpwi cr0,imm0,0
	subi imm2,imm2,fixnum_one
	lwzx arg_z,nfn,imm2
	addi nargs,nargs,fixnum_one
	bne cr0,.L_set_arg_y

.L_go:	
	vref32 nfn,nfn,1
	lwz loc_pc,_function.codevector(nfn)
	mtctr loc_pc
	bctr


/* Go out of line to do this.  Sheesh. */

_spentry(vpopargregs)
	cmpwi cr0,nargs,0
	cmpwi cr1,nargs,2<<fixnumshift
	beqlr cr0
	beq cr1,.L_yz
	blt cr1,.L_z
	lwz arg_z,0(vsp)
	lwz arg_y,4(vsp)
	lwz arg_x,8(vsp)
	la vsp,12(vsp)
	blr
.L_yz:	lwz arg_z,0(vsp)
	lwz arg_y,4(vsp)
	la vsp,8(vsp)
	blr
.L_z:	lwz arg_z,0(vsp)
	la vsp,4(vsp)
	blr

		
/*This (for better or worse) treats anything that's either */
/* (signed-byte 32), (unsigned-byte 32), (simple-base-string 4), or  */
/* (satisfies (lambda (s) (and (symbolp s) (typep (symbol-name s) '(simple-base-string 4))) */
/* as if it denoted a 32-bit value. */
/* Argument in arg_z, result in imm0.  May use temp0. */
_spentry(getxlong)
	extract_lisptag imm0,arg_z
	cmpwi imm0,tag_fixnum
	cmpwi cr1,imm0,tag_misc
	unbox_fixnum imm0,arg_z
	beqlr
	mr temp0,arg_z
	bne- cr1,.L_error
	getvheader imm0,temp0
	cmpwi cr0,imm0,symbol_header
	cmpwi cr1,imm0,one_digit_bignum_header
	cmpwi cr7,imm0,two_digit_bignum_header
	bne- cr0,.L_not_sym
	lwz temp0,symbol.pname(arg_z)
	getvheader imm0,temp0	
.L_not_sym:
	cmpwi cr0,imm0,(4<<num_subtag_bits)|subtag_simple_base_string
	beq cr1,.L_big1
	beq cr0,.L_big1
	bne cr7,.L_extended

.L_big2:	vref32 imm0,temp0,1		/* sign digit must be 0 */
	cmpwi imm0,0
	bne .L_error
.L_big1:	vref32 imm0,temp0,0
	blr

.L_extended:
	/* Handle extended strings. Maybe later handle displaced strings */
	cmpwi cr0,imm0,(4<<num_subtag_bits)|subtag_simple_general_string
        bne cr0,.L_error

	vref16 imm0,temp0,3
	cmpwi cr0,imm0,256
	vref16 imm1,temp0,2
	cmpwi cr1,imm1,256
	rlwimi imm0,imm1,8,16,23
	vref16 imm1,temp0,1
	bge cr0,.L_error
	cmpwi cr0,imm1,256
	rlwimi imm0,imm1,16,8,15
	vref16 imm1,temp0,0
	bge cr1,.L_error
	cmpwi cr1,imm1,256
	rlwimi imm0,imm1,24,0,7
	bge cr0,.L_error
	bge cr1,.L_error
	blr

.L_error: uuo_interr error_object_not_integer,arg_z/* not quite right but what 68K MCL said */


	

/* subtype (boxed, of course) is vpushed, followed by nargs bytes worth of */
/* initial-contents.  Note that this can be used to cons any type of initialized */
/* node-header'ed misc object (symbols, closures, ...) as well as vector-like */
/* objects. */
/* Note that we're guaranteed to win (or force GC, or run out of memory) */
/* because nargs < 32K. */
_spentry(gvector)
	lwzx arg_z,vsp,nargs
	unbox_fixnum imm0,arg_z
	rlwimi imm0,nargs,num_subtag_bits-fixnum_shift,0,31-num_subtag_bits
	addi imm1,nargs,4+7
	clrrwi imm1,imm1,3
	stwux rzero,freeptr,imm1
	stw imm0,0(initptr)
	la arg_z,fulltag_misc(initptr)
	mr initptr,freeptr
	mr imm1,nargs
	addi imm2,imm1,misc_data_offset
	b 2f
1:	stwx temp0,arg_z,imm2
2:	subi imm1,imm1,4
	cmpwi cr0,imm1,0
	subi imm2,imm2,4
	vpop temp0         /* Note the intentional fencepost: 
	                    discard the subtype as well. */
	bge cr0,1b
	blr


_spentry(ksignalerr)
	.globl ksignalerr
	.globl jmpsym
	/* Signal an error synchronously, via %ERR-DISP. */
	/* If %ERR-DISP isn't fbound, it'd be nice to print a message */
	/* on the C runtime stderr. */
	la fname,nrs.errdisp(rnil)
	b jmpsym



/* This is called from a c-style context and calls a lisp function. */
/* This does the moral equivalent of */
/*   (loop 
       (catch %toplevel-catch% 
         (let* ((fn (symbol-value *toplevel-function*)))
           (if fn (funcall fn) (return nil))))))) 
*/

_startfn(.toplevel_loop)
	mflr imm0
	stw imm0,eabi_c_frame.savelr(sp)
	b .L_test
.L_loop:
	ref_nrs_value arg_z,toplcatch
	bl _SPmkcatch1v
	b .L_test			/* cleanup address, not really a branch */
	
	ref_nrs_value temp0,toplfunc
	cmpw cr0,temp0,rnil
	set_nargs 0
	beq cr0,.L_test
	bl _SPfuncall
	mr arg_z,rnil
	li imm0,fixnum_one
	bl _SPnthrow1value
.L_test:
	ref_nrs_value temp0,toplfunc
	cmpw cr0,temp0,rnil
	bne cr0,.L_loop
.L_back_to_c:
	lwz imm0,eabi_c_frame.savelr(sp)
	mtlr imm0
	blr

	


/* This sucker gets called with R3 pointing to lisp_nil. */
/* r4 is 0 if we want to start the whole thing rolling, */
/* non-zero if we want to reset the current process */
/* by throwing to toplevel */
/* Whatever -was- in rtoc isn't very interesting to us. */
	.globl _SPreset
_exportfn(.start_lisp)
	mflr r0
	mr r5,r2
	mr rnil,r3
	set_global r5,saveTOC
	stw r0,eabi_c_frame.savelr(sp)
	stwu sp,-(eabi_c_frame.minsiz+(32*4))(sp)
	stmw r13,eabi_c_frame.minsiz(sp)	/* don't worry about the stmw. */
	stfd fp_s32conv,eabi_c_frame.minsiz+(22*4)(sp)
	lwi r30,0x43300000
	lwi r31,0x80000000
	stw r30,eabi_c_frame.minsiz+(20*4)(sp)
	stw r31,eabi_c_frame.minsiz+(20*4)+4(sp)
	lfd fp_s32conv,eabi_c_frame.minsiz+(20*4)(sp)
	stfd fp_zero,eabi_c_frame.minsiz+(20*4)(sp)
	lfs fp_zero,lisp_globals.short_float_zero(rnil)
	li rzero,0
	mr save0,rnil
	mr save1,rnil
	mr save2,rnil
	mr save3,rnil
	mr save4,rnil
	mr save5,rnil
	mr save6,rnil
	mr save7,rnil
	mr arg_z,rnil
	mr arg_y,rnil
	mr arg_x,rnil
	mr temp0,rnil
	mr temp1,rnil
	mr temp2,rnil
	mr temp3,rnil
	li fn,0
	li loc_g,0
	li loc_pc,0
	cmpwi cr0,r4,0
	ref_global vsp,save_vsp
	ref_global tsp,save_tsp
	ref_global memo,save_memo
	ref_global freeptr,save_freeptr
	mr initptr,freeptr
	bne cr0,1f
	bl .toplevel_loop
	b 2f
1:	bl _SPreset
2:	
	set_global freeptr,save_freeptr
	set_global memo,save_memo
	set_global tsp,save_tsp
	set_global vsp,save_vsp
	lmw r13,eabi_c_frame.minsiz(sp)
	mr r3,rnil
	lfd fp_zero,eabi_c_frame.minsiz+(20*4)(sp)
	lfd fp_s32conv,eabi_c_frame.minsiz+(22*4)(sp)
	lwz r0,(eabi_c_frame.minsiz+(32*4)+eabi_c_frame.savelr)(sp)
	mtlr r0
	la sp,(eabi_c_frame.minsiz+(32*4))(sp)
	blr
	
	_endfile
